SystemOrganization addCategory: #'Seaside-Core'!
SystemOrganization addCategory: #'Seaside-Core-Backtracking'!
SystemOrganization addCategory: #'Seaside-Core-Cache'!
SystemOrganization addCategory: #'Seaside-Core-Callbacks'!
SystemOrganization addCategory: #'Seaside-Core-Configuration'!
SystemOrganization addCategory: #'Seaside-Core-Document'!
SystemOrganization addCategory: #'Seaside-Core-Document-Elements'!
SystemOrganization addCategory: #'Seaside-Core-Exceptions'!
SystemOrganization addCategory: #'Seaside-Core-Filter'!
SystemOrganization addCategory: #'Seaside-Core-HTTP'!
SystemOrganization addCategory: #'Seaside-Core-Libraries'!
SystemOrganization addCategory: #'Seaside-Core-Rendering'!
SystemOrganization addCategory: #'Seaside-Core-RequestHandling'!
SystemOrganization addCategory: #'Seaside-Core-Server'!
SystemOrganization addCategory: #'Seaside-Core-Utilities'!

!String methodsFor: '*seaside-core' stamp: 'lr 10/28/2007 14:42'!
asCapitalizedPhrase
	|read words currentWord capitalizedWord|
	(self noneSatisfy: [:ea | ea isLowercase] ) ifTrue: [^ self].
	words := WriteStream on: String new.
	read := ReadStream on: self.
	[read atEnd] whileFalse:
		[currentWord := WriteStream on: String new.
		currentWord nextPut: read next.
		[|x| x := read peek. x isNil or: [x isUppercase]] whileFalse:
			[currentWord nextPut: read next].
		capitalizedWord := currentWord contents capitalized.
			(#(Of In At A Or To By) includes: capitalizedWord)
				ifTrue: [capitalizedWord := capitalizedWord asLowercase].
		words nextPutAll: capitalizedWord.
		words nextPutAll: ' '].
	words skip: -1.
	^ words contents! !

!String methodsFor: '*seaside-core' stamp: 'lr 3/26/2007 20:22'!
encodeOn: aDocument
	aDocument htmlEncoder nextPutAll: self! !

!String methodsFor: '*seaside-core' stamp: 'lr 6/13/2006 16:06'!
renderOn: aRenderer
	aRenderer text: self! !

!String methodsFor: '*seaside-core' stamp: 'lr 10/18/2008 15:50'!
seasideMimeDocument
	^ WAMimeDocument on: self mimeType: WAMimeType textPlain! !

!String methodsFor: '*seaside-core' stamp: 'jf 9/22/2008 12:14'!
seasideMimeType
	^ WAMimeType fromString: self! !

!String methodsFor: '*seaside-core' stamp: 'jf 9/22/2008 12:29'!
seasideUrl
	^ WAUrl absolute: self! !

!Object methodsFor: '*seaside-core' stamp: 'jf 9/30/2009 01:10'!
encodeOn: aDocument 
	aDocument print: self greaseString! !

!Object methodsFor: '*seaside-core' stamp: 'avi 3/14/2005 15:19'!
labelForSelector: aSymbol
	^ aSymbol asCapitalizedPhrase! !

!Object methodsFor: '*seaside-core' stamp: 'jf 2/13/2009 17:18'!
renderOn: aRenderer
	"This method is called on all objects passed as an argument to the #render: method of a WARenderer subclass. Override this method to customize how objects render themselves. The default is the return value of #displayString.
	Subclasses of WAPainter (including Components) should override #renderContentOn: and #rendererClass instead."

	aRenderer text: self! !

GRError subclass: #WAError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Exceptions'!

WAError subclass: #WAAuthConfigurationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Exceptions'!

!WAAuthConfigurationError commentStamp: 'pmm 11/4/2008 20:45' prior: 0!
A WAAuthConfigurationError is signaled when no WAAuthConfigration was to an application that is behind a WAAuthMain.!

!WAAuthConfigurationError methodsFor: 'accessing' stamp: 'jf 2/20/2009 18:09'!
seasidePossibleCauses
	^#(
		'No WAAuthConfiguration has been added to the application.'
	)! !

WAError subclass: #WAConfigurationError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

WAConfigurationError subclass: #WAAttributeNotFound
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAAttributeNotFound class methodsFor: 'signaling' stamp: 'lr 1/11/2009 14:03'!
signalWithKey: aSymbol
	^ self new
		initializeWithKey: aSymbol;
		signal! !

!WAAttributeNotFound methodsFor: 'initialization' stamp: 'lr 1/11/2009 13:35'!
initializeWithKey: aSymbol
	key := aSymbol! !

!WAAttributeNotFound methodsFor: 'accessing' stamp: 'lr 1/11/2009 14:11'!
key
	^ key! !

!WAAttributeNotFound methodsFor: 'accessing' stamp: 'jf 2/20/2009 18:09'!
seasidePossibleCauses
	^ #(
		'you need to clear your configuration caches to see new attributes (try "WAAdmin clearConfigurationCaches" in a workspace)'
		'you have not included a necessary ancestor in a configuration'
	)! !

WAError subclass: #WAIllegalStateException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

WAError subclass: #WARequestContextNotFound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Exceptions'!

!WARequestContextNotFound commentStamp: 'jf 9/11/2008 19:42' prior: 0!
This exception is raised when trying to obtain the current request context when none is available.!

WAError subclass: #WAUnhandledNotificationError
	instanceVariableNames: 'notification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Exceptions'!

!WAUnhandledNotificationError commentStamp: 'jf 10/18/2008 10:19' prior: 0!
Seaside has several Notifications that signal the desire to end the current attempt to process a request. These Notification must be handled as they are not resumable or continuable. If those Notifications are not handled, their default actions are to signal this error.!

!WAUnhandledNotificationError class methodsFor: 'signaling' stamp: 'lr 1/10/2009 16:52'!
signalWithNotification: aNotification
	^ self new
		notification: aNotification;
		signal! !

!WAUnhandledNotificationError methodsFor: 'accessing' stamp: 'jf 10/18/2008 10:20'!
notification
	^ notification! !

!WAUnhandledNotificationError methodsFor: 'accessing' stamp: 'jf 10/18/2008 10:20'!
notification: aNotification
	notification := aNotification! !

WAError subclass: #WAUnregisteredHandlerError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Exceptions'!

!WAUnregisteredHandlerError commentStamp: 'jf 10/27/2008 14:56' prior: 0!
This error is signaled by WARegistry whenever an attempt is made to find the key or URL for a handler that is not registered in its cache.!

!WAUnregisteredHandlerError methodsFor: 'accessing' stamp: 'jf 2/20/2009 18:09'!
seasidePossibleCauses
	^ #(
		'You are trying to use a session or other request handler that has expired'
	)! !

!UndefinedObject methodsFor: '*seaside-core' stamp: 'lr 3/27/2007 10:40'!
encodeOn: aDocument! !

!UndefinedObject methodsFor: '*seaside-core' stamp: 'lr 10/28/2007 14:42'!
renderOn: html! !

!GRPackage class methodsFor: '*seaside-core' stamp: 'jf 9/30/2009 01:16'!
seasideCore
	^ self new
		name: 'Seaside-Core';
		description: 'The core of Seaside, required for all packages.';
		addDependency: 'Grease-Core';
		yourself! !

!MessageNotUnderstood methodsFor: '*seaside-core' stamp: 'jf 2/20/2009 18:09'!
seasidePossibleCauses
	| causes |
	self receiver isNil ifFalse: [
		^ #('you sent a message this type of object doesn''t understand' )].
	causes := #(
		'the receiver of the message is nil'
		'a class extension hasn''t been loaded correctly'
		'you sent the wrong message' ) asOrderedCollection.
	self message selector = #contents ifTrue: [
		causes addFirst: 'you forgot to send "super initialize" in a initialize method of a component or task' ].
	^causes! !

!Collection methodsFor: '*seaside-core' stamp: 'jf 11/4/2008 12:41'!
renderOn: html
	self do: [ :each | html render: each ]! !

!GRInvalidUtf8Error methodsFor: '*seaside-core' stamp: 'jf 2/20/2009 18:09'!
seasidePossibleCauses
	^#(
		'The input is not UTF-8 but some other encoding like ISO-8859-1.'
	)! !

GRNotification subclass: #WANotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Exceptions'!

WANotification subclass: #WADynamicVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WADynamicVariable commentStamp: 'pmm 4/17/2007 00:14' prior: 0!
A WADynamicVariable is a variable that is visible only in the stackframes outgoing from this one.

Example:

WADynamicVariable
	use: 'Seaside'
	during: [ self compilcatedCalculation ]
	
Whenever
WADynamicVariable value
gets evaluated somewhere inside [ self compilcatedCalculation ] or a method invoked directly or indirectly by it, its value will be 'Seaside'. If no #use:during: handler is around the current stack frame, then the value will be the return value of #defaultValue.

Do not use WADynamicVariable directly, instead create a subclass for each variable you want to use.!

WADynamicVariable subclass: #WACurrentRequestContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandling'!

!WACurrentRequestContext commentStamp: 'pmm 6/1/2008 00:38' prior: 0!
A WACurrentRequestContext is a thread local variable that points to the current WARequestContext.
!

!WACurrentRequestContext class methodsFor: 'defaults' stamp: 'jf 2/3/2009 14:56'!
defaultValue
	^ WARequestContextNotFound signal! !

!WADynamicVariable class methodsFor: 'defaults' stamp: 'avi 3/29/2004 14:12'!
defaultValue
	^ nil! !

!WADynamicVariable class methodsFor: 'evaluating' stamp: 'lr 1/20/2009 23:06'!
use: anObject during: aBlock
	"Set the dynamic value of the receiver to anObject during the evaluation of aBlock."
	
	^ aBlock on: self do: [ :notification | notification resume: anObject ]! !

!WADynamicVariable class methodsFor: 'evaluating' stamp: 'lr 1/20/2009 23:06'!
value
	"Answer the dynamic value of the receiver."
	
	^ self signal! !

!WADynamicVariable methodsFor: 'defaults' stamp: 'lr 3/29/2008 19:01'!
defaultAction
	^ self class defaultValue! !

WANotification subclass: #WARenderNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Exceptions'!

!WARenderNotification methodsFor: 'public' stamp: 'lr 1/10/2009 16:48'!
defaultAction
	^ WAUnhandledNotificationError signalWithNotification: self! !

!WARenderNotification methodsFor: 'public' stamp: 'jf 10/18/2008 08:31'!
isResumable
	^ false! !

WANotification subclass: #WAResponseNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Exceptions'!

!WAResponseNotification commentStamp: 'lr 1/12/2009 08:25' prior: 0!
A WAReturnResponseRequest is singalled whenever the application server wants to return a response back to the client.!

!WAResponseNotification methodsFor: 'public' stamp: 'lr 1/10/2009 16:48'!
defaultAction
	^ WAUnhandledNotificationError signalWithNotification: self! !

!WAResponseNotification methodsFor: 'testing' stamp: 'jf 10/18/2008 08:28'!
isResumable
	^ false! !

!Dictionary methodsFor: '*seaside-core' stamp: 'lr 2/16/2007 15:11'!
valuesCollect: aBlock
	| result |
	result := self species new: self size.
	self keysAndValuesDo: [ :key :value |
		result at: key put: (aBlock value: value) ].
	^ result! !

GRSmallDictionary subclass: #WAHeaderFields
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAHeaderFields methodsFor: 'private' stamp: 'lr 1/12/2009 21:39'!
errorKeyNotFound
	^ nil! !

GRSmallDictionary subclass: #WAHtmlAttributes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlAttributes commentStamp: 'jf 1/23/2009 12:28' prior: 0!
I represent the attributes of a (X)(HT)ML tag. Compared to my superclass I ignore requests to add a nil-values. I also don't throw an exception when accessing a key that doesn't exist, but instead return nil.!

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
addClass: aString
	"Add an additional CSS class aString to the receiver."

	self at: 'class' append: aString separator: ' '! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'pmm 3/9/2008 11:21'!
addMedia: aString
	"Add an additional intended destination medium aString to the receiver."

	self at: 'media' append: aString separator: ', '! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'lr 10/28/2007 14:42'!
addStyle: aString
	"Add an additional CSS style definition aString to the receiver."

	self at: 'style' append: aString separator: ';'! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'lr 7/9/2007 07:46'!
at: aKey append: aValue
	"Append aValue to the attribute aKey. If already present, concatenate it with a space. Ignore the request if aValue is nil."

	^ self at: aKey append: aValue separator: ' '! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'jf 9/30/2009 01:10'!
at: aKey append: aValue separator: aString 
	"Append aValue to the attribute aKey. If already present, concatenate it with aString. Ignore the request if aValue is nil."
	aValue ifNil: [ ^ self at: aKey ].
	^ self 
		at: aKey
		put: (String streamContents: 
			[ :stream | 
			self 
				at: aKey
				ifPresent: 
					[ :value | 
					stream nextPutAll: value greaseString.
					stream nextPutAll: aString ].
			stream nextPutAll: aValue greaseString ])! !

!WAHtmlAttributes methodsFor: 'encoding' stamp: 'lr 10/28/2007 14:42'!
encodeOn: aDocument
	"Encode the receivers attribute onto aDocument. Note that this implementation reqires those two checks for true and false exactly the way they are here, to reliable encode boolean attributes in an XHTML compliant way."

	self keysAndValuesDo: [ :key :value |
		value == false ifFalse: [
			aDocument nextPut: $ ; nextPutAll: key; nextPutAll: '="'.
			value == true
				ifTrue: [ aDocument nextPutAll: key ]
				ifFalse: [ aDocument print: value ].
			aDocument nextPut: $" ] ]! !

!WAHtmlAttributes methodsFor: 'private' stamp: 'lr 7/12/2007 13:21'!
errorKeyNotFound
	^ nil! !

!WAHtmlAttributes methodsFor: 'private' stamp: 'lr 7/12/2007 13:23'!
privateAt: aKey put: aValue
	aValue ifNil: [ ^ nil ].
	^ super privateAt: aKey put: aValue! !

GRObject subclass: #WAObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core'!

!WAObject commentStamp: 'pmm 9/1/2008 13:27' prior: 0!
A WAObject is the base class for all portable Seaside classes. It guarantees that #initialize is send upon object creation. Additionally it provides convienience methods for accessing the current request context, session and application.!

WAObject subclass: #WAAttributeSearchContext
	instanceVariableNames: 'key attribute cachedValues attributeHolders attributeInheritors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAAttributeSearchContext commentStamp: 'jf 1/1/2009 21:39' prior: 0!
This class makes attribute searching more efficient by traversing the ancestry once and caching which Configurations hold the attribute. It is then passed through search functions which cache values for the attribute.!

!WAAttributeSearchContext class methodsFor: 'instance creation' stamp: 'jf 1/1/2009 18:05'!
key: keySymbol target: targetConfiguration
	^ self basicNew
		initializeWithKey: keySymbol;
		findAttributeAndSelectAncestorsOf: targetConfiguration;
		yourself! !

!WAAttributeSearchContext methodsFor: 'accessing' stamp: 'jf 1/1/2009 21:37'!
at: aConfiguration ifPresent: aBlock
	^ self cachedValues at: aConfiguration ifPresent: aBlock! !

!WAAttributeSearchContext methodsFor: 'accessing' stamp: 'jf 1/1/2009 21:37'!
at: aConfiguration put: cachedObject
	^ self cachedValues at: aConfiguration put: cachedObject! !

!WAAttributeSearchContext methodsFor: 'accessing' stamp: 'jf 8/4/2008 14:38'!
attribute
	^ attribute! !

!WAAttributeSearchContext methodsFor: 'private' stamp: 'jf 1/1/2009 21:37'!
cachedValues
	^ cachedValues! !

!WAAttributeSearchContext methodsFor: 'private' stamp: 'jf 1/1/2009 21:32'!
findAttributeAndSelectAncestorsOf: aConfiguration
	| found |
	(attributeHolders includes: aConfiguration) ifTrue: [ ^ true ].
			
	aConfiguration localAttributeAt: self key ifPresent:
		[ :attr |
		attribute := attr.
		attributeHolders add: aConfiguration.
		^ true ].
		
	found := false.
	aConfiguration parents do: [ :each | found := found | (self findAttributeAndSelectAncestorsOf: each) ].
	
	found ifTrue: [ attributeInheritors add: aConfiguration ].
	
	^ found! !

!WAAttributeSearchContext methodsFor: 'initialization' stamp: 'jf 3/13/2009 18:04'!
initializeWithKey: keySymbol
	self initialize.
	key := keySymbol.
	attributeHolders := Set new.
	attributeInheritors := Set new.
	cachedValues := Dictionary new! !

!WAAttributeSearchContext methodsFor: 'testing' stamp: 'jf 1/1/2009 18:01'!
isAttributeFoundOn: aConfiguration 
	^ (self isAttributeLocalOn: aConfiguration) or: [ self isAttributeInheritedOn: aConfiguration ]! !

!WAAttributeSearchContext methodsFor: 'testing' stamp: 'jf 1/1/2009 18:01'!
isAttributeInheritedOn: aConfiguration 
	^ attributeInheritors includes: aConfiguration! !

!WAAttributeSearchContext methodsFor: 'testing' stamp: 'jf 1/1/2009 18:00'!
isAttributeLocalOn: aConfiguration 
	^ attributeHolders includes: aConfiguration! !

!WAAttributeSearchContext methodsFor: 'accessing' stamp: 'jf 8/4/2008 18:29'!
key
	^ key! !

WAObject subclass: #WABuilder
	instanceVariableNames: 'fullDocument rootBlock rootClass documentClass rendererClass codec actionUrl resourceUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Rendering'!

!WABuilder commentStamp: 'jf 2/15/2009 21:41' prior: 0!
This is a convenience class which provides a result of a rendering operation as a string. It is expected to be used like this:

WARenderCanvas builder render: [ :html |
	html anchor
		url: 'htttp://www.seaside.st';
		with: 'Seaside Homepage' ]

See WABuilderCanvasTest for more examples.!

!WABuilder class methodsFor: 'instance creation' stamp: 'jf 10/19/2008 02:48'!
on: aRendererClass
	^self new
		rendererClass: aRendererClass;
		yourself! !

!WABuilder methodsFor: 'accessing' stamp: 'jf 2/15/2009 19:47'!
actionUrl
	^ actionUrl ifNil: [ actionUrl := WAUrl new ]! !

!WABuilder methodsFor: 'accessing' stamp: 'jf 2/15/2009 19:47'!
actionUrl: aUrl
	actionUrl := aUrl! !

!WABuilder methodsFor: 'private' stamp: 'jf 1/23/2009 13:02'!
closeDocument: aDocument
	self fullDocument ifTrue: [ aDocument close ]! !

!WABuilder methodsFor: 'accessing' stamp: 'jf 9/30/2009 00:27'!
codec
	^ codec ifNil: [ codec := GRNullCodec new ]! !

!WABuilder methodsFor: 'accessing' stamp: 'jf 1/23/2009 15:25'!
codec: aCodec
	codec := aCodec! !

!WABuilder methodsFor: 'accessing' stamp: 'jf 2/15/2009 19:45'!
documentClass
	^ documentClass ifNil: [ documentClass := WADocument ]! !

!WABuilder methodsFor: 'accessing' stamp: 'jf 2/15/2009 19:45'!
documentClass: aDocumentClass
	documentClass := aDocumentClass! !

!WABuilder methodsFor: 'accessing' stamp: 'pmm 8/12/2007 11:53'!
fullDocument
	^fullDocument! !

!WABuilder methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
fullDocument: aBoolean
	fullDocument := aBoolean! !

!WABuilder methodsFor: 'initialization' stamp: 'jf 8/30/2008 16:31'!
initialize
	super initialize.
	self fullDocument: false! !

!WABuilder methodsFor: 'private' stamp: 'jf 1/31/2009 02:34'!
openDocument: aDocument context: aContext 
	| documentRoot |
	self fullDocument ifFalse: [ ^ self ].
	documentRoot := self rootClass context: aContext.
	self rootBlock value: documentRoot.
	aDocument open: documentRoot! !

!WABuilder methodsFor: 'rendering' stamp: 'jf 2/21/2009 18:37'!
render: anObject
	"Render anObject and return the contents of the resulting Document as a String.
	anObject must understand #renderOn:. Commonly anObject will be a one-argument
	block, which will be evaluated with the appropriate renderer."
	
	^ String streamContents: [ :stream |
		| context document renderer |
		document := self documentClass on: stream codec: self codec.
		context := WARenderContext new.
		context document: document.
		context actionUrl: self actionUrl; resourceUrl: self resourceUrl.
		renderer := self rendererClass context: context.
		
		self openDocument: document context: context.
		renderer render: anObject; flush.
		self closeDocument: document ]! !

!WABuilder methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
renderResponse: anObject 
	"This implementation will only work when used within a Session or something that has WACurrentRequestContext defined."
	self 
		greaseDeprecatedApi: 'WABuilder>>#renderResponse:'
		details: 'Returning a response is no longer allowed. Use WABuilder>>#render: to obtain the contents, configure the response returned by WARequestContext>>#response, then respond using WARequestContext>>#respond.'.
	self fullDocument: true.
	self requestContext respond: 
		[ :response | 
		response
			contentType: WAMimeType textHtml;
			nextPutAll: (self render: anObject) ]! !

!WABuilder methodsFor: 'accessing' stamp: 'jf 10/19/2008 02:48'!
rendererClass
	^ rendererClass! !

!WABuilder methodsFor: 'accessing' stamp: 'jf 2/15/2009 19:44'!
rendererClass: aRendererClass 
	rendererClass := aRendererClass! !

!WABuilder methodsFor: 'accessing' stamp: 'jf 2/21/2009 18:37'!
resourceUrl
	^ resourceUrl! !

!WABuilder methodsFor: 'accessing' stamp: 'jf 2/21/2009 18:37'!
resourceUrl: aUrl
	resourceUrl := aUrl! !

!WABuilder methodsFor: 'accessing' stamp: 'jf 2/15/2009 19:44'!
rootBlock
	rootBlock isNil ifTrue: [
		rootBlock := [ :root | ] ].
	^rootBlock! !

!WABuilder methodsFor: 'accessing' stamp: 'pmm 8/12/2007 12:00'!
rootBlock: anObject
	rootBlock := anObject! !

!WABuilder methodsFor: 'accessing' stamp: 'jf 2/15/2009 19:42'!
rootClass
	rootClass isNil ifTrue: [ rootClass := WARoot ].
	^rootClass! !

!WABuilder methodsFor: 'accessing' stamp: 'jf 2/15/2009 19:42'!
rootClass: aRootClass
	rootClass := aRootClass! !

WAObject subclass: #WACache
	instanceVariableNames: 'mutex keysByObject objectsByKey expiryPolicy reapingStrategy missStrategy removalAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WACache commentStamp: 'jf 9/22/2008 17:41' prior: 0!
A WACache represents a collection of arbitrary objects referenced by a key (an instance of WAExternalID).

Methods are provided to add and retrieve and remove objects from the cache. The behaviour of the cache is configurable through four different plugins:

+ expiry policy: determines when objects are considered expired
+ cache miss strategy: determines what do to if a requested object is not found in the cache
+ cache reap action: determines what to do when an expired object is eventually reaped from the cache
+ cache reaping strategy: determines when expired objects should be reaped from the cache

Access to the two dictionaries which store the objects and keys is protected by a mutex. Calls to the plugins are currently not protected by the mutex, but possibly should be to simplify implementation of the plugins.!

!WACache methodsFor: 'public' stamp: 'jf 2/6/2009 19:34'!
at: aString
	^ self at: aString ifAbsent: [ nil ]! !

!WACache methodsFor: 'public' stamp: 'jf 2/6/2009 19:50'!
at: aString ifAbsent: absentBlock
	"Return the object stored at the key aString. If the key is not found in the
	cache, return the result of evaluating absentBlock.
	The block should not be evaluated within the mutex since it could take a long time."
	
	| object |
	mutex critical: [
		object := objectsByKey at: aString ifAbsent: [ self missStrategy missed: aString ].
		object isNil ifFalse: [
			(self expiryPolicy isExpired: object key: aString)
				ifTrue: [
					"Should we remove the object here?"
					object := nil ]
				ifFalse: [ self notifyRetrieved: object key: aString ] ] ].
	
	^ object ifNil: [ absentBlock value ]! !

!WACache methodsFor: 'public' stamp: 'jf 9/27/2009 21:46'!
clear
	"Remove all objects from the cache. The removal action will be triggered for each
	object that is removed."
	
	| objects |
	mutex critical: [
		objects := objectsByKey.
		self initializeCollections.
		objects isNil ifFalse: [
			objects keysAndValuesDo: [ :key :object | self notifyRemoved: object key: key ] ] ]! !

!WACache methodsFor: 'copying' stamp: 'jf 2/6/2009 20:16'!
copy
	"Some of our operations replace the collections sotred in our instance variables. We don't
	want a copy to be made in the middle of this process (or it might have an unmatched pair)
	so we need to copy within our mutex."
	^ mutex critical: [ super copy ]! !

!WACache methodsFor: 'copying' stamp: 'jf 9/27/2009 21:51'!
copyEmpty
	"Create a copy with no values."
	
	^ self species new
		setExpiryPolicy: self expiryPolicy copy;
		setMissStrategy: self missStrategy copy;
		setRemovalAction: self removalAction copy;
		setReapingStrategy: self reapingStrategy copy;
		yourself! !

!WACache methodsFor: 'private-accessing' stamp: 'jf 10/5/2008 22:40'!
expiryPolicy
	^ expiryPolicy! !

!WACache methodsFor: 'initialization' stamp: 'jf 9/27/2009 21:48'!
initialize
	super initialize.
	self initializeCollections.
	self initializeMutex.
	self setExpiryPolicy: WALastAccessExpiryPolicy new.
	self setReapingStrategy: WARetrievalIntervalReapingStrategy new.
	self setMissStrategy: WACacheMissStrategy new.
	self setRemovalAction: WANotifyRemovalAction new! !

!WACache methodsFor: 'initialization' stamp: 'jf 9/30/2009 00:19'!
initializeCollections
	objectsByKey := GRPlatform current reducedConflictDictionary new.
	keysByObject := GRPlatform current reducedConflictDictionary new! !

!WACache methodsFor: 'initialization' stamp: 'jf 2/5/2009 13:00'!
initializeMutex
	mutex := WAMutex new! !

!WACache methodsFor: 'testing' stamp: 'jf 2/6/2009 20:12'!
isEmpty
	^ self size = 0! !

!WACache methodsFor: 'public' stamp: 'jf 2/6/2009 19:23'!
keyAtValue: anObject
	^ self keyAtValue: anObject ifAbsent: [ nil ]! !

!WACache methodsFor: 'public' stamp: 'jf 2/6/2009 19:50'!
keyAtValue: anObject ifAbsent: absentBlock
	"Return the key at which anObject is stored. If anObject is not found in the
	cache, return the result of evaluating absentBlock.
	The block should not be evaluated within the mutex since it could take a long time."
	
	| key |
	key := mutex critical: [ keysByObject at: anObject ifAbsent: [ nil ] ].
	
	^ key ifNil: [ absentBlock value ]! !

!WACache methodsFor: 'configuration' stamp: 'jf 9/18/2008 15:34'!
keySize
	^ 16! !

!WACache methodsFor: 'enumerating' stamp: 'dkh 9/4/2009 06:37'!
keysAndValuesDo: aBlock

	objectsByKey keysAndValuesDo: aBlock! !

!WACache methodsFor: 'private-accessing' stamp: 'jf 10/5/2008 22:40'!
missStrategy
	^ missStrategy! !

!WACache methodsFor: 'private' stamp: 'jf 2/6/2009 16:58'!
notifyRemoved: anObject key: aString
	self pluginsDo: [ :each | each removed: anObject key: aString ]! !

!WACache methodsFor: 'private' stamp: 'jf 2/6/2009 16:39'!
notifyRetrieved: anObject key: aString
	self pluginsDo: [ :each | each retrieved: anObject key: aString ]! !

!WACache methodsFor: 'private' stamp: 'jf 2/6/2009 16:40'!
notifyStored: anObject key: aString
	self pluginsDo: [ :each | each stored: anObject key: aString ]! !

!WACache methodsFor: 'private' stamp: 'jf 2/6/2009 16:53'!
pluginsDo: aBlock
	aBlock value: self expiryPolicy.
	aBlock value: self reapingStrategy.
	aBlock value: self missStrategy.
	aBlock value: self removalAction.! !

!WACache methodsFor: 'copying' stamp: 'jf 2/6/2009 20:19'!
postCopy
	super postCopy.
	"At this point we are sharing the mutex with the original object. This means
	we can safely copy our dictionaries and our plugins."
	mutex critical: [
		keysByObject := keysByObject copy.
		objectsByKey := objectsByKey copy.
		
		self setExpiryPolicy: self expiryPolicy copy.
		self setMissStrategy: self missStrategy copy.
		self setRemovalAction: self removalAction copy.
		self setReapingStrategy: self reapingStrategy copy ].
	"Now we're done and have all our own data so we want our own mutex."
	self initializeMutex! !

!WACache methodsFor: 'public' stamp: 'jf 9/30/2009 00:19'!
reap
	"Iterate through the cache and remove objects that have expired."
	| newObjectsByKey newKeysByObject |
	newObjectsByKey := GRPlatform current reducedConflictDictionary new.
	newKeysByObject := GRPlatform current reducedConflictDictionary new.
	mutex critical: 
		[ objectsByKey keysAndValuesDo: 
			[ :key :object | 
			(self expiryPolicy 
				isExpired: object
				key: key) 
				ifTrue: 
					[ self 
						notifyRemoved: object
						key: key ]
				ifFalse: 
					[ newObjectsByKey 
						at: key
						put: object.
					newKeysByObject 
						at: object
						put: key ] ].
		objectsByKey := newObjectsByKey.
		keysByObject := newKeysByObject ]! !

!WACache methodsFor: 'private-accessing' stamp: 'jf 10/5/2008 22:40'!
reapingStrategy
	^ reapingStrategy! !

!WACache methodsFor: 'private-accessing' stamp: 'jf 2/6/2009 16:53'!
removalAction
	^ removalAction! !

!WACache methodsFor: 'public' stamp: 'jf 2/6/2009 19:09'!
remove: anObject
	^ self remove: anObject ifAbsent: [ nil ]! !

!WACache methodsFor: 'public' stamp: 'jf 2/6/2009 20:00'!
remove: anObject ifAbsent: absentBlock
	"Remove anObject from the cache, returning the removed object. If the object is not
	found in the cache,	return the result of evaluating absentBlock.
	The block should not be evaluated within the mutex since it could take a long time."
	
	| key |
	mutex critical: [
		key := keysByObject at: anObject ifAbsent: [ nil ].
		key isNil ifFalse: [
			keysByObject removeKey: anObject ifAbsent: [ nil ].
			objectsByKey removeKey: key ifAbsent: [ nil ].
			self notifyRemoved: anObject key: key ] ].
		
	^ key isNil ifTrue: [ absentBlock value ] ifFalse: [ anObject ]! !

!WACache methodsFor: 'public' stamp: 'jf 2/6/2009 19:14'!
removeKey: aString
	^ self removeKey: aString ifAbsent: [ nil ]! !

!WACache methodsFor: 'public' stamp: 'jf 2/6/2009 20:00'!
removeKey: aString ifAbsent: absentBlock
	"Remove the object stored at the key aString and return the removed object. If the key
	is not found in the cache, return the result of evaluating absentBlock.
	The block should not be evaluated within the mutex since it could take a long time."
	
	| object |
	mutex critical: [
		object := objectsByKey removeKey: aString ifAbsent: [ nil ].
		keysByObject removeKey: object ifAbsent: [ nil ].
		object isNil ifFalse: [ self notifyRemoved: object key: aString ] ].
	
	^ object ifNil: [ absentBlock value ]! !

!WACache methodsFor: 'initialization' stamp: 'jf 10/5/2008 22:49'!
setExpiryPolicy: anExpiryPolicy
	expiryPolicy := anExpiryPolicy setCache: self; yourself! !

!WACache methodsFor: 'initialization' stamp: 'jf 10/5/2008 22:50'!
setMissStrategy: aMissStrategy
	missStrategy := aMissStrategy setCache: self; yourself! !

!WACache methodsFor: 'initialization' stamp: 'jf 10/5/2008 22:50'!
setReapingStrategy: aReapingStrategy
	reapingStrategy := aReapingStrategy setCache: self; yourself! !

!WACache methodsFor: 'initialization' stamp: 'jf 2/6/2009 16:51'!
setRemovalAction: aRemovalAction
	removalAction := aRemovalAction setCache: self; yourself! !

!WACache methodsFor: 'public' stamp: 'jf 2/6/2009 20:00'!
size
	"Retun the number of objects currently in the cache. This number includes objects that
	are expired but have not yet been removed in a cache reap."

	^ mutex critical: [ objectsByKey size ].
! !

!WACache methodsFor: 'public' stamp: 'jf 2/6/2009 20:00'!
store: anObject
	"Store anObject in the cache, generating a new random key. Return the key."
	
	| key |
	mutex critical: [
		[ objectsByKey includesKey:
			(key := WAKeyGenerator current keyOfLength: self keySize) ] whileTrue.
		objectsByKey at: key put: anObject.
		keysByObject at: anObject put: key.
		self notifyStored: anObject key: key ].
	
	^ key! !

WAObject subclass: #WACachePlugin
	instanceVariableNames: 'cache configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

WACachePlugin subclass: #WACacheExpiryPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WACacheExpiryPolicy commentStamp: 'jf 9/22/2008 17:36' prior: 0!
A cache expiry policy determines when an item in the cache is considered expired. Expired items are periodically reaped an a schedule determined by the reaping strategy in place.

Subclasses should implement any of the notification methods that are interesting to them and should implement #isExpired:key: and return true or false as appropriate for any given object.!

!WACacheExpiryPolicy methodsFor: 'protocol' stamp: 'lr 1/10/2009 15:17'!
isExpired: anObject key: aString
	^ false! !

WACacheExpiryPolicy subclass: #WALastAccessExpiryPolicy
	instanceVariableNames: 'lastAccessTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WALastAccessExpiryPolicy methodsFor: 'configuration' stamp: 'jf 1/10/2009 15:12'!
defaultConfiguration
	^ super defaultConfiguration
		addParent: WACacheTimeoutConfiguration instance;
		yourself! !

!WALastAccessExpiryPolicy methodsFor: 'initialization' stamp: 'jf 9/30/2009 00:19'!
initialize
	super initialize.
	lastAccessTable := GRPlatform current reducedConflictDictionary new! !

!WALastAccessExpiryPolicy methodsFor: 'protocol' stamp: 'lr 1/10/2009 15:17'!
isExpired: anObject key: aString
	| lastAccess |
	lastAccess := lastAccessTable at: aString ifAbsent: [ Time totalSeconds ].
	^ (Time totalSeconds - lastAccess) > self timeout! !

!WALastAccessExpiryPolicy methodsFor: 'copying' stamp: 'lr 11/11/2008 22:58'!
postCopy
	super postCopy.
	lastAccessTable := lastAccessTable copy! !

!WALastAccessExpiryPolicy methodsFor: 'notifications' stamp: 'jf 2/6/2009 16:57'!
removed: anObject key: aString
	lastAccessTable removeKey: aString ifAbsent: []! !

!WALastAccessExpiryPolicy methodsFor: 'notifications' stamp: 'jf 2/6/2009 16:38'!
retrieved: anObject key: aString
	lastAccessTable at: aString put: Time totalSeconds! !

!WALastAccessExpiryPolicy methodsFor: 'notifications' stamp: 'jf 2/6/2009 16:39'!
stored: anObject key: aString
	lastAccessTable at: aString put: Time totalSeconds! !

!WALastAccessExpiryPolicy methodsFor: 'configuration' stamp: 'jf 1/10/2009 16:41'!
timeout
	^ self configuration at: #cacheTimeout! !

WACacheExpiryPolicy subclass: #WALeastRecentlyUsedExpiryPolicy
	instanceVariableNames: 'ageTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WALeastRecentlyUsedExpiryPolicy methodsFor: 'configuration' stamp: 'jf 1/10/2009 15:09'!
defaultConfiguration
	^ super defaultConfiguration
		addParent: WACacheCapacityConfiguration instance;
		yourself! !

!WALeastRecentlyUsedExpiryPolicy methodsFor: 'initialization' stamp: 'jf 9/30/2009 00:19'!
initialize
	super initialize.
	ageTable := GRPlatform current reducedConflictDictionary new! !

!WALeastRecentlyUsedExpiryPolicy methodsFor: 'protocol' stamp: 'jgf 1/28/2009 08:32'!
isExpired: anObject key: aString
	^ (ageTable at: aString) first > self maximumAge! !

!WALeastRecentlyUsedExpiryPolicy methodsFor: 'configuration' stamp: 'jf 1/10/2009 16:41'!
maximumAge
	^ self configuration at: #cacheCapacity! !

!WALeastRecentlyUsedExpiryPolicy methodsFor: 'copying' stamp: 'jgf 1/28/2009 08:59'!
postCopy
	super postCopy.
	ageTable := ageTable copy.
	ageTable keysAndValuesDo: [:eachKey :eachValue | 
		ageTable at: eachKey put: (Array with: eachValue first).
	]. ! !

!WALeastRecentlyUsedExpiryPolicy methodsFor: 'notifications' stamp: 'jf 2/6/2009 16:57'!
removed: anObject key: aString
	ageTable removeKey: aString ifAbsent: []! !

!WALeastRecentlyUsedExpiryPolicy methodsFor: 'notifications' stamp: 'jf 2/6/2009 16:38'!
retrieved: anObject key: aString
	(ageTable at: aString) at: 1 put: 0! !

!WALeastRecentlyUsedExpiryPolicy methodsFor: 'notifications' stamp: 'jf 2/6/2009 16:39'!
stored: anObject key: aString
	"Avoid #associationsDo: to maintain cross-platform portability (see Issue #312 for details)."
	
	ageTable do: [:each | each at: 1 put: (each at: 1) + 1].
	ageTable at: aString put: (Array with: 0).! !

WACachePlugin subclass: #WACacheMissStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WACacheMissStrategy commentStamp: 'jf 9/22/2008 16:45' prior: 0!
A cache miss strategy determines what should be done when an attempt is made to retrieve an object with a key that is not found in the cache.

Subclasses should implement #missed: and should either return nil or if the object can be found outside the cache somewhere, the object.!

!WACacheMissStrategy methodsFor: 'protocol' stamp: 'lr 1/10/2009 15:17'!
missed: aString
	^ nil! !

!WACachePlugin class methodsFor: 'instance creation' stamp: 'jf 10/5/2008 22:47'!
cache: aCache
	^ self new setCache: aCache; yourself! !

!WACachePlugin methodsFor: 'accessing' stamp: 'jf 1/10/2009 16:41'!
configuration
	^ configuration! !

!WACachePlugin methodsFor: 'configuration' stamp: 'jf 1/10/2009 14:36'!
defaultConfiguration
	^ WAUserConfiguration new! !

!WACachePlugin methodsFor: 'initialization' stamp: 'jf 1/10/2009 14:41'!
initialize
	super initialize.
	configuration := self defaultConfiguration! !

!WACachePlugin methodsFor: 'notifications' stamp: 'jf 2/6/2009 16:57'!
removed: anObject key: aString
	"Notification that an object has been removed from the cache."
! !

!WACachePlugin methodsFor: 'notifications' stamp: 'jf 2/6/2009 16:37'!
retrieved: anObject key: aString
	"Notification that an object has been retrieved from the cache."! !

!WACachePlugin methodsFor: 'initialization' stamp: 'jf 1/10/2009 14:41'!
setCache: aCache
	cache := aCache! !

!WACachePlugin methodsFor: 'notifications' stamp: 'jf 2/6/2009 16:39'!
stored: anObject key: aString
	"Notificatin that a new object is being stored in the cache."! !

WACachePlugin subclass: #WACacheReapingStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WACacheReapingStrategy commentStamp: 'jf 9/22/2008 16:43' prior: 0!
A cache reaping strategy determines when expired items should be removed from a cache.

Subclasses should implement any of the event notification methods they require and should call "self reap" whenever they determine that expired items should be removed from the cache.!

!WACacheReapingStrategy methodsFor: 'private' stamp: 'jf 9/18/2008 21:17'!
reap
	cache reap! !

WACacheReapingStrategy subclass: #WARetrievalIntervalReapingStrategy
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WARetrievalIntervalReapingStrategy methodsFor: 'configuration' stamp: 'jf 1/10/2009 14:59'!
defaultConfiguration
	^ super defaultConfiguration
		addParent: WARetrievalIntervalReapingStrategyConfiguration instance;
		yourself! !

!WARetrievalIntervalReapingStrategy methodsFor: 'initialization' stamp: 'jf 10/5/2008 22:48'!
initialize
	super initialize.
	count := 0! !

!WARetrievalIntervalReapingStrategy methodsFor: 'configuration' stamp: 'jf 1/10/2009 16:41'!
interval
	^ self configuration at: #cacheReapInterval! !

!WARetrievalIntervalReapingStrategy methodsFor: 'private' stamp: 'jf 9/18/2008 21:17'!
reap
	count := 0.
	super reap! !

!WARetrievalIntervalReapingStrategy methodsFor: 'notifications' stamp: 'jf 2/6/2009 16:38'!
retrieved: anObject key: anExternalId
	count := count + 1.
	(count >= self interval) ifTrue: [ self reap ]! !

WACachePlugin subclass: #WACacheRemovalAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WACacheRemovalAction commentStamp: 'jf 2/6/2009 16:33' prior: 0!
A cache reap action determines what, if anything, should happen when an object is reaped from the cache.

Subclasses should implement #reaped:key:. When this method is called, the object will already have been removed from the cache itself but the subclass should perform any any additional actions that need to be taken.!

WACacheRemovalAction subclass: #WANotifyRemovalAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WANotifyRemovalAction methodsFor: 'protocol' stamp: 'jf 2/6/2009 16:58'!
removed: anObject key: aString
	(anObject respondsTo: #unregistered) ifTrue: [ anObject unregistered ]
	! !

WAObject subclass: #WACallback
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

WACallback subclass: #WAActionCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WAActionCallback methodsFor: 'accessing' stamp: 'jf 7/14/2008 02:11'!
block: aZeroOrOneArgBlock
	block := aZeroOrOneArgBlock fixCallbackTemps! !

!WAActionCallback methodsFor: 'evaluation' stamp: 'pmm 1/10/2009 22:59'!
evaluateWithArgument: anObject
	block valueWithPossibleArguments: (Array with: anObject).
	self signalRenderNotification! !

!WAActionCallback methodsFor: 'testing' stamp: 'MAD 2/11/2009 21:41'!
isEnabledFor: aRequestContext
	^ aRequestContext request isXmlHttpRequest not! !

!WAActionCallback methodsFor: 'accessing' stamp: 'lr 12/28/2008 14:48'!
priority
	^ 5! !

!WAActionCallback methodsFor: 'evaluation' stamp: 'pmm 1/10/2009 13:45'!
signalRenderNotification
	WARenderNotification signal! !

WAActionCallback subclass: #WACancelActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WACancelActionCallback methodsFor: 'accessing' stamp: 'lr 12/28/2008 14:48'!
priority
	^ -5! !

WAActionCallback subclass: #WADefaultActionCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WADefaultActionCallback methodsFor: 'accessing' stamp: 'avi 6/7/2004 22:37'!
priority
	^ 10! !

WAActionCallback subclass: #WAImageCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WAImageCallback methodsFor: 'converting' stamp: 'lr 9/14/2008 10:06'!
convertKey: aString
	^ aString , '.x'! !

!WACallback class methodsFor: 'instance creation' stamp: 'MAD 2/20/2009 12:33'!
on: aBlock
	^ self new block: aBlock! !

!WACallback methodsFor: 'comparing' stamp: 'lr 12/28/2008 14:47'!
<= other
	^ self priority < other priority or: [ self priority = other priority and: [ self key asNumber <= other key asNumber ] ]! !

!WACallback methodsFor: 'accessing' stamp: 'lr 3/5/2009 21:07'!
block: aBlock! !

!WACallback methodsFor: 'converting' stamp: 'avi 9/2/2004 14:46'!
convertKey: aString
	^ aString! !

!WACallback methodsFor: 'evaluation' stamp: 'lr 12/28/2008 14:30'!
evaluateWithArgument: anObject
	self subclassResponsibility! !

!WACallback methodsFor: 'evaluation' stamp: 'lr 12/28/2008 16:05'!
evaluateWithField: anObject
	self evaluateWithArgument: (self valueForField: anObject)! !

!WACallback methodsFor: 'testing' stamp: 'MAD 2/11/2009 21:41'!
isEnabledFor: aRequestContext
	^ true! !

!WACallback methodsFor: 'accessing' stamp: 'lr 12/28/2008 14:47'!
key
	"Answer the callback key of the receiver."
	
	^ self convertKey: key! !

!WACallback methodsFor: 'accessing' stamp: 'lr 12/28/2008 14:48'!
priority
	"Answer the priority in which the receiver is evaluated."
	
	^ 0! !

!WACallback methodsFor: 'initialization' stamp: 'lr 12/28/2008 14:49'!
setKey: aString callbacks: aDictionary
	key := aString! !

!WACallback methodsFor: 'converting' stamp: 'lr 12/28/2008 13:22'!
valueForField: anObject
	^ anObject isNil
		ifTrue: [ String new ]
		ifFalse: [
			anObject isString
				ifTrue: [ anObject ]
				ifFalse: [
					anObject isEmpty
						ifTrue: [ String new ]
						ifFalse: [ self valueForField: anObject first ] ] ]! !

WACallback subclass: #WADispatchCallback
	instanceVariableNames: 'callbacks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WADispatchCallback methodsFor: 'evaluation' stamp: 'lr 12/28/2008 14:51'!
evaluateWithArgument: anObject
	callbacks at: anObject ifPresent: [ :callback | callback evaluateWithField: nil ]! !

!WADispatchCallback methodsFor: 'initialization' stamp: 'lr 12/28/2008 13:59'!
setKey: aString callbacks: aDictionary
	super setKey: aString callbacks: aDictionary.
	callbacks := aDictionary! !

WADispatchCallback subclass: #WAMultiDispatchCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WAMultiDispatchCallback methodsFor: 'evaluation' stamp: 'lr 12/28/2008 14:50'!
evaluateWithField: anObject
	| sorted |
	(anObject isString or: [ anObject isCollection not ])
		ifTrue: [ ^ super evaluateWithField: anObject ].
	sorted := SortedCollection new.
	anObject do: [ :each |
		callbacks at: each ifPresent: [ :callback |
			sorted add: callback ] ].
	sorted do: [ :callback | callback evaluateWithField: nil ]! !

WACallback subclass: #WAValueCallback
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

WAValueCallback subclass: #WAMapCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WAMapCallback methodsFor: 'converting' stamp: 'jf 9/30/2009 01:04'!
valueForField: anObject 
	| stream x y |
	stream := (super valueForField: anObject) readStream.
	(stream atEnd not and: [ stream next = $? ]) ifFalse: [ ^ nil ].
	x := (stream upTo: $,) greaseInteger.
	(x isNil or: [ stream atEnd ]) ifTrue: [ ^ nil ].
	y := stream upToEnd greaseInteger.
	y isNil ifTrue: [ ^ nil ].
	^ x @ y! !

WAValueCallback subclass: #WAUploadCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WAUploadCallback methodsFor: 'converting' stamp: 'lr 12/28/2008 13:16'!
valueForField: anObject
	^ (anObject isKindOf: WAFile) ifTrue: [ anObject ]! !

!WAValueCallback methodsFor: 'accessing' stamp: 'avi 9/19/2006 14:29'!
block: aOneArgBlock
	block := aOneArgBlock fixCallbackTemps! !

!WAValueCallback methodsFor: 'evaluation' stamp: 'pmm 1/10/2009 23:01'!
evaluateWithArgument: anObject
	anObject isNil
		ifFalse: [ block valueWithPossibleArguments: (Array with:  anObject) ]! !

WAObject subclass: #WACallbackRegistry
	instanceVariableNames: 'callbacks nextKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Callbacks'!

!WACallbackRegistry class methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
context: aContext 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry class>>#context:'
		details: 'Use #new. Callbacks are no longer instantiated with a context and an owning component.'.
	^ self new! !

!WACallbackRegistry class methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
context: aContext owner: anObject 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry class>>#context:owner:'
		details: 'Use #new. Callbacks are no longer instantiated with a context and an owning component.'.
	^ self new! !

!WACallbackRegistry methodsFor: 'accessing' stamp: 'jf 10/7/2008 20:56'!
advanceKey
	| key |
	key := self nextKey.
	self increaseKey.
	^ key! !

!WACallbackRegistry methodsFor: 'processing' stamp: 'MAD 2/11/2009 21:40'!
handle: aRequestContext
	| sorted |
	sorted := SortedCollection new.
	aRequestContext request fields keysDo: [ :key |
		callbacks at: key ifPresent: [ :callback |
			(callback isEnabledFor: aRequestContext)
				ifTrue: [ sorted add: callback ] ] ].
	sorted do: [ :callback |
		callback evaluateWithField: (aRequestContext request fields 
			at: callback key) ]! !

!WACallbackRegistry methodsFor: 'accessing' stamp: 'lr 12/28/2008 16:16'!
increaseKey
	nextKey := nextKey + 1! !

!WACallbackRegistry methodsFor: 'initialization' stamp: 'lr 12/28/2008 16:16'!
initialize
	super initialize.
	callbacks := Dictionary new.
	nextKey := 1! !

!WACallbackRegistry methodsFor: 'accessing' stamp: 'jf 9/30/2009 01:10'!
nextKey
	^ nextKey greaseString! !

!WACallbackRegistry methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
registerActionCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerActionCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WAActionCallback on: aBlock)! !

!WACallbackRegistry methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
registerCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WAValueCallback on: aBlock)! !

!WACallbackRegistry methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
registerCancelActionCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerCancelActionCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WACancelActionCallback on: aBlock)! !

!WACallbackRegistry methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
registerDefaultActionCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerDefaultActionCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WADefaultActionCallback on: aBlock)! !

!WACallbackRegistry methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
registerDispatchCallback
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerDispatchCallback'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: WADispatchCallback new! !

!WACallbackRegistry methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
registerImageCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerImageCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WAImageCallback on: aBlock)! !

!WACallbackRegistry methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
registerMapCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerMapCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WAMapCallback on: aBlock)! !

!WACallbackRegistry methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
registerMultiDispatchCallback
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerMultiDispatchCallback'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: WAMultiDispatchCallback new! !

!WACallbackRegistry methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
registerUploadCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerUploadCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WAUploadCallback on: aBlock)! !

!WACallbackRegistry methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
registerValueCallback: aBlock 
	self 
		greaseDeprecatedApi: 'WACallbackRegistry>>#registerValueCallback:'
		details: 'Use WACallbackRegistry>>#store: instead.'.
	^ self store: (WAValueCallback on: aBlock)! !

!WACallbackRegistry methodsFor: 'registration' stamp: 'MAD 2/20/2009 12:05'!
store: aCallback 
	| key |
	key := self advanceKey.
	callbacks 
		at: (aCallback convertKey: key)
		put: aCallback.
	aCallback 
		setKey: key
		callbacks: callbacks.
	^ key! !

WAObject subclass: #WAClosingConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAClosingConditionalComment commentStamp: 'pmm 1/28/2008 07:07' prior: 0!
Closes a WAConditionalComment.!

!WAClosingConditionalComment methodsFor: 'printing' stamp: 'lr 3/27/2007 11:37'!
encodeOn: aDocument
	aDocument nextPutAll: '<!![endif]-->'! !

WAObject subclass: #WAClosingRevealedConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAClosingRevealedConditionalComment commentStamp: 'pmm 1/28/2008 07:07' prior: 0!
Closes a WARevealedConditionalComment.!

!WAClosingRevealedConditionalComment methodsFor: 'printing' stamp: 'pmm 11/25/2007 21:55'!
encodeOn: aDocument
	aDocument nextPutAll: '<!!--<!![endif]-->'! !

WAObject subclass: #WAConditionalComment
	instanceVariableNames: 'condition root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAConditionalComment commentStamp: 'pmm 1/28/2008 07:06' prior: 0!
A WAConditionalComment is an implementation of Downlevel-hidden Conditional Comments:
http://msdn2.microsoft.com/en-us/library/ms537512.aspx
These are only visible for the IE family of browsers.

See also WAOpeningConditionalComment and WAClosingConditionalComment.!

!WAConditionalComment class methodsFor: 'instance creation' stamp: 'jf 3/13/2009 18:04'!
root: anHtmlRoot
	^self basicNew initializeWithRoot: anHtmlRoot! !

!WAConditionalComment methodsFor: 'private' stamp: 'lr 3/27/2007 11:36'!
addToCondition: aString
	condition := condition , aString! !

!WAConditionalComment methodsFor: 'private' stamp: 'pmm 11/25/2007 21:51'!
closingConditionClass
	^WAClosingConditionalComment! !

!WAConditionalComment methodsFor: 'public' stamp: 'pmm 11/25/2007 21:51'!
do: aBlock
	root add: (self openingConditionClass condition: condition).
	aBlock value.
	root add: (self closingConditionClass new)! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/11/2006 17:19'!
equal
	"implicit of nothing else"! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/11/2006 17:14'!
greaterThan
	self addToCondition: ' gt'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 10/11/2006 17:16'!
ie
	self addToCondition: ' IE'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 9/20/2009 11:33'!
ie5
	self addToCondition: '5'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 9/20/2009 11:32'!
ie50
	self addToCondition: '5.0'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 9/20/2009 11:32'!
ie55
	self ie: '5.5'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 9/20/2009 11:32'!
ie6
	self ie: '6'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 9/20/2009 11:32'!
ie7
	self ie: '7'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 9/20/2009 11:32'!
ie8
	self ie: '8'! !

!WAConditionalComment methodsFor: 'features' stamp: 'pmm 9/20/2009 11:32'!
ie: aString
	self addToCondition: ' IE ', aString! !

!WAConditionalComment methodsFor: 'initialization' stamp: 'jf 3/13/2009 18:05'!
initializeWithRoot: anHtmlRoot
	self initialize.
	root := anHtmlRoot.
	condition := 'if'! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/11/2006 17:15'!
lessThan
	self addToCondition: ' lt'! !

!WAConditionalComment methodsFor: 'operators' stamp: 'tbn 11/21/2007 12:41'!
not
	self addToCondition: ' !!'! !

!WAConditionalComment methodsFor: 'private' stamp: 'pmm 11/25/2007 21:51'!
openingConditionClass
	^WAOpeningConditionalComment! !

!WAConditionalComment methodsFor: 'operators' stamp: 'pmm 10/19/2006 20:19'!
orEqual
	self addToCondition: 'e'! !

WAConditionalComment subclass: #WARevealedConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WARevealedConditionalComment commentStamp: 'pmm 1/28/2008 07:07' prior: 0!
A WAConditionalComment is an implementation of Downlevel-revealed Conditional Comments:
http://msdn2.microsoft.com/en-us/library/ms537512.aspx
Non-IE family browsers see them always.

See also WAOpeningRevealedConditionalComment and WARevealedConditionalComment.!

!WARevealedConditionalComment methodsFor: 'private' stamp: 'pmm 11/25/2007 21:55'!
closingConditionClass
	^WAClosingRevealedConditionalComment! !

!WARevealedConditionalComment methodsFor: 'private' stamp: 'pmm 11/25/2007 21:55'!
openingConditionClass
	^WAOpeningRevealedConditionalComment! !

WAObject subclass: #WAConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAConfiguration commentStamp: 'jf 7/24/2008 19:44' prior: 0!
A configuration for a Seaside application contains attributes which can be used by Seaside and the application. WAConfiguration hierarchy uses the composite pattern.

Subclasses of WASystemConfiguration define and configure related groups of attributes. See WASystemConfiguration class comment for information on defining your own attributes.

WAUserConfiguration is a composite of configurations. The set of configurations contained in WAUserConfiguration is called the ancestors. Attribute values in a configuration override the attribute values in the ancestors. WAUserConfiguration also holds the non-default values of attributes.

Seaside applications start with a WAUserConfiguration (see WAApplication>>configuration) a single parent: WARenderLoopConfiguration. The full ancestry also includes WASessionConfiguration WAGlobalConfiguration. Other configurations can be added to an application on the Seaside configuration page for the application or in your application. Values for the attributes can be given in either location. 

See Seaside documentation (http://www.seaside.st/documentation) on configuration and preferences (http://www.seaside.st/documentation/Configuration%20and%20Preferences) for more information.

Example of setting attributes and adding configurations in code
ASubclassOfWAComponent class>>initialize
	"self initialize"
	| application |
	application := self registerAsApplication: 'GlorpExample'.
	"set a standard attribute"
	application preferenceAt: #sessionClass put: Glorp.WAGlorpSession. 

	"add a configuration"
	application configuration addParent: GlorpConfiguration new.
	application preferenceAt: #databaseLogin put: 'foo'. "set attribute defined in GlorpConfiguration"

Subclasses must implement the following messages:
	name
		return the name of the configuration

	localValueAt:ifAbsent:
		return the value of the attribute given as first argument!

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 1/1/2009 21:31'!
allAttributes
	| attributes |
	attributes := IdentityDictionary new.
	
	self ancestorsDo: 
		[ :each |
		each localAttributesDo: [ :attr | attributes at: attr key put: attr ] ].
	
	^ attributes! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'pmm 10/27/2008 15:23'!
ancestors
	"As it happens, the 'seen' set gives us the result we need"
	| set |
	set := IdentitySet new.
	self 
		ancestorsDo:  [ :each | "nothing" ]
		seen: set.
	^ set! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:22'!
ancestorsDo: aBlock 
	| set |
	set := IdentitySet new.
	self 
		ancestorsDo: aBlock
		seen: set.
	^ set! !

!WAConfiguration methodsFor: 'ancestry-private' stamp: 'jf 1/1/2009 23:11'!
ancestorsDo: aBlock seen: seenSet 
	self parents reverseDo: [ :each | 
		(seenSet includes: each) ifFalse: [
			aBlock value: each.
			seenSet add: each.
			each 
				ancestorsDo: aBlock
				seen: seenSet ] ]! !

!WAConfiguration methodsFor: 'values' stamp: 'jf 1/1/2009 23:17'!
at: aSymbol 
	| value context |
	context := self createSearchContextFor: aSymbol.

	value := self valueForContext: context.
	
	^ value isNil
		ifTrue: [ context attribute default ]
		ifFalse: [ value ]! !

!WAConfiguration methodsFor: 'attributes' stamp: 'lr 1/11/2009 14:03'!
attributeAt: aSymbol
	^ self attributeAt: aSymbol ifAbsent: [ WAAttributeNotFound signalWithKey: aSymbol ]! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 7/29/2008 18:40'!
attributeAt: aSymbol ifAbsent: aBlock
	^ self allAttributes at: aSymbol ifAbsent: aBlock! !

!WAConfiguration methodsFor: 'attributes-private' stamp: 'lr 1/11/2009 14:03'!
createSearchContextFor: aSymbol 
	| context |
	context := WAAttributeSearchContext key: aSymbol target: self.
	context attribute isNil ifTrue: [ WAAttributeNotFound signalWithKey: aSymbol ].
	^ context! !

!WAConfiguration methodsFor: 'values' stamp: 'jf 8/4/2008 16:07'!
expressionAt: aSymbol ifAbsent: absentBlock
	self subclassResponsibility! !

!WAConfiguration methodsFor: 'values' stamp: 'jf 8/4/2008 16:09'!
expressionAt: aSymbol ifPresent: aBlock
	| expression |
	expression := self expressionAt: aSymbol ifAbsent: [ ^ nil ].
	^ aBlock value: expression! !

!WAConfiguration methodsFor: 'values-private' stamp: 'jf 1/1/2009 23:17'!
inheritedValueForContext: aContext
	| value |
	(self parents select: [ :each | aContext isAttributeInheritedOn: each ]) reverseDo:
		[ :each |
		value := each valueForContext: aContext.
		value notNil ifTrue: [ ^ value ] ].
	
	^ nil! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'jf 1/1/2009 21:26'!
inheritsFrom: aConfiguration
	"Answer whether the given Configuration is a direct or indirect ancestor of this one"
	^ self ancestors includes: aConfiguration! !

!WAConfiguration methodsFor: 'testing' stamp: 'lr 10/21/2008 15:49'!
isShared
	^ false! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 1/1/2009 21:09'!
localAttributeAt: aSymbol ifAbsent: absentBlock
	self subclassResponsibility! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 1/1/2009 21:10'!
localAttributeAt: aSymbol ifPresent: aBlock
	| value |
	value := self localAttributeAt: aSymbol ifAbsent: [ ^ nil ].
	^ aBlock value: value! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 1/1/2009 21:28'!
localAttributesDo: aBlock
	self subclassResponsibility! !

!WAConfiguration methodsFor: 'accessing' stamp: 'jf 1/1/2009 21:24'!
name
	^self class name! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:10'!
parents
	^ #()! !

!WAConfiguration methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
valueAt: aSymbol 
	self 
		greaseDeprecatedApi: 'WAConfiguration>>#valueAt:'
		details: 'Use #at:.'.
	^ self at: aSymbol! !

!WAConfiguration methodsFor: 'values-private' stamp: 'jf 1/1/2009 23:23'!
valueForContext: aContext
	aContext at: self ifPresent: [ :v | ^ v ].
	
	self expressionAt: aContext key ifPresent:
		[ :expression |
		^ aContext
			at: self
			put: (expression determineValueWithContext: aContext configuration: self) ].
	
	(aContext isAttributeLocalOn: self) ifTrue: [ ^ aContext at: self put: nil ].

	^ aContext at: self put: (self inheritedValueForContext: aContext)! !

WAConfiguration subclass: #WASystemConfiguration
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

!WASystemConfiguration commentStamp: 'jf 7/24/2008 19:44' prior: 0!
You should subclass WASystemConfiguration to define new attributes. The method #addAttributes is passed an instance of WAAttributes which can be used to create new attributes. The attributes can be configured to specify their default value, label, and so on. See the methods on WAConfigurationAttribute and its subclasses to see what options are available.

If a configuration needs to override the value of another WASystemConfiguration or depends on its attributes, implement the method "parents", returning a collection of configuration objects.

WASystemConfiguration subclasses are "read-only" in that their attributes, parents, and default values are all specified in code. Users and applications that want to configure values for attributes should create a WAUserConfiguration and specify the WASystemConfiguration in its ancestry.

WASystemConfiguration classes are singleton. You should use #instance on the class side to get the current instance. You cannot call #copy on a WASystemConfiguration.

Subclasses should implement the following messages:
	addAttributes:
		
They may also want to implement:
	addOverrides:
	parents!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

WASystemConfiguration subclass: #WAAuthConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Filter'!

!WAAuthConfiguration commentStamp: 'jf 7/22/2008 12:39' prior: 0!
WAAuthConfiguration defines attributes to store a username and password for an application. It is used by WAApplication to provide a basic single-account authentication mechanism for applications like the Seaside Configuration application. It changes to mainClass for the session to WAAuthMain, which adds a Decoration to check for authentication before displaying the root component.

You can implement your own authentication mechanism without using this configuration by subclassing WAApplication and implementing #verifyPassword:forUser: to lookup account details from a database or similar. You can then manually set WAAuthMain as your main class.
!

!WAAuthConfiguration methodsFor: 'description' stamp: 'lr 9/12/2008 19:46'!
describeOn: config
	(config string: #login)
		group: #authentication;
		comment: 'The username for this application.'.
	(config password: #passwordHash)
		group: #authentication;
		comment: 'The password for this application.';
		label: 'Password'.! !

WASystemConfiguration subclass: #WACacheCapacityConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WACacheCapacityConfiguration methodsFor: 'description' stamp: 'jf 1/10/2009 15:07'!
describeOn: config
	(config integer: #cacheCapacity)
		comment: 'The maximum number of objects to keep in the cache.';
		default: 20! !

WASystemConfiguration subclass: #WACacheTimeoutConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WACacheTimeoutConfiguration methodsFor: 'description' stamp: 'jf 1/10/2009 15:12'!
describeOn: config
	(config integer: #cacheTimeout)
		comment: 'The maximum lifetime of a cached object in seconds';
		default: 600! !

WASystemConfiguration subclass: #WAExceptionFilterConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Filter'!

!WAExceptionFilterConfiguration methodsFor: 'description' stamp: 'jf 3/4/2009 10:15'!
describeOn: config
	(config list: #exceptionHandler)
		options: [ self exceptionHandlerClasses ];
		default: WAErrorHandler.! !

!WAExceptionFilterConfiguration methodsFor: 'description' stamp: 'jf 3/4/2009 10:15'!
exceptionHandlerClasses
	^ WAExceptionHandler withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

WASystemConfiguration subclass: #WAFileHandlerConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Libraries'!

!WAFileHandlerConfiguration methodsFor: 'description' stamp: 'lr 1/2/2009 20:53'!
describeOn: config
	(config list: #fileHandlerListingClass)
		beAdvanced;
		options: [ self listingClasses ];
		default: WAForbiddenFileHandlerListing! !

!WAFileHandlerConfiguration methodsFor: 'description' stamp: 'jf 11/9/2008 18:14'!
listingClasses
	^ WAFileHandlerListing allSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

!WAFileHandlerConfiguration methodsFor: 'ancestry' stamp: 'jf 11/9/2008 17:48'!
parents
	^ Array with: WARequestHandlingConfiguration instance! !

WASystemConfiguration subclass: #WARegistryConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandling'!

!WARegistryConfiguration methodsFor: 'description' stamp: 'jf 1/30/2009 10:57'!
describeOn: config
	(config boolean: #useCookies)
		comment: 'Whether cookies should be generated and honoured for registry keys. Will fall back to URL if the client does not support cookies.';
		default: false.! !

!WARegistryConfiguration methodsFor: 'ancestry' stamp: 'jf 1/30/2009 10:57'!
parents
	^ Array with: WARequestHandlingConfiguration instance! !

WASystemConfiguration subclass: #WARequestHandlingConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandling'!

!WARequestHandlingConfiguration commentStamp: 'jf 7/24/2008 22:37' prior: 0!
This configuration class holds attributes needed by classes in the Request Handling layer.!

!WARequestHandlingConfiguration methodsFor: 'description' stamp: 'yann.monclair 9/4/2009 17:16'!
describeOn: config 
	(config string: #charSet)
		beAdvanced;
		label: 'Charater Set';
		comment: 'The character set reported to the browser. You may additionally need to configure your server that this is also the character set used by your server.';
		default: 'utf-8'.
	(config list: #documentClass)
		beAdvanced;
		options: [ self documentClasses ];
		default: WAHtmlDocument.
	(config list: #responseGenerator)
		beAdvanced;
		options: [ self responseGenerators ];
		default: WAResponseGenerator.
	(config list: #serverProtocol)
		beAdvanced;
		group: #server;
		comment: 'The protocol in URLs generated by Seaside.';
		options: [ self serverProtocols ].
	(config string: #serverHostname)
		beAdvanced;
		group: #server;
		comment: 'The hostname in URLs generated by Seaside.'.
	(config integer: #serverPort)
		beAdvanced;
		group: #server;
		comment: 'The port in URLs generated by Seaside.'.
	(config string: #serverPath)
		group: #server;
		comment: 'The path in URLs generated by Seaside.'! !

!WARequestHandlingConfiguration methodsFor: 'private' stamp: 'jf 1/23/2009 23:17'!
documentClasses
	^ WADocument withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

!WARequestHandlingConfiguration methodsFor: 'private' stamp: 'lr 2/20/2009 11:01'!
responseGenerators
	^ WAResponseGenerator withAllSubclasses asSortedCollection: [ :a :b | a name <= b name ]! !

!WARequestHandlingConfiguration methodsFor: 'private' stamp: 'lr 12/29/2008 11:56'!
serverProtocols
	^ #('http' 'https')! !

WASystemConfiguration subclass: #WARetrievalIntervalReapingStrategyConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Cache'!

!WARetrievalIntervalReapingStrategyConfiguration methodsFor: 'description' stamp: 'jf 1/10/2009 15:10'!
describeOn: config
	(config integer: #cacheReapInterval)
		comment: 'The number of cache retrievals that are allowed before expired objects are reaped from the cache.';
		default: 10! !

!WASystemConfiguration class methodsFor: 'actions' stamp: 'MAD 9/13/2008 12:26'!
clearAllDescriptions
	self allSubclasses do: [ :each | each instance clearDescription ]! !

!WASystemConfiguration class methodsFor: 'accessing' stamp: 'lr 5/3/2006 09:44'!
instance
	^ instance ifNil: [ instance := self basicNew initialize ]! !

!WASystemConfiguration class methodsFor: 'instance creation' stamp: 'jf 7/18/2008 17:10'!
new
	^ self error: 'SystemConfigurations are singletons. Use #instance.'! !

!WASystemConfiguration methodsFor: 'private' stamp: 'jf 7/29/2008 18:36'!
attributes
	^ self description attributes! !

!WASystemConfiguration methodsFor: 'description' stamp: 'jf 1/1/2009 20:48'!
buildDescription
	| d |
	d := WAConfigurationDescription new.
	self describeOn: d.
	^ description := d! !

!WASystemConfiguration methodsFor: 'description' stamp: 'jf 7/29/2008 18:56'!
clearDescription
	description := nil! !

!WASystemConfiguration methodsFor: 'copying' stamp: 'jf 7/18/2008 17:10'!
copy
	^ self error: 'SystemConfigurations are singletons and should not be copied.'! !

!WASystemConfiguration methodsFor: 'description' stamp: 'jf 7/29/2008 17:55'!
describeOn: conf
	"Should be implemented by subclasses to add attributes and value overrides to the configuration"! !

!WASystemConfiguration methodsFor: 'private' stamp: 'jf 7/29/2008 18:56'!
description
	^ description isNil 
		ifFalse: [ description ]
		ifTrue: [ self buildDescription ]! !

!WASystemConfiguration methodsFor: 'values' stamp: 'jf 9/11/2008 11:27'!
expressionAt: aSymbol ifAbsent: absentBlock
	^ self description expressions at: aSymbol ifAbsent: absentBlock.! !

!WASystemConfiguration methodsFor: 'attributes' stamp: 'jf 1/1/2009 21:08'!
localAttributeAt: aSymbol ifAbsent: absentBlock
	^ self attributes at: aSymbol ifAbsent: absentBlock! !

!WASystemConfiguration methodsFor: 'attributes' stamp: 'jf 1/1/2009 21:30'!
localAttributesDo: aBlock
	self attributes do: aBlock! !

WAConfiguration subclass: #WAUserConfiguration
	instanceVariableNames: 'expressions parents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAUserConfiguration commentStamp: 'jf 7/24/2008 19:45' prior: 0!
WAUserConfiguration is a composite of configurations.  This composite of configurations is stored in the field "parents". WAUserConfiguration provides methods to dynamically provide non-default values for attributes. WAUserConfiguration inherits attributes and values defined in its ancestors. If WAUserConfiguration does not have a value for an attribute it will search its ancestors for a value, stopping when it finds a value.

An instance of WAUserConfiguration is the first configuration added to a Seaside application (WAApplication). All other configurations added to the application are added as ancestors of this instance. When a value for an attribute is set either by the standard Seaside component configuration page or in code the value is added to the "values" dictionary in WAUserConfiguration.

Instance Variables:
	parents	<Collection of: WAConfiguration>	 hierarchy of configurations defining all attributes for this instance of WAUserConfiguration
	values	<Dictionary>	the dictionary key is an attribute key, dictionary value is value of that attribute 
!

WAUserConfiguration subclass: #WASharedConfiguration
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

WASharedConfiguration class
	instanceVariableNames: 'instances'!

WASharedConfiguration class
	instanceVariableNames: 'instances'!

!WASharedConfiguration class methodsFor: 'accessing' stamp: 'jf 7/31/2008 14:38'!
configurations
	^ instances copy! !

!WASharedConfiguration class methodsFor: 'initialization' stamp: 'lr 10/21/2008 15:34'!
initialize
	instances := Set new! !

!WASharedConfiguration class methodsFor: 'instance creation' stamp: 'jf 3/15/2009 19:01'!
named: aString
	"Answer a shared configuration with the given name aString or answer a newly created one."
	
	^ instances
		detect: [ :each | each name = aString ]
		ifNone: [
			| config |
			instances add: (self basicNew
				initializeWithName: aString;
				yourself) ]! !

!WASharedConfiguration class methodsFor: 'instance creation' stamp: 'lr 1/9/2009 08:21'!
new
	self error: 'Create or retrieve shared configurations by sending the message #named:'! !

!WASharedConfiguration class methodsFor: 'instance creation' stamp: 'lr 1/9/2009 08:30'!
unregister: aConfiguration
	"Removes aConfiguration from the list of known configurations."
	
	^ instances remove: aConfiguration ifAbsent: [ nil ]! !

!WASharedConfiguration methodsFor: 'initialization' stamp: 'jf 3/13/2009 18:18'!
initializeWithName: aString
	self initialize.
	name := aString! !

!WASharedConfiguration methodsFor: 'testing' stamp: 'lr 10/21/2008 15:49'!
isShared
	^ true! !

!WASharedConfiguration methodsFor: 'accessing' stamp: 'jf 7/31/2008 14:15'!
name
	^ name! !

!WASharedConfiguration methodsFor: 'actions' stamp: 'lr 10/21/2008 15:55'!
unregister
	self class unregister: self! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'lr 1/11/2009 13:35'!
addParent: aConfiguration
	(self parents includes: aConfiguration)
		ifTrue: [ ^ aConfiguration ].
	(self canAddParent: aConfiguration) 
		ifTrue: [ parents add: aConfiguration ]
		ifFalse: [ WAConfigurationError signal: 'Cannot add this configuration as a parent. Would this cause a circular ancestry graph?' ].
	^ aConfiguration! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 10/5/2008 14:42'!
at: aSymbol addAll: aCollection
	^ self at: aSymbol addAll: aCollection removeAll: #()! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 10/5/2008 14:42'!
at: aSymbol addAll: additions removeAll: removals
	^ self
		storeExpression:
			((WAAddRemoveExpression key: aSymbol)
				additions: additions;
				removals: removals;
				yourself)
		forAttribute: (self attributeAt: aSymbol)! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 10/5/2008 14:40'!
at: aSymbol put: anObject
	"It would be faster to simply add the value to the dictionary and
	implement #takeValue:forAttribute: in terms of this method, but
	config options are set only rarely and this ensures you are setting
	a value for an attribute that actually exists."

	^ self takeValue: anObject forAttribute: (self attributeAt: aSymbol)! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:42'!
canAddParent: aConfiguration 
	^ (aConfiguration = self or: [ aConfiguration inheritsFrom: self ]) not! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 8/4/2008 16:17'!
expressionAt: aSymbol ifAbsent: errorBlock
	^ expressions at: aSymbol ifAbsent: errorBlock! !

!WAUserConfiguration methodsFor: 'initialization' stamp: 'jf 8/4/2008 16:17'!
initialize
	super initialize.
	expressions := Dictionary new.
	parents := OrderedCollection new! !

!WAUserConfiguration methodsFor: 'attributes' stamp: 'jf 1/1/2009 21:08'!
localAttributeAt: aSymbol ifAbsent: absentBlock
	^ absentBlock value! !

!WAUserConfiguration methodsFor: 'attributes' stamp: 'jf 1/1/2009 21:29'!
localAttributesDo: aBlock
	"we have no local attributes -- do nothing"! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'lr 8/30/2008 15:36'!
moveParentDown: aConfiguration 
	| index |
	index := parents indexOf: aConfiguration ifAbsent: [ ^ self ].
	index < parents size ifTrue: [ parents swap: index with: index + 1 ]! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'lr 8/30/2008 15:36'!
moveParentUp: aConfiguration 
	| index |
	index := parents indexOf: aConfiguration ifAbsent: [ ^ self ].
	index > 1 ifTrue: [ parents swap: index with: index - 1 ]! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'jf 7/24/2008 19:47'!
parents
	^ parents! !

!WAUserConfiguration methodsFor: 'copying' stamp: 'jf 8/4/2008 16:18'!
postCopy
	super postCopy.
	expressions := expressions copy.
	parents := parents copy.! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 1/1/2009 21:58'!
removeExpressionAt: aSymbol
	^ self removeExpressionAt: aSymbol ifAbsent: [ nil ]! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 1/1/2009 21:48'!
removeExpressionAt: aSymbol ifAbsent: aBlock
	^ expressions removeKey: aSymbol ifAbsent: aBlock! !

!WAUserConfiguration methodsFor: 'ancestry' stamp: 'lr 8/30/2008 15:34'!
removeParent: aConfiguration 
	parents 
		remove: aConfiguration
		ifAbsent: [ ]! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 1/1/2009 20:48'!
storeExpression: anAttributeExpression forAttribute: anAttribute
	^ expressions at: anAttribute key put: anAttributeExpression! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 1/1/2009 20:48'!
takeValue: anObject forAttribute: anAttribute
	^ anObject isNil ifFalse: [
		self
			storeExpression:
				((WAValueExpression key: anAttribute key)
					value: anObject;
					yourself)
			forAttribute: anAttribute ]! !

!WAUserConfiguration methodsFor: 'values' stamp: 'jf 7/19/2008 20:40'!
takeValueFromString: aString forAttribute: anAttribute
	^ self takeValue: (anAttribute valueFromString: aString) forAttribute: anAttribute! !

!WAUserConfiguration methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
valueAt: aSymbol put: anObject 
	self 
		greaseDeprecatedApi: 'WAUserConfiguration>>#valueAt:put:'
		details: 'Use #at:put:.'.
	^ self 
		at: aSymbol
		put: anObject! !

WAObject subclass: #WAConfigurationDescription
	instanceVariableNames: 'attributes expressions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAConfigurationDescription commentStamp: 'jf 7/19/2008 13:33' prior: 0!
I hold a collection of attributes and present methods to construct new methods, providing an interface a bit like WACanvs and #renderContentOn: to WASystemConfiguration>>addAttributes:.

I can use any kind of collection class and handle setting the #configuration: parameter of the attribute appropriately on addition. If my collection is a Dictionary, I will store the attributes by their keys.
!

!WAConfigurationDescription methodsFor: 'private' stamp: 'jf 1/1/2009 20:47'!
add: aDescriptor to: aDictionary
	^ aDictionary at: aDescriptor key put: aDescriptor! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 16:57'!
addAttribute: anAttribute
	^ self add: anAttribute to: attributes! !

!WAConfigurationDescription methodsFor: 'values' stamp: 'jf 9/11/2008 11:24'!
addExpression: anExpression
	^ self add: anExpression to: expressions! !

!WAConfigurationDescription methodsFor: 'values' stamp: 'jf 7/31/2008 13:11'!
at: aSymbol addAll: aCollection
	self at: aSymbol addAll: aCollection removeAll: #()! !

!WAConfigurationDescription methodsFor: 'values' stamp: 'jf 9/11/2008 11:24'!
at: aSymbol addAll: additions removeAll: removals
	self addExpression: ((WAAddRemoveExpression key: aSymbol)
			additions: additions;
			removals: removals;
			yourself)! !

!WAConfigurationDescription methodsFor: 'values' stamp: 'jf 9/11/2008 11:24'!
at: aSymbol put: anObject 
	self addExpression: ((WAValueExpression key: aSymbol)
			value: anObject;
			yourself)! !

!WAConfigurationDescription methodsFor: 'accessing' stamp: 'jf 7/29/2008 17:02'!
attributes
	^ attributes! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 16:59'!
boolean: aSymbol
	^ self addAttribute: (WABooleanAttribute key: aSymbol)! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 17:00'!
collection: aSymbol
	^ self addAttribute: (WACollectionAttribute key: aSymbol)! !

!WAConfigurationDescription methodsFor: 'accessing' stamp: 'jf 9/11/2008 11:27'!
expressions
	^ expressions! !

!WAConfigurationDescription methodsFor: 'initialization' stamp: 'jf 9/11/2008 11:27'!
initialize
	super initialize.
	attributes := IdentityDictionary new.
	expressions := IdentityDictionary new.! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 1/10/2009 14:23'!
integer: aSymbol
	^ self addAttribute: (WAIntegerAttribute key: aSymbol)! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 17:00'!
list: aSymbol
	^ self addAttribute: (WAListAttribute key: aSymbol)! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 17:00'!
number: aSymbol
	^ self addAttribute: (WANumberAttribute key: aSymbol)! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 17:00'!
password: aSymbol
	^ self addAttribute: (WAPasswordAttribute key: aSymbol)! !

!WAConfigurationDescription methodsFor: 'attribute creation' stamp: 'jf 7/29/2008 17:00'!
string: aSymbol
	^ self addAttribute: (WAStringAttribute key: aSymbol)! !

WAObject subclass: #WAConfigurationElement
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

WAConfigurationElement subclass: #WAAttribute
	instanceVariableNames: 'group comment label default advanced'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAAttribute commentStamp: 'jf 7/19/2008 13:54' prior: 0!
WAConfigurationAttribute represents a value of a specified type in a Seaside configuration. Some attributes are needed by Seaside for application parameters like deployment Mode and session timeout. Optional attributes like a database login may be used internally by the application.

Each subclass of WAConfigurationAttribute handles one type (Number, Boolean, etc) of attribute. The "group" of the attribute is used to place all attributes in the same group together on the Seaside configuration page. The "key" of the attribute identifies the attribute. Attribute keys must be globally unique so use namespacing where required to ensure uniqueness. See WAConfiguration for example of accessing a configuration attribute. 

Subclasses may implement their own configuration options depending on their needs.

Subclasses must implement the following messages:
	valueFromString: aString
		convert "aString" into type represented by the class, return result of the conversion
	
	accept: aVisitor with: anObject
		Typical implementation is:
			aVisitor visitXXXAttribute: self with: anObject

		where XXX is the type of this attribute. The method visitXXXAttribute:with: must be implemented in all visitors, in particular WAConfigurationEditor which creates the configuration page for Seaside applications.

Instance Variables:
	configuration	<WAConfiguration>	The configuration object that defined the attribute
	group	<Symbol>	name of the group the attribute belongs to
	key	<Symbol>	key or name of the attribute, used to look up the attribute
	comment	<String> a full length description of the attribute for displaying in the configuration interface
	label	<String>	a short field label used in the user interface. If not specified, a label is constructed from the key.
	default	<Object>	The default value for the attribute.!

!WAAttribute methodsFor: 'visiting' stamp: 'jf 1/11/2009 19:41'!
accept: aVisitor
	aVisitor visitAttribute: self! !

!WAAttribute methodsFor: 'actions' stamp: 'lr 1/2/2009 20:51'!
beAdvanced
	advanced := true! !

!WAAttribute methodsFor: 'accessing' stamp: 'lr 1/2/2009 20:43'!
comment
	"Answer a comment or help text of the receiving attribute."

	^ comment! !

!WAAttribute methodsFor: 'accessing' stamp: 'jf 7/16/2008 16:46'!
comment: aString
	comment := aString! !

!WAAttribute methodsFor: 'accessing' stamp: 'lr 1/2/2009 20:44'!
default
	"Answer a default value for the receiving attribute."

	^ default! !

!WAAttribute methodsFor: 'accessing' stamp: 'jf 7/18/2008 15:32'!
default: anObject
	default := anObject! !

!WAAttribute methodsFor: 'accessing' stamp: 'lr 1/2/2009 20:44'!
group
	"Answer the group of the receiving attribute."
	
	^ group ifNil: [ #general ]! !

!WAAttribute methodsFor: 'accessing' stamp: 'jf 7/16/2008 16:46'!
group: aSymbol
	group := aSymbol! !

!WAAttribute methodsFor: 'initialization' stamp: 'lr 1/2/2009 20:51'!
initializeWithKey: aSymbol
	super initializeWithKey: aSymbol.
	advanced := false! !

!WAAttribute methodsFor: 'testing' stamp: 'lr 1/2/2009 21:17'!
isAdvanced
	"Answer whether this is an advanced option and should be hidden by default in the configuration editor so as not to overwhelm new users."

	^ advanced! !

!WAAttribute methodsFor: 'accessing' stamp: 'lr 1/2/2009 20:44'!
label
	"Answer the label of the receiving attribute."

	^ label ifNil: [ self labelForSelector: self key ]! !

!WAAttribute methodsFor: 'accessing' stamp: 'jf 7/18/2008 18:10'!
label: aString
	label := aString! !

!WAAttribute methodsFor: 'printing' stamp: 'jf 9/30/2009 01:10'!
printOn: aStream 
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self key greaseString;
		nextPut: $)! !

!WAAttribute methodsFor: 'converting' stamp: 'jf 9/30/2009 01:10'!
stringForValue: anObject 
	^ anObject isNil ifFalse: [ anObject greaseString ]! !

!WAAttribute methodsFor: 'converting' stamp: 'lr 10/28/2007 14:42'!
valueFromString: aString
	self subclassResponsibility! !

WAAttribute subclass: #WABooleanAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WABooleanAttribute commentStamp: 'rew 10/7/2007 12:49' prior: 0!
WABooleanAttribute  represents a boolean attribute. It converts between text entered on the configuration page and boolean values.!

!WABooleanAttribute methodsFor: 'visiting' stamp: 'jf 1/11/2009 19:42'!
accept: aVisitor
	aVisitor visitBooleanAttribute: self! !

!WABooleanAttribute methodsFor: 'converting' stamp: 'lr 1/11/2009 13:36'!
valueFromString: aString
	^ aString = 'true'
		ifTrue: [ true ]
		ifFalse: [
			aString = 'false'
				 ifTrue: [ false ]
				 ifFalse: [ WAConfigurationError signal: 'Invalid value for boolean attribute' ] ]! !

WAAttribute subclass: #WAListAttribute
	instanceVariableNames: 'optionsBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAListAttribute commentStamp: 'jf 7/19/2008 13:55' prior: 0!
WAListAttribute is an attribute that is restricted to a list of values. 

Instance Variables:
	options	<Block>	A block returning a list of possible values for the attribute!

WAListAttribute subclass: #WACollectionAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WACollectionAttribute methodsFor: 'visiting' stamp: 'jf 1/11/2009 19:42'!
accept: aVisitor
	aVisitor visitCollectionAttribute: self! !

!WACollectionAttribute methodsFor: 'accessing' stamp: 'lr 11/11/2008 23:03'!
default: aCollection
	super default: (Array withAll: aCollection)! !

!WACollectionAttribute methodsFor: 'initialization' stamp: 'lr 10/22/2008 09:37'!
initializeWithKey: aSymbol
	super initializeWithKey: aSymbol.
	self default: #()! !

!WAListAttribute methodsFor: 'visiting' stamp: 'jf 1/11/2009 19:42'!
accept: aVisitor
	aVisitor visitListAttribute: self! !

!WAListAttribute methodsFor: 'accessing' stamp: 'lr 1/7/2009 12:25'!
options
	^ optionsBlock isNil
		ifTrue: [ #() ]
		ifFalse: [ optionsBlock value ]! !

!WAListAttribute methodsFor: 'accessing' stamp: 'jf 7/18/2008 20:19'!
options: aBlock
	optionsBlock := aBlock! !

!WAListAttribute methodsFor: 'converting' stamp: 'jf 9/11/2008 11:09'!
valueFromString: aString 
	self error: 'List attributes cannot be converted from Strings'! !

WAAttribute subclass: #WANumberAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WANumberAttribute commentStamp: 'rew 10/7/2007 12:51' prior: 0!
WANumberAttribute represents a number attribute. It converts between text entered on the configuration page and numbers.
!

WANumberAttribute subclass: #WAIntegerAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAIntegerAttribute methodsFor: 'visiting' stamp: 'jf 1/11/2009 19:43'!
accept: aVisitor
	aVisitor visitIntegerAttribute: self! !

!WAIntegerAttribute methodsFor: 'converting' stamp: 'jf 9/30/2009 01:04'!
valueFromString: aString 
	^ aString isEmptyOrNil ifFalse: [ aString greaseInteger ]! !

!WANumberAttribute methodsFor: 'visiting' stamp: 'jf 1/11/2009 19:43'!
accept: aVisitor
	aVisitor visitNumberAttribute: self! !

!WANumberAttribute methodsFor: 'converting' stamp: 'jf 7/31/2009 13:14'!
valueFromString: aString
	^ aString isEmptyOrNil ifFalse: [ Number readFrom: aString readStream ]! !

WAAttribute subclass: #WAPasswordAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAPasswordAttribute commentStamp: 'jf 7/10/2008 14:06' prior: 0!
WAPasswordAttribute represents a password attribute. When set from a string, it records a hashed value. On the Seaside configuration page it does not display its current value.
!

!WAPasswordAttribute methodsFor: 'visiting' stamp: 'jf 1/11/2009 19:43'!
accept: aVisitor
	aVisitor visitPasswordAttribute: self! !

!WAPasswordAttribute methodsFor: 'converting' stamp: 'jf 9/30/2009 00:19'!
valueFromString: aString 
	^ aString isEmptyOrNil ifFalse: [ GRPlatform current secureHashFor: aString ]! !

WAAttribute subclass: #WAStringAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAStringAttribute commentStamp: 'rew 10/7/2007 12:52' prior: 0!
WAStringAttribute represents a string attribute. It does the trivial conversion between text entered on the Seaside configuration page and a string.!

!WAStringAttribute methodsFor: 'visiting' stamp: 'jf 1/11/2009 19:43'!
accept: aVisitor
	aVisitor visitStringAttribute: self! !

!WAStringAttribute methodsFor: 'converting' stamp: 'lr 5/3/2006 09:56'!
valueFromString: aString
	^ aString isEmptyOrNil ifFalse: [ aString ]! !

WAConfigurationElement subclass: #WAAttributeExpression
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

WAAttributeExpression subclass: #WAAddRemoveExpression
	instanceVariableNames: 'additions removals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAAddRemoveExpression methodsFor: 'accessing' stamp: 'jf 7/31/2008 11:42'!
additions
	^ additions! !

!WAAddRemoveExpression methodsFor: 'accessing' stamp: 'jf 7/31/2008 11:43'!
additions: aCollection
	additions := aCollection! !

!WAAddRemoveExpression methodsFor: 'values' stamp: 'jf 1/1/2009 23:19'!
determineValueWithContext: aContext configuration: aConfiguration
	| collection result |
	collection := aConfiguration inheritedValueForContext: aContext.
	
	collection isNil ifTrue: [ collection := aContext attribute default ].
	collection isNil ifTrue: [ collection := Array new ].
	
	result := OrderedCollection withAll: collection.
	result := result reject: [ :each |
		(self additions includes: each)
			or: [ self removals includes: each ] ].
	result addAll: self additions.
	
	^ result asArray! !

!WAAddRemoveExpression methodsFor: 'accessing' stamp: 'jf 7/31/2008 13:09'!
removals
	^ removals! !

!WAAddRemoveExpression methodsFor: 'accessing' stamp: 'jf 7/31/2008 13:09'!
removals: anObject
	removals := anObject! !

!WAAttributeExpression methodsFor: 'values' stamp: 'jf 1/1/2009 18:18'!
determineValueWithContext: aContext configuration: aConfiguration
	self subclassResponsibility! !

WAAttributeExpression subclass: #WAValueExpression
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAValueExpression methodsFor: 'values' stamp: 'jf 1/1/2009 18:19'!
determineValueWithContext: aContext configuration: aConfiguration
	^ self value! !

!WAValueExpression methodsFor: 'accessing' stamp: 'jf 7/29/2008 16:31'!
value
	^ value! !

!WAValueExpression methodsFor: 'accessing' stamp: 'jf 7/29/2008 16:31'!
value: anObject
	value := anObject! !

!WAConfigurationElement class methodsFor: 'instance creation' stamp: 'jf 3/13/2009 18:05'!
key: aSymbol
	^ self basicNew initializeWithKey: aSymbol; yourself! !

!WAConfigurationElement methodsFor: 'initialization' stamp: 'jf 3/13/2009 18:05'!
initializeWithKey: aSymbol
	self initialize.
	key := aSymbol! !

!WAConfigurationElement methodsFor: 'accessing' stamp: 'jf 7/29/2008 16:54'!
key
	^ key! !

WAObject subclass: #WADictionaryMerger
	instanceVariableNames: 'dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WADictionaryMerger commentStamp: 'pmm 9/4/2008 14:07' prior: 0!
This is a utility class that merges multiple dictionaries. It also promotes values to collections if there a multiple mappings for the same key. This class can be used by server adapter to deal with http parameters.!

!WADictionaryMerger methodsFor: 'accessing' stamp: 'pmm 9/4/2008 14:13'!
at: aKey put: aValue
	^(aValue isKindOf: self collectionClass)
		ifTrue: [ 
			aValue size = 1
				ifTrue: [ self at: aKey putScalar: aValue first ]
				ifFalse: [ self at: aKey putCollection: aValue ] ]
		ifFalse: [ self at: aKey putScalar: aValue ]! !

!WADictionaryMerger methodsFor: 'private' stamp: 'pmm 9/4/2008 14:28'!
at: aKey putCollection: aCollection
	(dictionary includesKey: aKey)
		ifTrue: [
			| value |
			value := dictionary at: aKey.
			(value isKindOf: self collectionClass)
				ifTrue: [ value addAll: aCollection ]
				ifFalse: [
					dictionary
						at: aKey
						put: ((self collectionClass with: value), aCollection) ] ]
		ifFalse: [ dictionary at: aKey put: aCollection ]! !

!WADictionaryMerger methodsFor: 'private' stamp: 'pmm 9/4/2008 14:26'!
at: aKey putScalar: anObject
	^(dictionary includesKey: aKey)
		ifTrue: [
			| value |
			value := dictionary at: aKey.
			(value isKindOf: self collectionClass)
				ifTrue: [ value add: anObject ]
				ifFalse: [
					dictionary
						at: aKey
						put: (self collectionClass with: value with: anObject) ] ]
		ifFalse: [ dictionary at: aKey put: anObject ]! !

!WADictionaryMerger methodsFor: 'private' stamp: 'pmm 9/4/2008 14:09'!
collectionClass
	^OrderedCollection! !

!WADictionaryMerger methodsFor: 'accessing' stamp: 'pmm 9/4/2008 14:15'!
dictionary
	^dictionary! !

!WADictionaryMerger methodsFor: 'initialization' stamp: 'pmm 9/4/2008 14:08'!
initialize
	super initialize.
	dictionary := Dictionary new! !

WAObject subclass: #WADocument
	instanceVariableNames: 'root stream codec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WADocument class methodsFor: 'instance creation' stamp: 'jf 9/30/2009 00:19'!
new
	^ self on: GRPlatform current readWriteCharacterStream! !

!WADocument class methodsFor: 'instance creation' stamp: 'jf 9/30/2009 00:27'!
on: aStream 
	^ self 
		on: aStream
		codec: GRNullCodec new! !

!WADocument class methodsFor: 'instance creation' stamp: 'jf 1/23/2009 14:38'!
on: aStream codec: aCodec
	^ self basicNew initializeWithStream: aStream codec: aCodec; yourself! !

!WADocument class methodsFor: 'instance creation' stamp: 'jf 9/30/2009 00:27'!
stream: aStream 
	^ self 
		on: aStream
		codec: GRNullCodec new! !

!WADocument methodsFor: 'actions' stamp: 'jf 1/23/2009 12:58'!
close
	self close: (root ifNil: [ WARoot new ])! !

!WADocument methodsFor: 'actions' stamp: 'jf 1/23/2009 13:07'!
close: aRoot
	aRoot closeOn: self! !

!WADocument methodsFor: 'initialization' stamp: 'lr 2/20/2009 14:56'!
destroy
	root := stream := codec := nil! !

!WADocument methodsFor: 'initialization' stamp: 'jf 1/23/2009 14:18'!
initializeWithStream: aStream codec: aCodec
	self initialize.
	stream := aStream.
	codec := aCodec! !

!WADocument methodsFor: 'writing' stamp: 'jf 1/23/2009 12:40'!
nextPut: aCharacter
	stream nextPut: aCharacter! !

!WADocument methodsFor: 'writing' stamp: 'jf 1/23/2009 12:40'!
nextPutAll: aString
	stream nextPutAll: aString! !

!WADocument methodsFor: 'actions' stamp: 'jf 1/23/2009 12:53'!
open
	self open: WARoot new! !

!WADocument methodsFor: 'actions' stamp: 'jf 1/23/2009 13:06'!
open: aRoot
	(root := aRoot) openOn: self! !

!WADocument methodsFor: 'writing' stamp: 'jf 1/23/2009 12:21'!
print: anObject
	self subclassResponsibility! !

!WADocument methodsFor: 'accessing' stamp: 'jf 1/23/2009 12:37'!
stream
	^ stream! !

WADocument subclass: #WATagDocument
	instanceVariableNames: 'htmlEncoder urlEncoder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

WATagDocument subclass: #WAHtmlDocument
	instanceVariableNames: 'loadScripts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlDocument commentStamp: 'pmm 6/1/2008 00:19' prior: 0!
A WAHtmlDocument controls how a string is created from a series of brushes.!

!WAHtmlDocument methodsFor: 'load scripts' stamp: 'jf 1/23/2009 00:52'!
addLoadScript: anObject
	loadScripts := loadScripts copyWith: anObject.
	^ anObject! !

!WAHtmlDocument methodsFor: 'load scripts' stamp: 'jf 1/23/2009 00:52'!
addLoadScriptFirst: anObject
	| copy |
	copy := loadScripts species new: loadScripts size + 1.
	copy replaceFrom: 2 to: copy size with: loadScripts.
	copy at: 1 put: anObject.
	loadScripts := copy.
	^ anObject! !

!WAHtmlDocument methodsFor: 'actions' stamp: 'lr 9/8/2009 12:40'!
close: anHtmlRoot
	self writeLoadScripts.
	super close: anHtmlRoot! !

!WAHtmlDocument methodsFor: 'initialization' stamp: 'jf 1/23/2009 23:15'!
initializeWithStream: aStream codec: aCodec
	super initializeWithStream: aStream codec: aCodec.
	loadScripts := Array new.! !

!WAHtmlDocument methodsFor: 'load scripts' stamp: 'jf 1/23/2009 00:13'!
loadScripts
	^ loadScripts! !

!WAHtmlDocument methodsFor: 'load scripts' stamp: 'jf 1/23/2009 23:18'!
wrapLoadScripts: aBlock
	self nextPutAll: '/*<!![CDATA[*/function onLoad(){'.
	aBlock value.
	self nextPutAll: '}/*]]>*/'! !

!WAHtmlDocument methodsFor: 'load scripts' stamp: 'jf 9/30/2009 01:10'!
writeLoadScript: anObject 
	self nextPutAll: anObject greaseString! !

!WAHtmlDocument methodsFor: 'load scripts' stamp: 'jf 1/23/2009 03:24'!
writeLoadScriptSeparator
	self nextPut: $;! !

!WAHtmlDocument methodsFor: 'load scripts' stamp: 'jf 1/30/2009 20:34'!
writeLoadScripts
	| attributes |
	attributes := WAHtmlAttributes new.
	attributes at: 'type' put: 'text/javascript'.
	self openTag: 'script' attributes: attributes.
	self wrapLoadScripts: [
		loadScripts 
			do: [ :each | self writeLoadScript: each ]
			separatedBy: [ self writeLoadScriptSeparator ] ].
	self closeTag: 'script'! !

!WATagDocument methodsFor: 'writing-xhtml' stamp: 'jf 1/23/2009 12:44'!
closeTag: aString
	stream nextPutAll: '</'.
	stream nextPutAll: aString.
	stream nextPut: $>! !

!WATagDocument methodsFor: 'accessing-encoders' stamp: 'jf 1/23/2009 23:10'!
htmlEncoder
	^ htmlEncoder! !

!WATagDocument methodsFor: 'initialization' stamp: 'jf 1/23/2009 23:11'!
initializeWithStream: aStream codec: aCodec
	super initializeWithStream: aStream codec: aCodec.
	htmlEncoder := WAHtmlEncoder on: aStream.
	urlEncoder := WAUrlEncoder on: aStream codec: aCodec! !

!WATagDocument methodsFor: 'writing-tags' stamp: 'jf 1/23/2009 12:26'!
openTag: aString
	self openTag: aString attributes: nil closed: false! !

!WATagDocument methodsFor: 'writing-tags' stamp: 'jf 1/23/2009 12:26'!
openTag: aString attributes: anAttributes
	self openTag: aString attributes: anAttributes closed: false! !

!WATagDocument methodsFor: 'writing-xhtml' stamp: 'jf 1/23/2009 12:44'!
openTag: aString attributes: anAttributes closed: aBoolean
	stream nextPut: $<.
	stream nextPutAll: aString.
	anAttributes encodeOn: self.
	aBoolean ifTrue: [ stream nextPut: $/ ].
	stream nextPut: $>! !

!WATagDocument methodsFor: 'writing' stamp: 'jf 1/23/2009 13:40'!
print: anObject
	anObject encodeOn: self! !

!WATagDocument methodsFor: 'accessing-encoders' stamp: 'jf 1/23/2009 23:10'!
urlEncoder
	^ urlEncoder! !

WATagDocument subclass: #WAUnescapedDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAUnescapedDocument commentStamp: 'pmm 9/20/2009 15:11' prior: 0!
A WAUnescapedDocument is does not do any escaping.!

!WAUnescapedDocument methodsFor: 'initialization' stamp: 'pmm 9/20/2009 15:10'!
initializeWithStream: aStream codec: aCodec
	super initializeWithStream: aStream codec: aCodec.
	htmlEncoder := aStream! !

WATagDocument subclass: #WAXmlDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

WAObject subclass: #WAEmailAddress
	instanceVariableNames: 'username address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAEmailAddress class methodsFor: 'instance creation' stamp: 'pmm 8/31/2008 13:01'!
address: aString
	^self new
		address: aString;
		yourself! !

!WAEmailAddress class methodsFor: 'instance creation' stamp: 'pmm 8/31/2008 13:01'!
address: anAddressString username: aUsernameString
	^self new
		address: anAddressString;
		username: aUsernameString;
		yourself! !

!WAEmailAddress methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:01'!
address
	^address! !

!WAEmailAddress methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:36'!
address: aString
	address := self sanitize: aString! !

!WAEmailAddress methodsFor: 'displaying' stamp: 'pmm 11/30/2008 15:30'!
encodeOn: aDocument
	self encodeOn: aDocument htmlEncoder usingQuotes: false! !

!WAEmailAddress methodsFor: 'private' stamp: 'pmm 9/2/2008 14:14'!
encodeOn: aStream usingQuotes: aBoolean
	username isNil ifFalse:  [
		aBoolean ifTrue: [ aStream nextPut: $" ].
		aStream nextPutAll: username.
		aBoolean ifTrue: [ aStream nextPut: $" ].
		aStream nextPutAll: ' <' ].
	aStream nextPutAll: address.
	username isNil ifFalse: [ aStream nextPut: $> ]! !

!WAEmailAddress methodsFor: 'displaying' stamp: 'jf 9/30/2009 01:10'!
greaseString
	^ String streamContents: 
		[ :stream | 
		self 
			encodeOn: stream
			usingQuotes: true ]! !

!WAEmailAddress methodsFor: 'printing' stamp: 'jf 9/30/2009 01:10'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: self greaseString.
	aStream nextPut: $)! !

!WAEmailAddress methodsFor: 'private' stamp: 'pmm 8/31/2008 13:37'!
sanitize: aString
	"prevents SMTP header injection"
	| newlineIndex |
	newlineIndex := (aString indexOf: Character cr) min: (aString indexOf: Character lf).
	^newlineIndex = 0
		ifTrue: [ aString ]
		ifFalse: [ aString copyFrom: 1 to: newlineIndex - 1  ]! !

!WAEmailAddress methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:01'!
username
	^username! !

!WAEmailAddress methodsFor: 'accessing' stamp: 'pmm 8/31/2008 13:37'!
username: aString
	username := self sanitize: aString! !

WAObject subclass: #WAEncoder
	instanceVariableNames: 'stream table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

WAEncoder class
	instanceVariableNames: 'table'!

!WAEncoder commentStamp: 'jf 1/23/2009 19:50' prior: 0!
I encode everything that is written to myself using #nextPut: and #nextPutAll: onto the wrapped stream. The specific encoding that is done is determined by my subclasses (the conversion of a single character is defined in the class-side method #encode:on:).

To be efficient, each subclass uses a cached encoding table to transform the most used characters from the UTF Basic Multilingual Plane.!

WAEncoder class
	instanceVariableNames: 'table'!

!WAEncoder class methodsFor: 'private' stamp: 'lr 4/8/2007 13:42'!
encode: aCharacter on: aStream
	self subclassResponsibility! !

!WAEncoder class methodsFor: 'initialization' stamp: 'lr 7/16/2009 08:54'!
initializeBMP
	"Initializes the BMP, the Basic Multilingual Plane of UTF characters, using the encoding strategy of the receiver. This chaching strategy ensures that most commonly used characters can be encoded as efficient as possible."

	| stream characterLimit |
	characterLimit := self maximumCharacterValue.
	"counting starts at zero so we need to add 1"
	table := Array new: characterLimit + 1.
	stream := WriteStream on: (String new: 6).
	0 to: characterLimit do: [ :index |
		| encoded |
		self encode: (Character codePoint: index) on: stream reset.
		encoded := stream contents.
		"Smalltalk indices are one based but character values start at 0"
		table at: index + 1 put: (encoded size = 1
			ifTrue: [ encoded first ]
			ifFalse: [ encoded ]) ]! !

!WAEncoder class methodsFor: 'private' stamp: 'lr 7/16/2009 08:53'!
maximumCharacterValue
	"find the maximum value of a character that we can instantiate, for Squeak 3.7 this is 255"
	^[ Character codePoint: 16rFFFF.
		16rFFFF ]
			on: Error
			do: [ :error  | 16rFF ]! !

!WAEncoder class methodsFor: 'instance creation' stamp: 'jf 9/30/2009 00:19'!
new
	^ self on: GRPlatform current readWriteCharacterStream! !

!WAEncoder class methodsFor: 'instance creation' stamp: 'lr 3/26/2007 20:51'!
on: aStream
	^ self on: aStream table: table! !

!WAEncoder class methodsFor: 'instance creation' stamp: 'jf 1/23/2009 19:45'!
on: aStream codec: aCodec
	"For compatibility with WAUrlEncoder"
	^ self on: aStream! !

!WAEncoder class methodsFor: 'instance creation' stamp: 'jf 1/23/2009 19:44'!
on: aStream table: anArray
	^ self basicNew initializeOn: aStream table: anArray; yourself! !

!WAEncoder methodsFor: 'initialization' stamp: 'jf 1/23/2009 19:05'!
initializeOn: aStream table: anArray
	self initialize.
	stream := aStream.
	table := anArray! !

!WAEncoder methodsFor: 'accessing' stamp: 'jf 9/30/2009 01:04'!
nextPut: aCharacter 
	| value encoded |
	value := aCharacter greaseInteger.
	value < table size 
		ifFalse: 
			[ self class 
				encode: aCharacter
				on: stream ]
		ifTrue: 
			[ encoded := table at: value + 1.
			encoded isString 
				ifTrue: [ stream nextPutAll: encoded ]
				ifFalse: [ stream nextPut: encoded ] ]! !

!WAEncoder methodsFor: 'accessing' stamp: 'jf 9/30/2009 01:04'!
nextPutAll: aString 
	"uses #to:do: for speed reasons (on Squeak)
	this is not premature optimization, this is a hotspot method method
	and #to:do: shows measurable speed improvements for rendering seaside pages"
	| character value encoded |
	1 
		to: aString size
		do: 
			[ :index | 
			character := aString at: index.
			value := character greaseInteger.
			value < table size 
				ifFalse: 
					[ self class 
						encode: character
						on: stream ]
				ifTrue: 
					[ encoded := table at: value + 1.
					encoded isString 
						ifTrue: [ stream nextPutAll: encoded ]
						ifFalse: [ stream nextPut: encoded ] ] ]! !

WAEncoder subclass: #WAHtmlEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlEncoder commentStamp: 'lr 4/6/2007 19:45' prior: 0!
I encode XHTML text.!

!WAHtmlEncoder class methodsFor: 'private' stamp: 'lr 4/8/2007 14:05'!
encode: aCharacter on: aStream
	aCharacter = $" ifTrue: [ ^ aStream nextPutAll: '&quot;' ].
	aCharacter = $< ifTrue: [ ^ aStream nextPutAll: '&lt;' ].
	aCharacter = $& ifTrue: [ ^ aStream nextPutAll: '&amp;'].
	aCharacter = $> ifTrue: [ ^ aStream nextPutAll: '&gt;' ].
	aStream nextPut: aCharacter! !

!WAHtmlEncoder class methodsFor: 'initialization' stamp: 'lr 4/8/2007 14:01'!
initialize
	self initializeBMP! !

WAEncoder subclass: #WAUrlEncoder
	instanceVariableNames: 'codec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAUrlEncoder commentStamp: 'jf 1/23/2009 20:47' prior: 0!
I do percent-encoding of parts (e.g. path segments and arguments) of a URI.

Additionally, a Codec is given the chance to encode the characters into bytes before being percent-encoded (see http://tools.ietf.org/html/rfc3986#section-2.5). This allows extended characters to be represented in URIs in, for example, UTF-8.!

!WAUrlEncoder class methodsFor: 'private' stamp: 'jf 9/30/2009 01:04'!
encode: aCharacter on: aStream 
	| printer |
	('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.~' includes: aCharacter) ifTrue: [ ^ aStream nextPut: aCharacter ].
	aStream nextPut: $%.
	printer := GRNumberPrinter new.
	printer
		base: 16;
		padding: $0;
		digits: 2;
		uppercase.
	printer 
		print: aCharacter greaseInteger
		on: aStream! !

!WAUrlEncoder class methodsFor: 'initialization' stamp: 'lr 1/23/2009 22:36'!
initialize
	self initializeBMP ! !

!WAUrlEncoder class methodsFor: 'private' stamp: 'lr 10/12/2008 19:04'!
maximumCharacterValue
	"String to byte encoding has aleady happened in the server."
	
	^ 16rFF! !

!WAUrlEncoder class methodsFor: 'instance creation' stamp: 'jf 1/23/2009 19:46'!
on: aStream codec: aCodec
	^ self on: aStream codec: aCodec table: table! !

!WAUrlEncoder class methodsFor: 'instance creation' stamp: 'jf 1/23/2009 20:08'!
on: aStream codec: aCodec table: anArray
	^ self basicNew initializeOn: aStream table: anArray codec: aCodec; yourself! !

!WAUrlEncoder class methodsFor: 'instance creation' stamp: 'jf 9/30/2009 00:27'!
on: aStream table: anArray 
	^ self 
		on: aStream
		codec: GRNullCodec new
		table: anArray! !

!WAUrlEncoder methodsFor: 'initialization' stamp: 'jf 1/23/2009 19:06'!
initializeOn: aStream table: anArray codec: aCodec
	self initializeOn: aStream table: anArray.
	codec := aCodec! !

!WAUrlEncoder methodsFor: 'accessing' stamp: 'pmm 5/10/2008 22:05'!
nextPut: aCharacter
	self nextPutAll: (String with: aCharacter)! !

!WAUrlEncoder methodsFor: 'accessing' stamp: 'lr 2/7/2009 12:03'!
nextPutAll: aString
	super nextPutAll: (codec url encode: aString)! !

WAObject subclass: #WAExceptionHandler
	instanceVariableNames: 'requestContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandling'!

!WAExceptionHandler commentStamp: 'jf 9/17/2008 20:49' prior: 0!
Exception handlers are invoked when an error in a Seaside application occurs. Request handlers can use the class-side method #handleExceptionsDuring: to set up exception handlers around a block of code.

== Catching ==

Exception handlers can configure which exceptions they want to catch by overriding the class-side method #exceptionsToCatch. They may also choose to override #handleExceptionsDuring: on the class-side directly, if they need more complex behaviour.

== Handling ==

Handling behaviour is implemented on the instance side by implementing #handleException:. This method should return a suitable seaside response (usually an instance of WAResponse) if it returns.

== Internal Errors ==

Internal errors are typically errors that occur while trying to execute one of the other error handlers and should be as basic as possible to ensure they don't have any trouble executing. Request handlers can ask for an internal error response by calling #internalError: on the class-side of an exception handler.

== HTML Responses ==

See WAWalkbackErrorHandler in the development packages for examples of how to do rendering with the canvas API.
!

WAExceptionHandler subclass: #WAErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandling'!

!WAErrorHandler commentStamp: 'jf 9/17/2008 20:50' prior: 0!
WAErrorHandler catches Errors and Warnings and provides two methods for handling each type of exception:

handleError:
handleWarning:

If either method is not implemented, the default implementation will call #handleDefault:, which can be used to provide common behaviour for both exception types.!

!WAErrorHandler class methodsFor: 'exception handling' stamp: 'jf 12/29/2008 17:47'!
exceptionSelector
	^ super exceptionSelector, Error, Warning! !

!WAErrorHandler class methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
handleError: anError 
	self 
		greaseDeprecatedApi: 'WAErrorHandler class>>#handleError:'
		details: 'ExceptionHandlers should be allowed to set up their own exception handling code. See WAExceptionHandler class>>handleExceptionsDuring:.'.
	^ self new handleError: anError! !

!WAErrorHandler class methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
handleWarning: aWarning 
	self 
		greaseDeprecatedApi: 'WAErrorHandler class>>#handleWarning:'
		details: 'ExceptionHandlers should be allowed to set up their own exception handling code. See WAExceptionHandler class>>handleExceptionsDuring:.'.
	^ self new handleWarning: aWarning! !

!WAErrorHandler methodsFor: 'actions' stamp: 'jf 9/17/2008 20:03'!
handleDefault: anException
	"This method provides the default behaviour if subclasses do
	not implement one of the specific handler methods."
	^ self internalError: anException! !

!WAErrorHandler methodsFor: 'actions' stamp: 'jf 9/14/2008 13:03'!
handleError: anError
	^ self handleDefault: anError! !

!WAErrorHandler methodsFor: 'actions' stamp: 'jf 12/30/2008 20:06'!
handleException: anException
	(Error handles: anException)
		ifTrue: [ ^ self handleError: anException ].
	(Warning handles: anException)
		ifTrue: [ ^ self handleWarning: anException ].

	^ super handleException: anException! !

!WAErrorHandler methodsFor: 'actions' stamp: 'jf 9/14/2008 13:03'!
handleWarning: aWarning
	^ self handleDefault: aWarning! !

!WAExceptionHandler class methodsFor: 'ansi-exception-selector' stamp: 'jf 12/29/2008 17:47'!
, anException 
	"Create an exception set that includes all the exceptions we handle and the
	one passed as a parameter."
	^ self exceptionSelector, anException! !

!WAExceptionHandler class methodsFor: 'instance creation' stamp: 'jf 10/19/2008 12:19'!
context: aRequestContext
	^ self basicNew initializeWithContext: aRequestContext; yourself ! !

!WAExceptionHandler class methodsFor: 'exception handling' stamp: 'jf 2/3/2009 15:29'!
exceptionSelector
	^ ExceptionSet new! !

!WAExceptionHandler class methodsFor: 'exception handling' stamp: 'jf 12/30/2008 18:48'!
handleExceptionsDuring: aBlock context: aRequestContext
	^ (self context: aRequestContext) handleExceptionsDuring: aBlock! !

!WAExceptionHandler class methodsFor: 'ansi-exception-selector' stamp: 'jf 12/29/2008 17:46'!
handles: anException 
	"You should probably override #exceptionsToCatch instead of this method.
	If you do need to override this method, make sure to override #, as well"
	^ self exceptionSelector handles: anException! !

!WAExceptionHandler class methodsFor: 'responding' stamp: 'jf 10/19/2008 14:58'!
internalError: anError context: aRequestContext
	^ (self context: aRequestContext) internalError: anError! !

!WAExceptionHandler class methodsFor: 'instance creation' stamp: 'jf 10/19/2008 12:19'!
new
	^ self context: nil! !

!WAExceptionHandler methodsFor: 'ansi-exception-selector' stamp: 'jf 12/29/2008 17:10'!
, anException
	^ self class, anException! !

!WAExceptionHandler methodsFor: 'actions' stamp: 'jf 2/3/2009 15:28'!
handleException: anException
	"If for some reason we are asked to handle an exception for which we have no
	handling behaviour defined, just pass."	
	^ anException pass! !

!WAExceptionHandler methodsFor: 'actions' stamp: 'jf 12/30/2008 18:52'!
handleExceptionsDuring: aBlock
	^ aBlock
		on: self
		do: [ :exception | 
			[ self handleException: exception ]
				"If there's an error while handling the exception, fall
				back on an internal error response."
				on: Error
				do: [ :error | self internalError: error ] ] ! !

!WAExceptionHandler methodsFor: 'ansi-exception-selector' stamp: 'jf 12/29/2008 16:41'!
handles: anException
	^ self class handles: anException! !

!WAExceptionHandler methodsFor: 'initialization' stamp: 'jf 10/19/2008 12:18'!
initializeWithContext: aRequestContext
	self initialize.
	requestContext := aRequestContext! !

!WAExceptionHandler methodsFor: 'actions' stamp: 'lr 2/20/2009 11:07'!
internalError: anError 
	"This method should not call #handleException: because subclasses want to modify the behaviour for for other exceptions without changing the simple fallback internal error behaviour."
	
	self requestContext responseGenerator
		internalError: anError;
		respond! !

!WAExceptionHandler methodsFor: 'accessing' stamp: 'jf 10/19/2008 14:23'!
requestContext
	"Exception handlers are created with a request context because they may
	often be running where WACurrentRequestContext is either undefined or
	unused."
	^ requestContext! !

WAObject subclass: #WAFile
	instanceVariableNames: 'contents contentType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAFile commentStamp: 'pmm 5/31/2008 23:54' prior: 0!
I represent a file that was uploaded by the user via #fileInput.

Instance Variables
	contents:		<ByteArray>
	contentType:	<WAMimeType>
	fileName:		<String>

contents
	- the contents of the file, binary

contentType
	- the content type of the file
	
fileName
	- The name of the file the user agent uploaded. This is locale name on the machine of the client. The instance variable might include the full path on the file system, the accessor will never return the path.!

!WAFile methodsFor: 'accessing' stamp: 'avi 4/28/2004 11:13'!
contentType
	^ contentType! !

!WAFile methodsFor: 'accessing' stamp: 'jf 9/22/2008 12:23'!
contentType: aMimeTypeOrString
	contentType := aMimeTypeOrString seasideMimeType! !

!WAFile methodsFor: 'accessing' stamp: 'mh 5/7/2010 19:27'!
contents
	"Answer a ByteArray"
	^ contents asByteArray ! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:37'!
contents: aByteArray
	contents := aByteArray! !

!WAFile methodsFor: 'accessing' stamp: 'pmm 7/24/2007 22:03'!
fileName
	"compensate for windows explorer behavior"
	^ self isWindowsPath
		ifTrue: [ fileName copyAfterLast: $\ ]
		ifFalse: [ fileName ]! !

!WAFile methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:21'!
fileName: aString
	fileName := aString! !

!WAFile methodsFor: 'private' stamp: 'pmm 7/24/2007 22:02'!
isWindowsPath
	"'#:\*' match: fileName is broken on Squeak for WideString arguments"
	^fileName notEmpty
		and: [ fileName first isLetter
		and: [ fileName size >= 3
		and: [ (fileName copyFrom: 2 to: 3) = ':\' ] ] ]! !

!WAFile methodsFor: 'accessing' stamp: 'pmm 4/18/2008 22:45'!
size
	"the file size in bytes"
	^self contents size! !

WAObject subclass: #WAFileHandlerListing
	instanceVariableNames: 'handler context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Libraries'!

!WAFileHandlerListing class methodsFor: 'instance creation' stamp: 'jf 11/9/2008 17:35'!
on: aFileHandler context: aRequestContext
	^ self basicNew initializeWithFileHandler: aFileHandler context: aRequestContext; yourself! !

!WAFileHandlerListing methodsFor: 'initialization' stamp: 'jf 11/9/2008 17:36'!
initializeWithFileHandler: aFileHandler context: aRequestContext
	self initialize.
	handler := aFileHandler.
	context := aRequestContext! !

!WAFileHandlerListing methodsFor: 'responding' stamp: 'jf 11/9/2008 18:14'!
responseForLibraries
	self subclassResponsibility! !

!WAFileHandlerListing methodsFor: 'responding' stamp: 'jf 11/9/2008 18:14'!
responseForLibrary: aLibrary
	self subclassResponsibility! !

WAFileHandlerListing subclass: #WAForbiddenFileHandlerListing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Libraries'!

!WAForbiddenFileHandlerListing methodsFor: 'responding' stamp: 'lr 2/20/2009 11:05'!
responseForLibraries
	context responseGenerator
		forbidden;
		respond! !

!WAForbiddenFileHandlerListing methodsFor: 'responding' stamp: 'lr 2/20/2009 11:05'!
responseForLibrary: aLibrary 
	context responseGenerator
		forbidden;
		respond! !

WAFileHandlerListing subclass: #WATextFileHandlerListing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Libraries'!

!WATextFileHandlerListing methodsFor: 'responding' stamp: 'lr 5/20/2009 20:15'!
responseForLibraries
	context respond: [ :response |
		response contentType: WAMimeType textPlain.
		handler libraries do: [ :each |
			response stream
				nextPutAll: each name;
				crlf ] ]! !

!WATextFileHandlerListing methodsFor: 'responding' stamp: 'lr 5/20/2009 20:16'!
responseForLibrary: aLibrary
	context respond: [ :response |
		response contentType: WAMimeType textPlain.
		aLibrary fileSelectors do: [ :each |
			response stream
				nextPutAll: (aLibrary asFilename: each);
				crlf ] ]! !

WAObject subclass: #WAFileLibrary
	instanceVariableNames: ''
	classVariableNames: 'MimeTypes'
	poolDictionaries: ''
	category: 'Seaside-Core-Libraries'!

WAFileLibrary class
	instanceVariableNames: 'default'!

!WAFileLibrary commentStamp: 'pmm 8/17/2007 06:58' prior: 0!
What does FileLibrary do
=============================
It allows to serve static files directly from seaside without the need for a standalone server like Apache or to configure Kom. These files can reference each other (say a CSS references an image) and can be distrubuted the same way as normal Smalltalk code (Monticello, SqueakMap, ...).

Each file in a file library is represented by a method. The method name is created from the file name, the dot is removed and the first letter of the suffix in capitalized. This puts certain limitations to the allowed filenames. Eg. 'main.css' becomes #mainCss.

Like Script- and StyleLibraries FileLibraries can be added to an application so that they automatically include themselves in the document root. Implement #selectorsToInclude and return the selectors you whish to be added to the document root.

How to create a FileLibrary
================================
- First create the static files and put them in some directory. From there they can reference the other files in the same directory normally with their filenames.
- Make sure you have a "Files" entry that serves your files. This is a normal entry point type that you can find in your /seaside/config application. If you don't already have one, you can create it if you select "Files" in the type field of the "add entry point" dialog. For the rest of this text we assume you chose "files" as the path.
- Create a subclass of WAFileLibrary, for the rest of this text I assume its name is MyFileLibrary.
- To add the files to your file library there are two ways.
1. Programmatically with MyFileLibrary class >> #addAllFilesIn: / #addFileNamed:. For example MyFileLibrary addAllFilesIn: '/path/to/directory/with/files' or MyFileLibrary addFileNamed: '/path/to/background.png'.
2. Via the web interface. Go to your /seaside/config application and there click configure for your "Files". Click "configure" behind MyFileLibrary. There you can add a file by uploading it (select the file, then click "Add")

Note that a "Files" can consist of several file libraries and can even have tradional script or style libraries.

How to integrate a FileLibrary into your application
=============================================================
Files from a FileLibrary are ingetrated the same way other static files are integrated. They have a constant path that is '/seaside/<Static File Library>/<FileLibrary class name>/<filename>' so for example '/seaside/files/MyFileLibrary/background.png'. These can be conveniently generated by 'MyFileLibrary / #aSelector' where #aSelector is the name of the method representing that file. For example 'MyFileLibrary / #backgroundPng'.

How to get back the files in a FileLibrary
=================================================
The contents of a file library can be written out to disk. Writing out a file library first makes a folder with the name of the file library in the folder of your Smallatlk image. Then a file for each file in the file library is created in this folder. Writing out to disk can happen in three ways
1. MyFileLibrary default deployFiles
2. Via the configuration interface of the file library. On the same page where you can add files to your file library there is also a button 'write to disk' which will write out all the files in this library.
3. Via the configuration interface of your application. In the section where you can add libraries to your application there is a a button 'write to disk' which will write out all the libraries of this application.

Examples:
==========

The following code uses WAFileLibrary to add a CSS file to a page.

updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet 
		url: WAFileLibraryDemo / #mainCss
		
The folllowing code uses WAFileLibrary to display an image.

renderContentOn: html
	html image
		url: WAFileLibraryDemo / #mainJpg!

WAFileLibrary class
	instanceVariableNames: 'default'!

!WAFileLibrary class methodsFor: 'convenience' stamp: 'pmm 2/27/2007 20:35'!
/ aSymbol
	^self urlOf: aSymbol! !

!WAFileLibrary class methodsFor: 'file addition' stamp: 'jf 9/30/2009 00:19'!
addAllFilesIn: aPathString 
	"adds all files in the directory specified by aPathString to the current file library"
	(GRPlatform current filesIn: aPathString) do: [ :each | self addFileAt: each ]! !

!WAFileLibrary class methodsFor: 'file addition' stamp: 'jf 9/30/2009 00:19'!
addFileAt: aPath 
	"adds the file specified by aFilename to the current file library"
	self 
		addFileAt: aPath
		contents: (GRPlatform current 
				contentsOfFile: aPath
				binary: (self isBinaryAt: aPath))! !

!WAFileLibrary class methodsFor: 'private' stamp: 'jf 9/30/2009 00:19'!
addFileAt: aPath contents: aByteArrayOrString 
	self 
		addFileNamed: (GRPlatform current localNameOf: aPath)
		contents: aByteArrayOrString! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 10/5/2006 18:37'!
addFileNamed: aFilename contents: aByteArrayOrString
	| selector |
	selector := self asSelector: aFilename.
	(self isBinary: aFilename)
		ifTrue: [ self compileBinary: aByteArrayOrString selector: selector ]
		ifFalse: [ self compileText: aByteArrayOrString selector: selector ]! !

!WAFileLibrary class methodsFor: 'vw port-squeak' stamp: 'lr 10/28/2007 14:42'!
adjustForVisualWorks
	| newSource oldSource badCode goodCode |
	badCode := 'xxxCache := #(nil).'.
	goodCode := 'xxxCache := #(nil) beMutable.'.
	self selectors do: [:selector |
		oldSource := self sourceCodeAt: selector.
		(oldSource indexOfSubCollection: badCode startingAt: 1) > 0 ifTrue:
			[newSource := oldSource copyReplaceAll: badCode with: goodCode.
			self compile: newSource classified: self methodCategory]]! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 2/23/2008 18:25'!
asSelector: aFilename
	| mainPart extension |
	mainPart := (aFilename copyUpToLast: $.)
		select: [ :each | each isAlphaNumeric ].
	[ mainPart first isDigit ]
		whileTrue: [ mainPart := mainPart allButFirst ].
	extension := (aFilename copyAfterLast: $.) asLowercase capitalized.
	^ (mainPart , extension) asSymbol! !

!WAFileLibrary class methodsFor: 'private' stamp: 'jf 9/30/2009 00:19'!
compileBinary: aByteArrayOrString selector: aSymbol 
	"compiles aByteArrayOrString into a method named aSymbol that returns aByteArrayOrString as a byte array"
	| code |
	code := GRPlatform current 
		asMethodReturningByteArray: aByteArrayOrString
		named: aSymbol.
	GRPlatform current 
		compile: code
		into: self
		classified: self methodCategory! !

!WAFileLibrary class methodsFor: 'private' stamp: 'jf 9/30/2009 01:10'!
compileText: aByteArrayOrString selector: aSymbol 
	"Compiles aByteArrayOrString into a method named aSymbol that returns aByteArrayOrString as a string literal.
	aSymbol
		^ aByteArrayOrString"
	| code |
	code := String streamContents: 
		[ :stream | 
		stream
			nextPutAll: aSymbol;
			nextPut: Character cr.
		stream
			tab;
			nextPutAll: '^ '''.
		aByteArrayOrString greaseString do: 
			[ :each | 
			each = $' ifTrue: [ stream nextPut: $' ].
			stream nextPut: each ].
		stream nextPutAll: '''' ].
	GRPlatform current 
		compile: code
		into: self
		classified: self methodCategory! !

!WAFileLibrary class methodsFor: 'instance creation' stamp: 'lr 1/10/2009 15:22'!
default
	^ default ifNil: [ default := self new ]! !

!WAFileLibrary class methodsFor: 'accessing-defaults' stamp: 'pmm 4/20/2006 20:52'!
defaultMimeType
	^ 'application/octet-stream'! !

!WAFileLibrary class methodsFor: 'accessing-defaults' stamp: 'pmm 9/6/2007 22:27'!
defaultMimeTypes
	^ #(
		'%' 'application/x-trash'
		'323' 'text/h323'
		'abw' 'application/x-abiword'
		'ai' 'application/postscript'
		'aif' 'audio/x-aiff'
		'aifc' 'audio/x-aiff'
		'aiff' 'audio/x-aiff'
		'alc' 'chemical/x-alchemy'
		'art' 'image/x-jg'
		'asc' 'text/plain'
		'asf' 'video/x-ms-asf'
		'asn' 'chemical/x-ncbi-asn1-spec'
		'aso' 'chemical/x-ncbi-asn1-binary'
		'asx' 'video/x-ms-asf'
		'au' 'audio/basic'
		'avi' 'video/x-msvideo'
		'b' 'chemical/x-molconn-Z'
		'bak' 'application/x-trash'
		'bat' 'application/x-msdos-program'
		'bcpio' 'application/x-bcpio'
		'bib' 'text/x-bibtex'
		'bin' 'application/octet-stream'
		'bmp' 'image/x-ms-bmp'
		'book' 'application/x-maker'
		'bsd' 'chemical/x-crossfire'
		'c' 'text/x-csrc'
		'c++' 'text/x-c++src'
		'c3d' 'chemical/x-chem3d'
		'cac' 'chemical/x-cache'
		'cache' 'chemical/x-cache'
		'cascii' 'chemical/x-cactvs-binary'
		'cat' 'application/vnd.ms-pki.seccat'
		'cbin' 'chemical/x-cactvs-binary'
		'cc' 'text/x-c++src'
		'cdf' 'application/x-cdf'
		'cdr' 'image/x-coreldraw'
		'cdt' 'image/x-coreldrawtemplate'
		'cdx' 'chemical/x-cdx'
		'cdy' 'application/vnd.cinderella'
		'cef' 'chemical/x-cxf'
		'cer' 'chemical/x-cerius'
		'chm' 'chemical/x-chemdraw'
		'chrt' 'application/x-kchart'
		'cif' 'chemical/x-cif'
		'class' 'application/java-vm'
		'cls' 'text/x-tex'
		'cmdf' 'chemical/x-cmdf'
		'cml' 'chemical/x-cml'
		'cod' 'application/vnd.rim.cod'
		'com' 'application/x-msdos-program'
		'cpa' 'chemical/x-compass'
		'cpio' 'application/x-cpio'
		'cpp' 'text/x-c++src'
		'cpt' 'image/x-corelphotopaint'
		'crl' 'application/x-pkcs7-crl'
		'crt' 'application/x-x509-ca-cert'
		'csf' 'chemical/x-cache-csf'
		'csh' 'text/x-csh'
		'csm' 'chemical/x-csml'
		'csml' 'chemical/x-csml'
		'css' 'text/css'
		'csv' 'text/comma-separated-values'
		'ctab' 'chemical/x-cactvs-binary'
		'ctx' 'chemical/x-ctx'
		'cu' 'application/cu-seeme'
		'cub' 'chemical/x-gaussian-cube'
		'cxf' 'chemical/x-cxf'
		'cxx' 'text/x-c++src'
		'dat' 'chemical/x-mopac-input'
		'dcr' 'application/x-director'
		'deb' 'application/x-debian-package'
		'dif' 'video/dv'
		'diff' 'text/plain'
		'dir' 'application/x-director'
		'djv' 'image/vnd.djvu'
		'djvu' 'image/vnd.djvu'
		'dl' 'video/dl'
		'dll' 'application/x-msdos-program'
		'dmg' 'application/x-apple-diskimage'
		'dms' 'application/x-dms'
		'doc' 'application/msword'
		'dot' 'application/msword'
		'dv' 'video/dv'
		'dvi' 'application/x-dvi'
		'dx' 'chemical/x-jcamp-dx'
		'dxr' 'application/x-director'
		'emb' 'chemical/x-embl-dl-nucleotide'
		'embl' 'chemical/x-embl-dl-nucleotide'
		'ent' 'chemical/x-pdb'
		'eps' 'application/postscript'
		'etx' 'text/x-setext'
		'exe' 'application/x-msdos-program'
		'ez' 'application/andrew-inset'
		'fb' 'application/x-maker'
		'fbdoc' 'application/x-maker'
		'fch' 'chemical/x-gaussian-checkpoint'
		'fchk' 'chemical/x-gaussian-checkpoint'
		'fig' 'application/x-xfig'
		'flac' 'application/x-flac'
		'fli' 'video/fli'
		'fm' 'application/x-maker'
		'frame' 'application/x-maker'
		'frm' 'application/x-maker'
		'gal' 'chemical/x-gaussian-log'
		'gam' 'chemical/x-gamess-input'
		'gamin' 'chemical/x-gamess-input'
		'gau' 'chemical/x-gaussian-input'
		'gcd' 'text/x-pcs-gcd'
		'gcf' 'application/x-graphing-calculator'
		'gcg' 'chemical/x-gcg8-sequence'
		'gen' 'chemical/x-genbank'
		'gf' 'application/x-tex-gf'
		'gif' 'image/gif'
		'gjc' 'chemical/x-gaussian-input'
		'gjf' 'chemical/x-gaussian-input'
		'gl' 'video/gl'
		'gnumeric' 'application/x-gnumeric'
		'gpt' 'chemical/x-mopac-graph'
		'gsf' 'application/x-font'
		'gsm' 'audio/x-gsm'
		'gtar' 'application/x-gtar'
		'h' 'text/x-chdr'
		'h++' 'text/x-c++hdr'
		'hdf' 'application/x-hdf'
		'hh' 'text/x-c++hdr'
		'hin' 'chemical/x-hin'
		'hpp' 'text/x-c++hdr'
		'hqx' 'application/mac-binhex40'
		'hs' 'text/x-haskell'
		'hta' 'application/hta'
		'htc' 'text/x-component'
		'htm' 'text/html'
		'html' 'text/html'
		'hxx' 'text/x-c++hdr'
		'ica' 'application/x-ica'
		'ice' 'x-conference/x-cooltalk'
		'ico' 'image/x-icon'
		'ics' 'text/calendar'
		'icz' 'text/calendar'
		'ief' 'image/ief'
		'iges' 'model/iges'
		'igs' 'model/iges'
		'iii' 'application/x-iphone'
		'inp' 'chemical/x-gamess-input'
		'ins' 'application/x-internet-signup'
		'iso' 'application/x-iso9660-image'
		'isp' 'application/x-internet-signup'
		'ist' 'chemical/x-isostar'
		'istr' 'chemical/x-isostar'
		'jad' 'text/vnd.sun.j2me.app-descriptor'
		'jar' 'application/java-archive'
		'java' 'text/x-java'
		'jdx' 'chemical/x-jcamp-dx'
		'jmz' 'application/x-jmol'
		'jng' 'image/x-jng'
		'jnlp' 'application/x-java-jnlp-file'
		'jpe' 'image/jpeg'
		'jpeg' 'image/jpeg'
		'jpg' 'image/jpeg'
		'js' 'application/x-javascript'
		'kar' 'audio/midi'
		'key' 'application/pgp-keys'
		'kil' 'application/x-killustrator'
		'kin' 'chemical/x-kinemage'
		'kpr' 'application/x-kpresenter'
		'kpt' 'application/x-kpresenter'
		'ksp' 'application/x-kspread'
		'kwd' 'application/x-kword'
		'kwt' 'application/x-kword'
		'latex' 'application/x-latex'
		'lha' 'application/x-lha'
		'lhs' 'text/x-literate-haskell'
		'lsf' 'video/x-la-asf'
		'lsx' 'video/x-la-asf'
		'ltx' 'text/x-tex'
		'lzh' 'application/x-lzh'
		'lzx' 'application/x-lzx'
		'm3u' 'audio/x-mpegurl'
		'm4a' 'audio/mpeg'
		'maker' 'application/x-maker'
		'man' 'application/x-troff-man'
		'mcif' 'chemical/x-mmcif'
		'mcm' 'chemical/x-macmolecule'
		'mdb' 'application/msaccess'
		'me' 'application/x-troff-me'
		'mesh' 'model/mesh'
		'mid' 'audio/midi'
		'midi' 'audio/midi'
		'mif' 'application/x-mif'
		'mm' 'application/x-freemind'
		'mmd' 'chemical/x-macromodel-input'
		'mmf' 'application/vnd.smaf'
		'mml' 'text/mathml'
		'mmod' 'chemical/x-macromodel-input'
		'mng' 'video/x-mng'
		'moc' 'text/x-moc'
		'mol' 'chemical/x-mdl-molfile'
		'mol2' 'chemical/x-mol2'
		'moo' 'chemical/x-mopac-out'
		'mop' 'chemical/x-mopac-input'
		'mopcrt' 'chemical/x-mopac-input'
		'mov' 'video/quicktime'
		'movie' 'video/x-sgi-movie'
		'mp2' 'audio/mpeg'
		'mp3' 'audio/mpeg'
		'mp4' 'video/mp4'
		'mpc' 'chemical/x-mopac-input'
		'mpe' 'video/mpeg'
		'mpeg' 'video/mpeg'
		'mpega' 'audio/mpeg'
		'mpg' 'video/mpeg'
		'mpga' 'audio/mpeg'
		'ms' 'application/x-troff-ms'
		'msh' 'model/mesh'
		'msi' 'application/x-msi'
		'mvb' 'chemical/x-mopac-vib'
		'mxu' 'video/vnd.mpegurl'
		'nb' 'application/mathematica'
		'nc' 'application/x-netcdf'
		'nwc' 'application/x-nwc'
		'o' 'application/x-object'
		'oda' 'application/oda'
		'odb' 'application/vnd.oasis.opendocument.database'
		'odc' 'application/vnd.oasis.opendocument.chart'
		'odf' 'application/vnd.oasis.opendocument.formula'
		'odg' 'application/vnd.oasis.opendocument.graphics'
		'odi' 'application/vnd.oasis.opendocument.image'
		'odm' 'application/vnd.oasis.opendocument.text-master'
		'odp' 'application/vnd.oasis.opendocument.presentation'
		'ods' 'application/vnd.oasis.opendocument.spreadsheet'
		'odt' 'application/vnd.oasis.opendocument.text'
		'ogg' 'application/ogg'
		'old' 'application/x-trash'
		'oth' 'application/vnd.oasis.opendocument.text-web'
		'oza' 'application/x-oz-application'
		'p' 'text/x-pascal'
		'p7r' 'application/x-pkcs7-certreqresp'
		'pac' 'application/x-ns-proxy-autoconfig'
		'pas' 'text/x-pascal'
		'pat' 'image/x-coreldrawpattern'
		'pbm' 'image/x-portable-bitmap'
		'pcf' 'application/x-font'
		'pcf.Z' 'application/x-font'
		'pcx' 'image/pcx'
		'pdb' 'chemical/x-pdb'
		'pdf' 'application/pdf'
		'pfa' 'application/x-font'
		'pfb' 'application/x-font'
		'pgm' 'image/x-portable-graymap'
		'pgn' 'application/x-chess-pgn'
		'pgp' 'application/pgp-signature'
		'pk' 'application/x-tex-pk'
		'pl' 'text/x-perl'
		'pls' 'audio/x-scpls'
		'pm' 'text/x-perl'
		'png' 'image/png'
		'pnm' 'image/x-portable-anymap'
		'pot' 'text/plain'
		'ppm' 'image/x-portable-pixmap'
		'pps' 'application/vnd.ms-powerpoint'
		'ppt' 'application/vnd.ms-powerpoint'
		'prf' 'application/pics-rules'
		'prt' 'chemical/x-ncbi-asn1-ascii'
		'ps' 'application/postscript'
		'psd' 'image/x-photoshop'
		'psp' 'text/x-psp'
		'py' 'text/x-python'
		'pyc' 'application/x-python-code'
		'pyo' 'application/x-python-code'
		'qt' 'video/quicktime'
		'qtl' 'application/x-quicktimeplayer'
		'ra' 'audio/x-realaudio'
		'ram' 'audio/x-pn-realaudio'
		'rar' 'application/rar'
		'ras' 'image/x-cmu-raster'
		'rd' 'chemical/x-mdl-rdfile'
		'rdf' 'application/rdf+xml'
		'rgb' 'image/x-rgb'
		'rm' 'audio/x-pn-realaudio'
		'roff' 'application/x-troff'
		'ros' 'chemical/x-rosdal'
		'rpm' 'application/x-redhat-package-manager'
		'rss' 'application/rss+xml'
		'rtf' 'text/rtf'
		'rtx' 'text/richtext'
		'rxn' 'chemical/x-mdl-rxnfile'
		'sct' 'text/scriptlet'
		'sd' 'chemical/x-mdl-sdfile'
		'sd2' 'audio/x-sd2'
		'sda' 'application/vnd.stardivision.draw'
		'sdc' 'application/vnd.stardivision.calc'
		'sdd' 'application/vnd.stardivision.impress'
		'sdf' 'chemical/x-mdl-sdfile'
		'sdp' 'application/vnd.stardivision.impress'
		'sdw' 'application/vnd.stardivision.writer'
		'ser' 'application/java-serialized-object'
		'sgf' 'application/x-go-sgf'
		'sgl' 'application/vnd.stardivision.writer-global'
		'sh' 'text/x-sh'
		'shar' 'application/x-shar'
		'shtml' 'text/html'
		'sid' 'audio/prs.sid'
		'sik' 'application/x-trash'
		'silo' 'model/mesh'
		'sis' 'application/vnd.symbian.install'
		'sit' 'application/x-stuffit'
		'skd' 'application/x-koan'
		'skm' 'application/x-koan'
		'skp' 'application/x-koan'
		'skt' 'application/x-koan'
		'smf' 'application/vnd.stardivision.math'
		'smi' 'application/smil'
		'smil' 'application/smil'
		'snd' 'audio/basic'
		'spc' 'chemical/x-galactic-spc'
		'spl' 'application/x-futuresplash'
		'src' 'application/x-wais-source'
		'stc' 'application/vnd.sun.xml.calc.template'
		'std' 'application/vnd.sun.xml.draw.template'
		'sti' 'application/vnd.sun.xml.impress.template'
		'stl' 'application/vnd.ms-pki.stl'
		'stw' 'application/vnd.sun.xml.writer.template'
		'sty' 'text/x-tex'
		'sv4cpio' 'application/x-sv4cpio'
		'sv4crc' 'application/x-sv4crc'
		'svg' 'image/svg+xml'
		'svgz' 'image/svg+xml'
		'sw' 'chemical/x-swissprot'
		'swf' 'application/x-shockwave-flash'
		'swfl' 'application/x-shockwave-flash'
		'sxc' 'application/vnd.sun.xml.calc'
		'sxd' 'application/vnd.sun.xml.draw'
		'sxg' 'application/vnd.sun.xml.writer.global'
		'sxi' 'application/vnd.sun.xml.impress'
		'sxm' 'application/vnd.sun.xml.math'
		'sxw' 'application/vnd.sun.xml.writer'
		't' 'application/x-troff'
		'tar' 'application/x-tar'
		'taz' 'application/x-gtar'
		'tcl' 'text/x-tcl'
		'tex' 'text/x-tex'
		'texi' 'application/x-texinfo'
		'texinfo' 'application/x-texinfo'
		'text' 'text/plain'
		'tgf' 'chemical/x-mdl-tgf'
		'tgz' 'application/x-gtar'
		'tif' 'image/tiff'
		'tiff' 'image/tiff'
		'tk' 'text/x-tcl'
		'tm' 'text/texmacs'
		'torrent' 'application/x-bittorrent'
		'tr' 'application/x-troff'
		'ts' 'text/texmacs'
		'tsp' 'application/dsptype'
		'tsv' 'text/tab-separated-values'
		'txt' 'text/plain'
		'udeb' 'application/x-debian-package'
		'uls' 'text/iuls'
		'ustar' 'application/x-ustar'
		'val' 'chemical/x-ncbi-asn1-binary'
		'vcd' 'application/x-cdlink'
		'vcf' 'text/x-vcard'
		'vcs' 'text/x-vcalendar'
		'vmd' 'chemical/x-vmd'
		'vms' 'chemical/x-vamas-iso14976'
		'vor' 'application/vnd.stardivision.writer'
		'vrm' 'x-world/x-vrml'
		'vrml' 'x-world/x-vrml'
		'vsd' 'application/vnd.visio'
		'wad' 'application/x-doom'
		'wav' 'audio/x-wav'
		'wax' 'audio/x-ms-wax'
		'wbmp' 'image/vnd.wap.wbmp'
		'wbxml' 'application/vnd.wap.wbxml'
		'wk' 'application/x-123'
		'wm' 'video/x-ms-wm'
		'wma' 'audio/x-ms-wma'
		'wmd' 'application/x-ms-wmd'
		'wml' 'text/vnd.wap.wml'
		'wmlc' 'application/vnd.wap.wmlc'
		'wmls' 'text/vnd.wap.wmlscript'
		'wmlsc' 'application/vnd.wap.wmlscriptc'
		'wmv' 'video/x-ms-wmv'
		'wmx' 'video/x-ms-wmx'
		'wmz' 'application/x-ms-wmz'
		'wp5' 'application/wordperfect5.1'
		'wpd' 'application/wordperfect'
		'wrl' 'x-world/x-vrml'
		'wsc' 'text/scriptlet'
		'wvx' 'video/x-ms-wvx'
		'wz' 'application/x-wingz'
		'xbm' 'image/x-xbitmap'
		'xcf' 'application/x-xcf'
		'xht' 'application/xhtml+xml'
		'xhtml' 'application/xhtml+xml'
		'xlb' 'application/vnd.ms-excel'
		'xls' 'application/vnd.ms-excel'
		'xlt' 'application/vnd.ms-excel'
		'xml' 'application/xml'
		'xpi' 'application/x-xpinstall'
		'xpm' 'image/x-xpixmap'
		'xsl' 'application/xml'
		'xtel' 'chemical/x-xtel'
		'xul' 'application/vnd.mozilla.xul+xml'
		'xwd' 'image/x-xwindowdump'
		'xyz' 'chemical/x-xyz'
		'zip' 'application/zip'
		'zmt' 'chemical/x-mopac-input'
		'~' 'application/x-trash'

	)! !

!WAFileLibrary class methodsFor: 'actions' stamp: 'lr 1/10/2009 15:22'!
deployFiles
	^self default deployFiles! !

!WAFileLibrary class methodsFor: 'accessing' stamp: 'lr 1/12/2009 20:24'!
documentAt: aFilename forContext: aRequestContext
	^ self default documentAt: aFilename forContext: aRequestContext! !

!WAFileLibrary class methodsFor: 'testing' stamp: 'lr 1/10/2009 15:22'!
handlesFolder: aSymbol
	^self name = aSymbol! !

!WAFileLibrary class methodsFor: 'class initialization' stamp: 'pmm 9/6/2007 22:28'!
initialize
	MimeTypes := Dictionary new.
	1 to: self defaultMimeTypes size by: 2 do: [ :index |
		MimeTypes
			at: (self defaultMimeTypes at: index)
			put: (self defaultMimeTypes at: index + 1) ]! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 1/4/2008 15:04'!
isBinary: aFilename
	^(self mimetypeFor: (aFilename copyAfterLast: $.)) isBinary! !

!WAFileLibrary class methodsFor: 'private' stamp: 'jf 9/30/2009 00:19'!
isBinaryAt: aPath 
	^ self isBinary: (GRPlatform current localNameOf: aPath)! !

!WAFileLibrary class methodsFor: 'private' stamp: 'pmm 4/7/2007 00:58'!
methodCategory
	"the method category for uploaded files"
	^#uploaded! !

!WAFileLibrary class methodsFor: 'migrating' stamp: 'pmm 2/21/2009 10:43'!
migrateSubclassesSeaside29
	"migrates all subclasses of the receiver to Seaside 2.9
	you should not send this message to WAFileLibrary because that will also migrate the classes in Seaside"
	self allSubclassesDo: [ :each |
		each migrateToSeaside29 ]! !

!WAFileLibrary class methodsFor: 'migrating' stamp: 'pmm 2/20/2009 21:17'!
migrateToSeaside29
	"migrates only the receiver to Seaside 2.9"
	(self default fileSelectors intersection: self selectors) do: [ :each |
		| contents |
		contents := (self default perform: each).
		(contents isKindOf: ByteArray) ifTrue: [
			| file |
			file := WAFile new
				contents: contents;
				fileName: (self default asFilename: each);
				yourself.
			self default addFile: file ] ]! !

!WAFileLibrary class methodsFor: 'accessing' stamp: 'jf 9/22/2008 12:23'!
mimetypeFor: aString
	^ (self mimetypes at: aString ifAbsent: [ self defaultMimeType ]) seasideMimeType! !

!WAFileLibrary class methodsFor: 'accessing' stamp: 'pmm 4/20/2006 20:51'!
mimetypes
	^ MimeTypes! !

!WAFileLibrary class methodsFor: 'convenience' stamp: 'pmm 2/13/2007 18:03'!
register
	"no longer needed left in so that code can still be loaded since it is sent in class side initialize methods"! !

!WAFileLibrary class methodsFor: 'convenience' stamp: 'pmm 2/16/2007 16:01'!
unregister
	"no longer used"! !

!WAFileLibrary class methodsFor: 'convenience' stamp: 'jf 8/30/2008 19:33'!
urlOf: aSymbol
	^self default urlOf: aSymbol! !

!WAFileLibrary methodsFor: 'actions' stamp: 'jf 9/30/2009 00:19'!
addFile: aFile 
	"adds a file to the receiver

	aFile an instance of of WAFile"
	| contents |
	aFile isNil ifTrue: [ ^ self	"in case no file was selected for uploading" ].
	contents := (self class isBinary: aFile fileName) 
		ifTrue: [ aFile contents ]
		ifFalse: [ GRPlatform current convertToSmalltalkNewlines: aFile contents ].
	self class 
		addFileNamed: aFile fileName
		contents: contents! !

!WAFileLibrary methodsFor: 'private' stamp: 'jf 9/30/2009 01:10'!
asFilename: aSelector 
	| dotIndex extension |
	dotIndex := self lastUpperCaseIndexIn: aSelector.
	dotIndex = 0 ifTrue: 
		[ "convert Symbol to String"
		^ aSelector greaseString ].
	extension := (aSelector last: aSelector size - dotIndex + 1) asLowercase.
	^ (aSelector first: dotIndex - 1) , '.' , extension! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
asSelector: aFilename
	^ self class asSelector: aFilename! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'lr 1/10/2009 15:21'!
cacheDuration
	"ansers the duration the response should be cached by the user agent"
	^Duration days: 0 hours: 0 minutes: 30 seconds: 0! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
compileBinary: aString selector: aSymbol
	^self class compileBinary: aString selector: aSymbol! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 10/28/2007 14:42'!
compileText: aString selector: aSymbol
	self class compileText: aString selector: aSymbol! !

!WAFileLibrary methodsFor: 'actions' stamp: 'jf 9/30/2009 00:19'!
deployFiles
	"Write to disk the files that the receiver use to serve as methods.
	The files are stored in a subfolder named like the classname of the receiver in a subfolder of Smalltalk image folder."
	GRPlatform current ensureExistenceOfFolder: self name.
	self fileSelectors do: 
		[ :each | 
		GRPlatform current 
			write: (self perform: each)
			toFile: (self asFilename: each)
			inFolder: self name ]! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'lr 5/20/2009 20:12'!
documentAt: aFilename forContext: aRequestContext
	| selector |
	selector := self asSelector: aFilename.
	(self fileSelectors includes: selector) 
		ifFalse: [ ^ self ].
	aRequestContext respond: [ :response |
		response
			cacheFor: self cacheDuration;
			document: (self documentForFile: aFilename)
			mimeType: (self mimetypeForFile: aFilename) ]! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'lr 1/10/2009 15:21'!
documentForFile: aFilename
	^self perform: (self asSelector: aFilename)! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 1/10/2009 15:25'!
fileSelectors
	| selectors current |
	selectors := Set new.
	current := self class.
	[ WAFileLibrary = current ] whileFalse: [
		selectors addAll: (current selectors
			select: [ :each | self isFileSelector: each ]).
		current := current superclass ].
	^ selectors! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'lr 1/10/2009 15:21'!
filenames
	^ self fileSelectors collect: [ :each | self asFilename: each ]! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 2/21/2009 16:03'!
isFileSelector: aSymbol
	"added condition to prevent overrides of methods defined in this class being picked up"
	^ aSymbol isUnary
		and: [ (self lastUpperCaseIndexIn: aSymbol) > 1
		and: [ (self nonFileSelectors includes: aSymbol) not ] ]! !

!WAFileLibrary methodsFor: 'private' stamp: 'lr 2/18/2007 12:28'!
lastUpperCaseIndexIn: aString
	^ aString findLast: [ :each | each isUppercase ]! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'mb 2/23/2007 10:18'!
mimetypeForFile: aFilename
	^self class mimetypeFor: (aFilename copyAfterLast: $.)! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'lr 1/10/2009 15:21'!
name
	^ self class name! !

!WAFileLibrary methodsFor: 'private' stamp: 'pmm 2/21/2009 16:03'!
nonFileSelectors
	"Answers all the unary selectors with an upper clase latter that are not file selector.s
	This method is intended to be overriden by superclasses that add functionality. Don't forget to add the result of the super send."
	^ #(cacheDuration fileSelectors deployFiles configurationComponent selectorsToInclude nonFileSelectors)! !

!WAFileLibrary methodsFor: 'actions' stamp: 'jf 9/30/2009 00:19'!
removeFile: aFilename 
	GRPlatform current 
		removeSelector: (self asSelector: aFilename)
		from: self class! !

!WAFileLibrary methodsFor: 'actions' stamp: 'lr 10/28/2007 14:42'!
renameFile: oldName to: newName
	| contents file |
	(self asSelector: oldName) = (self asSelector: newName)
		ifTrue: [ ^ nil ].
	contents := self perform: (self asSelector: oldName).
	file := WAFile new contents: contents.
	file fileName: newName.
	self addFile: file.
	self removeFile: oldName! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
selectorsToInclude
	"The files represented by the selectors this method returns will be automatically added to the html <head> if the receiver is added to the respective Seaside application.

	This makes only sense for CSS and JS files"
	^ #()! !

!WAFileLibrary methodsFor: 'processing' stamp: 'lr 9/8/2009 12:40'!
updateRoot: anHtmlRoot
	"Only override if you want to automatically include new types of resources. The default implementation knows how to reference CSS, JS and FavIcons into anHtmlRoot."

	self selectorsToInclude do: [ :each |
		(each endsWith: #Js)
			ifTrue: [ anHtmlRoot javascript url: (self urlOf: each) ].
		(each endsWith: #Ico)
			ifTrue: [ anHtmlRoot link beShortcutIcon; url: (self urlOf: each) ].
		(each endsWith: #Css)
			ifTrue: [ anHtmlRoot stylesheet url: (self urlOf: each) ] ]! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'lr 1/10/2009 15:21'!
urlForFile: aFilename
	^ self urlOf: (self asSelector: aFilename)! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'lr 1/10/2009 15:21'!
urlOf: aSymbol
	^ self urlOf: aSymbol using: WAFileHandler default! !

!WAFileLibrary methodsFor: 'accessing' stamp: 'lr 1/10/2009 15:21'!
urlOf: aSymbol using: aHandler
	^ aHandler baseUrl
		addToPath: self className;
		addToPath: (self asFilename: aSymbol);
		yourself! !

WAObject subclass: #WAHtmlElement
	instanceVariableNames: 'root attributes children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAHtmlElement commentStamp: 'pmm 1/28/2008 07:08' prior: 0!
Root class of all elements inside a <head> section.!

WAHtmlElement subclass: #WABaseElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WABaseElement commentStamp: 'pmm 1/28/2008 07:05' prior: 0!
In HTML, links and references to external images, applets, form-processing programs, style sheets, etc. are always specified by a URI. Relative URIs are resolved according to a base URI, which may come from a variety of sources. The BASE element allows authors to specify a document's base URI explicitly.

When present, the BASE element must appear in the HEAD section of an HTML document, before any element that refers to an external source. The path information specified by the BASE element only affects URIs in the document where the element appears.

For example, given the following BASE declaration and A declaration:
updateRoot: html
	super updateRoot: html.
	html base url: 'http://www.aviary.com/products/intro.html'

renderContentOn: html
	html anchor
		url: '../cages/birds.gif';
		with: 'Bird Cages'

the relative URI "../cages/birds.gif" would resolve to:
http://www.aviary.com/cages/birds.gif!

!WABaseElement methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:26'!
tag
	^ 'base'! !

!WABaseElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:43'!
target: aString
	self attributeAt: 'target' put: aString! !

!WABaseElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:43'!
url: aString
	self attributeAt: 'href' put: aString! !

WAHtmlElement subclass: #WAContentElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAContentElement commentStamp: 'pmm 1/28/2008 07:01' prior: 0!
Common superclass of all elements inside a <head> that can have content. Either between the start and end tag or a (mime) document pointed to by an URL.!

!WAContentElement methodsFor: 'attributes' stamp: 'lr 10/20/2008 00:02'!
charset: aString
	self attributeAt: 'charset' put: aString! !

!WAContentElement methodsFor: 'attributes' stamp: 'lr 3/27/2007 13:33'!
contents: aString
	self document: aString! !

!WAContentElement methodsFor: 'document' stamp: 'lr 3/27/2007 13:32'!
document: aString
	self document: aString mimeType: self typeOrNil! !

!WAContentElement methodsFor: 'document' stamp: 'lr 3/27/2007 13:32'!
document: aString fileName: fileName
	self document: aString mimeType: self typeOrNil fileName: fileName! !

!WAContentElement methodsFor: 'document' stamp: 'lr 3/27/2007 13:32'!
document: aString mimeType: mimeType
	self document: aString mimeType: mimeType fileName: nil! !

!WAContentElement methodsFor: 'document' stamp: 'lr 3/27/2007 13:33'!
document: aString mimeType: mimeType fileName: fileName
	self url: (root context urlForDocument: aString mimeType: mimeType fileName: fileName)! !

!WAContentElement methodsFor: 'printing' stamp: 'jf 9/30/2009 01:10'!
encodeChildrenOn: aDocument 
	children isEmptyOrNil ifTrue: [ ^ self ].
	aDocument nextPutAll: '/*<!![CDATA[*/'.
	children do: [ :each | aDocument nextPutAll: each greaseString ].
	aDocument nextPutAll: '/*]]>*/'! !

!WAContentElement methodsFor: 'testing' stamp: 'lr 11/5/2007 17:20'!
isClosed
	^ false! !

!WAContentElement methodsFor: 'attributes' stamp: 'jf 2/21/2009 18:30'!
resourceUrl: aString
	self url: (root absoluteUrlForResource: aString)! !

!WAContentElement methodsFor: 'attributes' stamp: 'pmm 11/21/2007 20:48'!
type: aMimeTypeOrString
	self attributeAt: 'type' put: aMimeTypeOrString! !

!WAContentElement methodsFor: 'private' stamp: 'lr 3/27/2007 10:51'!
typeOrNil
	^ self attributeAt: 'type' ifAbsent:  [ nil ]! !

!WAContentElement methodsFor: 'attributes' stamp: 'lr 10/28/2007 14:42'!
url: aString
	self subclassResponsibility! !

WAContentElement subclass: #WALinkElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WALinkElement commentStamp: 'pmm 1/29/2008 22:04' prior: 0!
Defines either a link or style sheet rules. If it has children then it defines style sheet rules, else it defines a link.

= if link =
This element defines a link. Unlike A, it may only appear in the HEAD section of a document, although it may appear any number of times. Although LINK has no content, it conveys relationship information that may be rendered by user agents in a variety of ways (e.g., a tool-bar with a drop-down menu of links).

= style sheet rules =
The STYLE element allows authors to put style sheet rules in the head of the document. HTML permits any number of STYLE elements in the HEAD section of a document.

User agents that don't support style sheets, or don't support the specific style sheet language used by a STYLE element, must hide the contents of the STYLE element. It is an error to render the content as part of the document's text. Some style sheet languages support syntax for hiding the content from non-conforming user agents.!

!WALinkElement methodsFor: 'accessing-children' stamp: 'pmm 1/29/2008 22:00'!
add: anElement
	super add: anElement.
	attributes isNil ifFalse: [
		attributes removeKey: 'rel' ifAbsent: [ "ignore" ] ]! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addAll
	self addMedia: 'all'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addAural
	self addMedia: 'aural'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addBraille
	self addMedia: 'braille'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addHandheld
	self addMedia: 'handheld'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 3/9/2008 11:19'!
addMedia: aString
	self attributes addMedia: aString! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:36'!
addPrint
	self addMedia: 'print'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addProjection
	self addMedia: 'projection'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addScreen
	self addMedia: 'screen'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addTeletype
	self addMedia: 'tty'! !

!WALinkElement methodsFor: 'media' stamp: 'pmm 10/7/2006 17:35'!
addTelevision
	self addMedia: 'tv'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:54'!
beAlternate
	"Gives alternate representations of the current document."
	self relationship: 'alternate'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:14'!
beAlternateStylesheet
	self relationship: 'alternate stylesheet'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beAppendix
	self relationship: 'appendix'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:56'!
beArchives
	"Provides a link to a collection of records, documents, or other materials of historical interest."
	self relationship: 'archives'! !

!WALinkElement methodsFor: 'type' stamp: 'jf 9/22/2008 12:21'!
beAtom
	self type: 'application/atom+xml' seasideMimeType! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beBookmark
	self relationship: 'bookmark'! !

!WALinkElement methodsFor: 'relationship' stamp: 'lr 2/14/2009 20:05'!
beCanonical
	"Used to specify a canonical URL."

	self relationship: 'canonical'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beChapter
	self relationship: 'chapter'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beClossary
	self relationship: 'lossary'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beCopyright
	self relationship: 'copyright'! !

!WALinkElement methodsFor: 'type' stamp: 'jf 9/22/2008 13:14'!
beCss
	self type: WAMimeType textCss! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:05'!
beFirst
	"Indicates that the current document is a part of a series, and that the first document in the series is the referenced document."
	self relationship: 'first'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:17'!
beFontDefinition
	self relationship: 'fontdef'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:57'!
beGlossary
	self relationship: 'glossary'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beHelp
	self relationship: 'help'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:10'!
beIndex
	self relationship: 'index'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:18'!
beLast
	self relationship: 'last'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:58'!
beMicrosummary
	"http://wiki.mozilla.org/Microsummaries"
	self relationship: 'microsummary'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:04'!
beNext
	"Indicates that the current document is a part of a series, and that the next document in the series is the referenced document."
	self relationship: 'next'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:04'!
bePrevious
	"Indicates that the current document is a part of a series, and that the previous document in the series is the referenced document."
	self relationship: 'previous'! !

!WALinkElement methodsFor: 'type' stamp: 'jf 9/22/2008 12:21'!
beRss
	self type: 'application/rss+xml' seasideMimeType! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:04'!
beSearch
	"Gives a link to a resource that can be used to search through the current document and its related pages. "
	self relationship: 'search'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:11'!
beSection
	self relationship: 'section'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:16'!
beShortcutIcon
	self relationship: 'shortcut icon'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 01:03'!
beStart
	"Refers to the first document in a collection of documents. This link type tells search engines which document is considered by the author to be the starting point of the collection."
	self relationship: 'start'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:58'!
beStylesheet
	"Imports a stylesheet."
	self relationship: 'stylesheet'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:12'!
beSubsection
	self relationship: 'subsection'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:10'!
beTableOfContents
	self relationship: 'contents'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 10/7/2006 17:18'!
beTop
	self relationship: 'top'! !

!WALinkElement methodsFor: 'relationship' stamp: 'pmm 3/31/2007 00:58'!
beUp
	"Provides a link to a document giving the context for the current document."
	self relationship: 'up'! !

!WALinkElement methodsFor: 'testing' stamp: 'lr 11/5/2007 17:20'!
isClosed
	^ children isEmptyOrNil! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 3/31/2007 01:02'!
media: aString
	"This attribute specifies the intended destination medium for style information. It may be a single media descriptor or a comma-separated list. The default value for this attribute is 'screen'."
	self attributeAt: 'media' put: aString! !

!WALinkElement methodsFor: 'attributes' stamp: 'lr 12/28/2008 11:01'!
relationship: aString
	"This attribute describes the relationship from the current document to the anchor specified by the href attribute. The value of this attribute is a space-separated list of link types."
	
	self attributes at: 'rel' append: aString! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 3/31/2007 01:00'!
reverse: aString
	"This attribute is used to describe a reverse link from the anchor specified by the href attribute to the current document. The value of this attribute is a space-separated list of link types."
	self attributeAt: 'rev' put: aString! !

!WALinkElement methodsFor: 'accessing' stamp: 'pmm 1/29/2008 21:57'!
tag
	^ children isEmptyOrNil
		ifTrue: [ 'link' ]
		ifFalse: [ 'style' ]! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 17:09'!
title: aString
	self attributeAt: 'title' put: aString! !

!WALinkElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:10'!
url: aString
	self attributeAt: 'href' put: aString! !

WAContentElement subclass: #WAScriptElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAScriptElement commentStamp: 'pmm 1/28/2008 06:46' prior: 0!
The SCRIPT element places a script within a document. This element may appear any number of times in the HEAD of an HTML document.

The script may be defined within the contents of the SCRIPT element or in an external file. If the src attribute is not set, user agents must interpret the contents of the element as the script. If the src has a URI value, user agents must ignore the element's contents and retrieve the script via the URI. Note that the charset attribute refers to the character encoding of the script designated by the src attribute; it does not concern the content of the SCRIPT element.!

!WAScriptElement methodsFor: 'types' stamp: 'jf 9/22/2008 13:02'!
beJavascript
	self type: WAMimeType textJavascript! !

!WAScriptElement methodsFor: 'attributes' stamp: 'pmm 9/22/2007 07:36'!
defer
	"When set, this boolean attribute provides a hint to the user agent that the script is not going to generate any document content (e.g., no 'document.write' in javascript) and thus, the user agent can continue parsing and rendering."
		self attributeAt: 'defer' put: true! !

!WAScriptElement methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:27'!
tag
	^ 'script'! !

!WAScriptElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:10'!
url: aString
	self attributeAt: 'src' put: aString! !

!WAHtmlElement class methodsFor: 'instance creation' stamp: 'jf 3/13/2009 18:13'!
root: aRoot
	^ self basicNew initializeWithRoot: aRoot; yourself! !

!WAHtmlElement methodsFor: 'accessing-children' stamp: 'lr 3/27/2007 10:47'!
add: anElement
	children ifNil: [ children := OrderedCollection new ].
	children add: anElement! !

!WAHtmlElement methodsFor: 'accessing-attributes' stamp: 'lr 3/21/2007 15:59'!
attributeAt: aString
	^ self attributes at: aString! !

!WAHtmlElement methodsFor: 'accessing-attributes' stamp: 'lr 3/21/2007 15:59'!
attributeAt: aString ifAbsent: aBlock
	^ self attributes at: aString ifAbsent: aBlock! !

!WAHtmlElement methodsFor: 'accessing-attributes' stamp: 'lr 3/21/2007 15:59'!
attributeAt: aString put: anObject
	^ self attributes at: aString put: anObject! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'lr 3/21/2007 15:58'!
attributes
	^ attributes ifNil: [ attributes := WAHtmlAttributes new ]! !

!WAHtmlElement methodsFor: 'accessing-children' stamp: 'lr 2/28/2009 22:46'!
childrenDo: aBlock
	children isNil
		ifFalse: [ children do: aBlock ]! !

!WAHtmlElement methodsFor: 'printing' stamp: 'lr 1/26/2008 21:08'!
encodeAfterOn: aDocument
	aDocument closeTag: self tag! !

!WAHtmlElement methodsFor: 'printing' stamp: 'lr 1/26/2008 21:08'!
encodeBeforeOn: aDocument
	aDocument openTag: self tag attributes: attributes closed: self isClosed! !

!WAHtmlElement methodsFor: 'printing' stamp: 'lr 1/26/2008 21:08'!
encodeChildrenOn: aDocument
	self childrenDo: [ :each | each encodeOn: aDocument ]! !

!WAHtmlElement methodsFor: 'printing' stamp: 'lr 1/26/2008 21:08'!
encodeOn: aDocument
	self encodeBeforeOn: aDocument.
	self isClosed ifTrue: [ ^ self ].
	self encodeChildrenOn: aDocument.
	self encodeAfterOn: aDocument! !

!WAHtmlElement methodsFor: 'initialization' stamp: 'jf 3/13/2009 18:13'!
initializeWithRoot: aRoot
	self initialize.
	root := aRoot! !

!WAHtmlElement methodsFor: 'testing' stamp: 'lr 3/27/2007 11:24'!
isClosed
	^ true! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:24'!
tag
	self subclassResponsibility! !

!WAHtmlElement methodsFor: 'public' stamp: 'lr 11/5/2007 17:22'!
with: anObject
	self add: anObject! !

WAHtmlElement subclass: #WAMetaElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAMetaElement commentStamp: 'pmm 1/28/2008 06:58' prior: 0!
The META element can be used to identify properties of a document (e.g., author, expiration date, a list of key words, etc.) and assign values to those properties. This specification does not define a normative set of properties.

Each META element specifies a property/value pair. The name attribute identifies the property and the content attribute specifies the property's value.

For example, the following declaration sets a value for the Author property:
<META name="Author" content="Dave Raggett">

The lang attribute can be used with META to specify the language for the value of the content attribute. This enables speech synthesizers to apply language dependent pronunciation rules.

In this example, the author's name is declared to be French:

htm meta
	name: 'Author'; language: 'fr'; content: 'Arnaud Le Hors'
	
Note. The META element is a generic mechanism for specifying meta data. However, some HTML elements and attributes already handle certain pieces of meta data and may be used by authors instead of META to specify those pieces: the TITLE element, the ADDRESS element, the INS and DEL elements, the title attribute, and the cite attribute.

Note. When a property specified by a META element takes a value that is a URI, some authors prefer to specify the meta data via the LINK element. Thus, the following meta data declaration:
html meta
      name: 'DC.identifier';
      content: 'http://www.ietf.org/rfc/rfc1866.txt'

might also be written:
html link
         relationship: 'DC.identifier';
         type: 'text/plain';
         url: 'http://www.ietf.org/rfc/rfc1866.txt'

The http-equiv attribute can be used in place of the name attribute and has a special significance when documents are retrieved via the Hypertext Transfer Protocol (HTTP). HTTP servers may use the property name specified by the http-equiv attribute to create an [RFC822]-style header in the HTTP response. Please see the HTTP specification ([RFC2616]) for details on valid HTTP headers.

The following sample META declaration:
htttp meta
         responseHeaderName: 'Expires';
         content: 'Tue, 20 Aug 1996 14:25:27 GMT'

will result in the HTTP header:
Expires: Tue, 20 Aug 1996 14:25:27 GMT

This can be used by caches to determine when to fetch a fresh copy of the associated document.

Note. Some user agents support the use of META to refresh the current page after a specified number of seconds, with the option of replacing it by a different URI. Authors should not use this technique to forward users to different pages, as this makes the page inaccessible to some users. Instead, automatic page forwarding should be done using server-side redirects.

html meta
         redirectAfter: 5 to: 'http://www.google.com/'!

!WAMetaElement methodsFor: 'convenience' stamp: 'pmm 10/7/2006 18:20'!
beLeftToRight
	self textDirection: 'LTR'! !

!WAMetaElement methodsFor: 'convenience' stamp: 'pmm 10/7/2006 18:20'!
beRightToLeft
	self textDirection: 'RTL'! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:17'!
content: aString
	self attributeAt: 'content' put: aString! !

!WAMetaElement methodsFor: 'convenience' stamp: 'pmm 11/21/2007 21:17'!
contentScriptType: aMimeTypeOrString
	self responseHeaderName: 'Content-Script-Type'.
	self content: aMimeTypeOrString! !

!WAMetaElement methodsFor: 'convenience' stamp: 'pmm 11/21/2007 21:17'!
contentType: aMimeTypeOrString
	self responseHeaderName: 'Content-Type'.
	self content: aMimeTypeOrString! !

!WAMetaElement methodsFor: 'printing' stamp: 'jf 3/13/2009 18:34'!
encodeBeforeOn: aDocument
	self attributes at: 'content' ifAbsentPut: ''.
	super encodeBeforeOn: aDocument! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:18'!
language: aString
	self attributeAt: 'lang' put: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:17'!
name: aString
	self attributeAt: 'name' put: aString! !

!WAMetaElement methodsFor: 'convenience' stamp: 'jf 9/30/2009 01:10'!
redirectAfter: seconds to: aString 
	self responseHeaderName: 'refresh'.
	self content: seconds greaseString , ';URL=' , aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:25'!
responseHeaderName: aString
	self attributeAt: 'http-equiv' put: aString! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:17'!
scheme: aString
	self attributeAt: 'scheme' put: aString! !

!WAMetaElement methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:26'!
tag
	^ 'meta'! !

!WAMetaElement methodsFor: 'attributes' stamp: 'pmm 10/7/2006 18:19'!
textDirection: aString
	self attributeAt: 'dir' put: aString! !

WAObject subclass: #WAHttpVersion
	instanceVariableNames: 'major minor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAHttpVersion class methodsFor: 'instance creation' stamp: 'jf 7/31/2009 12:34'!
fromString: aString
	^ self readFrom: aString readStream! !

!WAHttpVersion class methodsFor: 'instance creation' stamp: 'jf 7/31/2009 10:02'!
http10
	^ self major: 1 minor: 0! !

!WAHttpVersion class methodsFor: 'instance creation' stamp: 'jf 7/31/2009 10:02'!
http11
	^ self major: 1 minor: 1! !

!WAHttpVersion class methodsFor: 'instance creation' stamp: 'jf 7/31/2009 10:01'!
major: majorInteger minor: minorInteger
	^ self basicNew initializeWithMajor: majorInteger minor: minorInteger; yourself! !

!WAHttpVersion class methodsFor: 'instance creation' stamp: 'jf 7/31/2009 10:02'!
new
	^ self http11! !

!WAHttpVersion class methodsFor: 'instance creation' stamp: 'jf 9/30/2009 01:04'!
readFrom: aStream 
	| major minor |
	[ aStream peek = Character space ] whileTrue: [ aStream next ].
	aStream peek = $H ifTrue: [ aStream skipTo: $/ ].	"Skip over 'HTTP/' "
	major := aStream upTo: $..
	minor := aStream upTo: Character space.
	^ self 
		major: major greaseInteger
		minor: minor greaseInteger! !

!WAHttpVersion methodsFor: 'comparing' stamp: 'jf 7/31/2009 10:22'!
< otherVersion
	^ (major < otherVersion major) or: [
		(major = otherVersion major) and: [ minor < otherVersion minor ] ]! !

!WAHttpVersion methodsFor: 'comparing' stamp: 'jf 7/31/2009 10:30'!
<= otherVersion
	^ (self = otherVersion) or: [ self < otherVersion ]! !

!WAHttpVersion methodsFor: 'comparing' stamp: 'jf 7/31/2009 10:13'!
= otherVersion
	^ (major = otherVersion major) and: [ minor = otherVersion minor ]! !

!WAHttpVersion methodsFor: 'comparing' stamp: 'jf 7/31/2009 10:24'!
> otherVersion
	^ (major > otherVersion major) or: [
		(major = otherVersion major) and: [ minor > otherVersion minor ] ]! !

!WAHttpVersion methodsFor: 'comparing' stamp: 'jf 7/31/2009 10:30'!
>= otherVersion
	^ (self = otherVersion) or: [ self > otherVersion ]! !

!WAHttpVersion methodsFor: 'comparing' stamp: 'lr 9/4/2009 09:47'!
hash
	^ major hash bitXor: minor hash! !

!WAHttpVersion methodsFor: 'initialization' stamp: 'jf 7/31/2009 10:01'!
initializeWithMajor: majorInteger minor: minorInteger
	major := majorInteger.
	minor := minorInteger! !

!WAHttpVersion methodsFor: 'testing' stamp: 'jf 7/31/2009 10:50'!
isHttp10
	^ major = 1 and: [ minor = 0 ]! !

!WAHttpVersion methodsFor: 'testing' stamp: 'jf 7/31/2009 10:50'!
isHttp11
	^ major = 1 and: [ minor = 1 ]! !

!WAHttpVersion methodsFor: 'accessing' stamp: 'jf 7/31/2009 10:05'!
major
	^ major! !

!WAHttpVersion methodsFor: 'accessing' stamp: 'jf 7/31/2009 10:05'!
minor
	^ minor! !

!WAHttpVersion methodsFor: 'printing' stamp: 'jf 7/31/2009 10:09'!
printOn: aStream
	aStream nextPutAll: 'HTTP/'.
	major printOn: aStream.
	aStream nextPut: $..
	minor printOn: aStream! !

WAObject subclass: #WAKeyGenerator
	instanceVariableNames: 'generator space'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

WAKeyGenerator class
	instanceVariableNames: 'current'!

WAKeyGenerator class
	instanceVariableNames: 'current'!

!WAKeyGenerator class methodsFor: 'accessing' stamp: 'lr 4/22/2009 19:59'!
current
	^ current! !

!WAKeyGenerator class methodsFor: 'initialization' stamp: 'pmm 1/10/2009 16:04'!
initialize
	current := self new! !

!WAKeyGenerator methodsFor: 'accessing' stamp: 'lr 1/10/2009 12:22'!
generator: aStream
	"A stream of random numbers, basically a random generator."

	generator := aStream! !

!WAKeyGenerator methodsFor: 'initialization' stamp: 'jf 9/30/2009 00:19'!
initialize
	super initialize.
	self generator: GRPlatform current newRandom.
	self space: (Array withAll: ($a to: $z)) , (Array withAll: ($A to: $Z)) , (Array withAll: ($0 to: $9)) , (Array 
				with: $_
				with: $-)! !

!WAKeyGenerator methodsFor: 'public' stamp: 'pmm 1/10/2009 16:05'!
keyOfLength: anInteger
	"Answer a random key as a string with the length anInteger. This does not use any of the fancy collection methods for speed reasons."

	| key |
	key := String new: anInteger.
	1 to: anInteger do: [ :index |
			key at: index put: (space at: (generator nextInt: space size)) ].
	^ key! !

!WAKeyGenerator methodsFor: 'accessing' stamp: 'lr 1/10/2009 12:05'!
space: aCollectionOfCharacters
	"Defines the key generator space."

	space := aCollectionOfCharacters! !

WAObject subclass: #WALocale
	instanceVariableNames: 'language country'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

WALocale class
	instanceVariableNames: 'iso2Languages iso3Languages iso2Countries iso3Countries'!

!WALocale commentStamp: 'pmm 6/1/2008 11:58' prior: 0!
A WALocale definces a users langauge and country.

Instance Variables
	country:		<String>
	language:		<String>

country
	- either an ISO 2 or ISO 3 country code

language
	- either an ISO 2 or ISO 3 language code
!

WALocale class
	instanceVariableNames: 'iso2Languages iso3Languages iso2Countries iso3Countries'!

!WALocale class methodsFor: 'accessing' stamp: ''!
countryList
	^#(('AF' 'AFG' 'AFGHANISTAN') ('AL' 'ALB' 'ALBANIA') ('DZ' 'DZA' 'ALGERIA') ('AS' 'ASM' 'AMERICAN SAMOA') ('AD' 'AND' 'ANDORRA') ('AO' 'AGO' 'ANGOLA') ('AI' 'AIA' 'ANGUILLA') ('AQ' 'ATA' 'ANTARCTICA') ('AG' 'ATG' 'ANTIGUA AND BARBUDA') ('AR' 'ARG' 'ARGENTINA') ('AM' 'ARM' 'ARMENIA') ('AW' 'ABW' 'ARUBA') ('AU' 'AUS' 'AUSTRALIA') ('AT' 'AUT' 'AUSTRIA') ('AZ' 'AZE' 'AZERBAIJAN') ('BS' 'BHS' 'BAHAMAS') ('BH' 'BHR' 'BAHRAIN') ('BD' 'BGD' 'BANGLADESH') ('BB' 'BRB' 'BARBADOS') ('BY' 'BLR' 'BELARUS') ('BE' 'BEL' 'BELGIUM') ('BZ' 'BLZ' 'BELIZE') ('BJ' 'BEN' 'BENIN') ('BM' 'BMU' 'BERMUDA') ('BT' 'BTN' 'BHUTAN') ('BO' 'BOL' 'BOLIVIA') ('BA' 'BIH' 'BOSNIA AND HERZEGOWINA') ('BW' 'BWA' 'BOTSWANA') ('BV' 'BVT' 'BOUVET ISLAND') ('BR' 'BRA' 'BRAZIL') ('IO' 'IOT' 'BRITISH INDIAN OCEAN TERRITORY') ('BN' 'BRN' 'BRUNEI DARUSSALAM') ('BG' 'BGR' 'BULGARIA') ('BF' 'BFA' 'BURKINA FASO') ('BI' 'BDI' 'BURUNDI') ('KH' 'KHM' 'CAMBODIA') ('CM' 'CMR' 'CAMEROON') ('CA' 'CAN' 'CANADA') ('CV' 'CPV' 'CAPE VERDE') ('KY' 'CYM' 'CAYMAN ISLANDS') ('CF' 'CAF' 'CENTRAL AFRICAN REPUBLIC') ('TD' 'TCD' 'CHAD') ('CL' 'CHL' 'CHILE') ('CN' 'CHN' 'CHINA') ('CX' 'CXR' 'CHRISTMAS ISLAND') ('CC' 'CCK' 'COCOS (KEELING) ISLANDS') ('CO' 'COL' 'COLOMBIA') ('KM' 'COM' 'COMOROS') ('CG' 'COG' 'CONGO') ('CK' 'COK' 'COOK ISLANDS') ('CR' 'CRI' 'COSTA RICA') ('CI' 'CIV' 'COTE D''IVOIRE') ('HR' 'HRV' 'CROATIA (local name: Hrvatska)') ('CU' 'CUB' 'CUBA') ('CY' 'CYP' 'CYPRUS') ('CZ' 'CZE' 'CZECH REPUBLIC') ('DK' 'DNK' 'DENMARK') ('DJ' 'DJI' 'DJIBOUTI') ('DM' 'DMA' 'DOMINICA') ('DO' 'DOM' 'DOMINICAN REPUBLIC') ('TP' 'TMP' 'EAST TIMOR') ('EC' 'ECU' 'ECUADOR') ('EG' 'EGY' 'EGYPT') ('SV' 'SLV' 'EL SALVADOR') ('GQ' 'GNQ' 'EQUATORIAL GUINEA') ('ER' '   ' 'ERITREA') ('EE' 'EST' 'ESTONIA') ('ET' 'ETH' 'ETHIOPIA') ('FK' 'FLK' 'FALKLAND ISLANDS (MALVINAS)') ('FO' 'FRO' 'FAROE ISLANDS') ('FJ' 'FJI' 'FIJI') ('FI' 'FIN' 'FINLAND') ('FR' 'FRA' 'FRANCE') ('FX' 'FXX' 'FRANCE, METROPOLITAN') ('GF' 'GUF' 'FRENCH GUIANA') ('PF' 'PYF' 'FRENCH POLYNESIA') ('TF' 'ATF' 'FRENCH SOUTHERN TERRITORIES') ('GA' 'GAB' 'GABON') ('GM' 'GMB' 'GAMBIA') ('GE' 'GEO' 'GEORGIA') ('DE' 'DEU' 'GERMANY') ('GH' 'GHA' 'GHANA') ('GI' 'GIB' 'GIBRALTAR') ('GR' 'GRC' 'GREECE') ('GL' 'GRL' 'GREENLAND') ('GD' 'GRD' 'GRENADA') ('GP' 'GLP' 'GUADELOUPE') ('GU' 'GUM' 'GUAM') ('GT' 'GTM' 'GUATEMALA') ('GN' 'GIN' 'GUINEA') ('GW' 'GNB' 'GUINEA-BISSAU') ('GY' 'GUY' 'GUYANA') ('HT' 'HTI' 'HAITI') ('HM' 'HMD' 'HEARD AND MC DONALD ISLANDS') ('VA' 'VAT' 'HOLY SEE (VATICAN CITY STATE)') ('HN' 'HND' 'HONDURAS') ('HK' 'HKG' 'HONG KONG') ('HU' 'HUN' 'HUNGARY') ('IS' 'ISL' 'ICELAND') ('IN' 'IND' 'INDIA') ('ID' 'IDN' 'INDONESIA') ('IR' 'IRN' 'IRAN (ISLAMIC REPUBLIC OF)') ('IQ' 'IRQ' 'IRAQ') ('IE' 'IRL' 'IRELAND') ('IL' 'ISR' 'ISRAEL') ('IT' 'ITA' 'ITALY') ('JM' 'JAM' 'JAMAICA') ('JP' 'JPN' 'JAPAN') ('JO' 'JOR' 'JORDAN') ('KZ' 'KAZ' 'KAZAKHSTAN') ('KE' 'KEN' 'KENYA') ('KI' 'KIR' 'KIRIBATI') ('KP' 'PRK' 'KOREA, DEMOCRATIC PEOPLE''S REPUBLIC OF') ('KR' 'KOR' 'KOREA, REPUBLIC OF') ('KW' 'KWT' 'KUWAIT') ('KG' 'KGZ' 'KYRGYZSTAN') ('LA' 'LAO' 'LAO PEOPLE''S DEMOCRATIC REPUBLIC') ('LV' 'LVA' 'LATVIA') ('LB' 'LBN' 'LEBANON') ('LS' 'LSO' 'LESOTHO') ('LR' 'LBR' 'LIBERIA') ('LY' 'LBY' 'LIBYAN ARAB JAMAHIRIYA') ('LI' 'LIE' 'LIECHTENSTEIN') ('LT' 'LTU' 'LITHUANIA') ('LU' 'LUX' 'LUXEMBOURG') ('MO' 'MAC' 'MACAU') ('MK' 'MKD' 'MACEDONIA, THE FORMER YUGOSLAV REPUBLIC OF') ('MG' 'MDG' 'MADAGASCAR') ('MW' 'MWI' 'MALAWI') ('MY' 'MYS' 'MALAYSIA') ('MV' 'MDV' 'MALDIVES') ('ML' 'MLI' 'MALI') ('MT' 'MLT' 'MALTA') ('MH' 'MHL' 'MARSHALL ISLANDS') ('MQ' 'MTQ' 'MARTINIQUE') ('MR' 'MRT' 'MAURITANIA') ('MU' 'MUS' 'MAURITIUS') ('YT' 'MYT' 'MAYOTTE') ('MX' 'MEX' 'MEXICO') ('FM' 'FSM' 'MICRONESIA, FEDERATED STATES OF') ('MD' 'MDA' 'MOLDOVA, REPUBLIC OF') ('MC' 'MCO' 'MONACO') ('MN' 'MNG' 'MONGOLIA') ('MS' 'MSR' 'MONTSERRAT') ('MA' 'MAR' 'MOROCCO') ('MZ' 'MOZ' 'MOZAMBIQUE') ('MM' 'MMR' 'MYANMAR') ('NA' 'NAM' 'NAMIBIA') ('NR' 'NRU' 'NAURU') ('NP' 'NPL' 'NEPAL') ('NL' 'NLD' 'NETHERLANDS') ('AN' 'ANT' 'NETHERLANDS ANTILLES') ('NC' 'NCL' 'NEW CALEDONIA') ('NZ' 'NZL' 'NEW ZEALAND') ('NI' 'NIC' 'NICARAGUA') ('NE' 'NER' 'NIGER') ('NG' 'NGA' 'NIGERIA') ('NU' 'NIU' 'NIUE') ('NF' 'NFK' 'NORFOLK ISLAND') ('MP' 'MNP' 'NORTHERN MARIANA ISLANDS') ('NO' 'NOR' 'NORWAY') ('OM' 'OMN' 'OMAN') ('PK' 'PAK' 'PAKISTAN') ('PW' 'PLW' 'PALAU') ('PA' 'PAN' 'PANAMA') ('PG' 'PNG' 'PAPUA NEW GUINEA') ('PY' 'PRY' 'PARAGUAY') ('PE' 'PER' 'PERU') ('PH' 'PHL' 'PHILIPPINES') ('PN' 'PCN' 'PITCAIRN') ('PL' 'POL' 'POLAND') ('PT' 'PRT' 'PORTUGAL') ('PR' 'PRI' 'PUERTO RICO') ('QA' 'QAT' 'QATAR') ('RE' 'REU' 'REUNION') ('RO' 'ROM' 'ROMANIA') ('RU' 'RUS' 'RUSSIAN FEDERATION') ('RW' 'RWA' 'RWANDA') ('KN' 'KNA' 'SAINT KITTS AND NEVIS') ('LC' 'LCA' 'SAINT LUCIA') ('VC' 'VCT' 'SAINT VINCENT AND THE GRENADINES') ('WS' 'WSM' 'SAMOA') ('SM' 'SMR' 'SAN MARINO') ('ST' 'STP' 'SAO TOME AND PRINCIPE') ('SA' 'SAU' 'SAUDI ARABIA') ('SN' 'SEN' 'SENEGAL') ('SC' 'SYC' 'SEYCHELLES') ('SL' 'SLE' 'SIERRA LEONE') ('SG' 'SGP' 'SINGAPORE') ('SK' 'SVK' 'SLOVAKIA (Slovak Republic)') ('SI' 'SVN' 'SLOVENIA') ('SB' 'SLB' 'SOLOMON ISLANDS') ('SO' 'SOM' 'SOMALIA') ('ZA' 'ZAF' 'SOUTH AFRICA') ('GS' 'SGS' 'SOUTH GEORGIA AND THE SOUTH SANDWICH ISLANDS') ('ES' 'ESP' 'SPAIN') ('LK' 'LKA' 'SRI LANKA') ('SH' 'SHN' 'ST. HELENA') ('PM' 'SPM' 'ST. PIERRE AND MIQUELON') ('SD' 'SDN' 'SUDAN') ('SR' 'SUR' 'SURINAME') ('SJ' 'SJM' 'SVALBARD AND JAN MAYEN ISLANDS') ('SZ' 'SWZ' 'SWAZILAND') ('SE' 'SWE' 'SWEDEN') ('CH' 'CHE' 'SWITZERLAND') ('SY' 'SYR' 'SYRIAN ARAB REPUBLIC') ('TW' 'TWN' 'TAIWAN, PROVINCE OF CHINA') ('TJ' 'TJK' 'TAJIKISTAN') ('TZ' 'TZA' 'TANZANIA, UNITED REPUBLIC OF') ('TH' 'THA' 'THAILAND') ('TG' 'TGO' 'TOGO') ('TK' 'TKL' 'TOKELAU') ('TO' 'TON' 'TONGA') ('TT' 'TTO' 'TRINIDAD AND TOBAGO') ('TN' 'TUN' 'TUNISIA') ('TR' 'TUR' 'TURKEY') ('TM' 'TKM' 'TURKMENISTAN') ('TC' 'TCA' 'TURKS AND CAICOS ISLANDS') ('TV' 'TUV' 'TUVALU') ('UG' 'UGA' 'UGANDA') ('UA' 'UKR' 'UKRAINE') ('AE' 'ARE' 'UNITED ARAB EMIRATES') ('GB' 'GBR' 'UNITED KINGDOM') ('US' 'USA' 'UNITED STATES') ('UM' 'UMI' 'UNITED STATES MINOR OUTLYING ISLANDS') ('UY' 'URY' 'URUGUAY') ('UZ' 'UZB' 'UZBEKISTAN') ('VU' 'VUT' 'VANUATU') ('VE' 'VEN' 'VENEZUELA') ('VN' 'VNM' 'VIET NAM') ('VG' 'VGB' 'VIRGIN ISLANDS (BRITISH)') ('VI' 'VIR' 'VIRGIN ISLANDS (U.S.)') ('WF' 'WLF' 'WALLIS AND FUTUNA ISLANDS') ('EH' 'ESH' 'WESTERN SAHARA') ('YE' 'YEM' 'YEMEN') ('YU' 'YUG' 'YUGOSLAVIA') ('ZR' 'ZAR' 'ZAIRE') ('ZM' 'ZMB' 'ZAMBIA') ('ZW' 'ZWE' 'ZIMBABWE'))! !

!WALocale class methodsFor: 'instance creation' stamp: 'lr 2/8/2009 15:46'!
fromString: aString
	| language country delimiter |
	delimiter := (aString includes: $_)
		ifTrue: [ $_ ]
		ifFalse: [ $- ].
	language := aString copyUpTo: delimiter.
	country := aString copyAfter: delimiter.
	country isEmpty ifTrue: [ country := nil ].
	^self
		language: language
		country: country! !

!WALocale class methodsFor: 'class initialization' stamp: 'pmm 3/16/2008 12:50'!
initialize
	self initializeLangaugeList.
	self initializeCountryList! !

!WALocale class methodsFor: 'class initialization' stamp: 'lr 3/29/2008 14:47'!
initializeCountryList
	iso2Countries := Dictionary new.
	iso3Countries := Dictionary new.
	self countryList do: [ :each |
		iso2Countries
			at: each first
			put: each third.
		iso3Countries
			at: each second
			put: each third ]! !

!WALocale class methodsFor: 'class initialization' stamp: 'pmm 3/16/2008 12:50'!
initializeLangaugeList
	iso2Languages := Dictionary new.
	iso3Languages := Dictionary new.
	
	self languageList do: [ :each |
		each size > 2
			ifTrue: [
				iso2Languages at: each first put: each third.
				iso3Languages at: each second put: each third ]
			ifFalse: [
				iso3Languages at: each first put: each second ] ]! !

!WALocale class methodsFor: 'accessing' stamp: 'pmm 1/4/2008 17:36'!
iso2Countries
	^iso2Countries! !

!WALocale class methodsFor: 'accessing' stamp: 'pmm 1/4/2008 17:04'!
iso2Languages
	^iso2Languages! !

!WALocale class methodsFor: 'accessing' stamp: 'lr 3/29/2008 14:50'!
iso3Countries
	^iso3Countries! !

!WALocale class methodsFor: 'accessing' stamp: 'pmm 1/4/2008 17:04'!
iso3Languages
	^iso3Languages! !

!WALocale class methodsFor: 'instance creation' stamp: 'pmm 11/20/2007 13:16'!
language: aLanguageString country: aCounryString
	^self new
		language: aLanguageString;
		country: aCounryString;
		yourself! !

!WALocale class methodsFor: 'accessing' stamp: ''!
languageList
	^#(('aa' 'aar' 'Afar') ('ab' 'abk' 'Abkhazian') ('ace' 'Achinese') ('ach' 'Acoli') ('ada' 'Adangme') ('ady' 'Adyghe; Adygei') ('afa' 'Afro-Asiatic (Other)') ('afh' 'Afrihili') ('af' 'afr' 'Afrikaans') ('ain' 'Ainu') ('ak' 'aka' 'Akan') ('akk' 'Akkadian') ('sq' 'alb' 'Albanian') ('ale' 'Aleut') ('alg' 'Algonquian languages') ('alt' 'Southern Altai') ('am' 'amh' 'Amharic') ('ang' 'English, Old (ca.450-1100)') ('anp' 'Angika') ('apa' 'Apache languages') ('ar' 'ara' 'Arabic') ('arc' 'Official Aramaic (700-300 BCE); Imperial Aramaic (700-300 BCE)') ('an' 'arg' 'Aragonese') ('hy' 'arm' 'Armenian') ('arn' 'Mapudungun; Mapuche') ('arp' 'Arapaho') ('art' 'Artificial (Other)') ('arw' 'Arawak') ('as' 'asm' 'Assamese') ('ast' 'Asturian; Bable; Leonese; Asturleonese') ('ath' 'Athapascan languages') ('aus' 'Australian languages') ('av' 'ava' 'Avaric') ('ae' 'ave' 'Avestan') ('awa' 'Awadhi') ('ay' 'aym' 'Aymara') ('az' 'aze' 'Azerbaijani') ('bad' 'Banda languages') ('bai' 'Bamileke languages') ('ba' 'bak' 'Bashkir') ('bal' 'Baluchi') ('bm' 'bam' 'Bambara') ('ban' 'Balinese') ('eu' 'baq' 'Basque') ('bas' 'Basa') ('bat' 'Baltic (Other)') ('bej' 'Beja; Bedawiyet') ('be' 'bel' 'Belarusian') ('bem' 'Bemba') ('bn' 'ben' 'Bengali') ('ber' 'Berber (Other)') ('bho' 'Bhojpuri') ('bh' 'bih' 'Bihari') ('bik' 'Bikol') ('bin' 'Bini; Edo') ('bi' 'bis' 'Bislama') ('bla' 'Siksika') ('bnt' 'Bantu (Other)') ('bs' 'bos' 'Bosnian') ('bra' 'Braj') ('br' 'bre' 'Breton') ('btk' 'Batak languages') ('bua' 'Buriat') ('bug' 'Buginese') ('bg' 'bul' 'Bulgarian') ('my' 'bur' 'Burmese') ('byn' 'Blin; Bilin') ('cad' 'Caddo') ('cai' 'Central American Indian (Other)') ('car' 'Galibi Carib') ('ca' 'cat' 'Catalan; Valencian') ('cau' 'Caucasian (Other)') ('ceb' 'Cebuano') ('cel' 'Celtic (Other)') ('ch' 'cha' 'Chamorro') ('chb' 'Chibcha') ('ce' 'che' 'Chechen') ('chg' 'Chagatai') ('zh' 'chi' 'Chinese') ('chk' 'Chuukese') ('chm' 'Mari') ('chn' 'Chinook jargon') ('cho' 'Choctaw') ('chp' 'Chipewyan; Dene Suline') ('chr' 'Cherokee') ('cu' 'chu' 'Church Slavic; Old Slavonic; Church Slavonic; Old Bulgarian; Old Church Slavonic') ('cv' 'chv' 'Chuvash') ('chy' 'Cheyenne') ('cmc' 'Chamic languages') ('cop' 'Coptic') ('kw' 'cor' 'Cornish') ('co' 'cos' 'Corsican') ('cpe' 'Creoles and pidgins, English based (Other)') ('cpf' 'Creoles and pidgins, French-based (Other)') ('cpp' 'Creoles and pidgins, Portuguese-based (Other)') ('cr' 'cre' 'Cree') ('crh' 'Crimean Tatar; Crimean Turkish') ('crp' 'Creoles and pidgins (Other)') ('csb' 'Kashubian') ('cus' 'Cushitic (Other)') ('cs' 'cze' 'Czech') ('dak' 'Dakota') ('da' 'dan' 'Danish') ('dar' 'Dargwa') ('day' 'Land Dayak languages') ('del' 'Delaware') ('den' 'Slave (Athapascan)') ('dgr' 'Dogrib') ('din' 'Dinka') ('dv' 'div' 'Divehi; Dhivehi; Maldivian') ('doi' 'Dogri') ('dra' 'Dravidian (Other)') ('dsb' 'Lower Sorbian') ('dua' 'Duala') ('dum' 'Dutch, Middle (ca.1050-1350)') ('nl' 'dut' 'Dutch; Flemish') ('dyu' 'Dyula') ('dz' 'dzo' 'Dzongkha') ('efi' 'Efik') ('egy' 'Egyptian (Ancient)') ('eka' 'Ekajuk') ('elx' 'Elamite') ('en' 'eng' 'English') ('enm' 'English, Middle (1100-1500)') ('eo' 'epo' 'Esperanto') ('et' 'est' 'Estonian') ('ee' 'ewe' 'Ewe') ('ewo' 'Ewondo') ('fan' 'Fang') ('fo' 'fao' 'Faroese') ('fat' 'Fanti') ('fj' 'fij' 'Fijian') ('fil' 'Filipino; Pilipino') ('fi' 'fin' 'Finnish') ('fiu' 'Finno-Ugrian (Other)') ('fon' 'Fon') ('fr' 'fre' 'French') ('frm' 'French, Middle (ca.1400-1600)') ('fro' 'French, Old (842-ca.1400)') ('frr' 'Northern Frisian') ('frs' 'Eastern Frisian') ('fy' 'fry' 'Western Frisian') ('ff' 'ful' 'Fulah') ('fur' 'Friulian') ('gaa' 'Ga') ('gay' 'Gayo') ('gba' 'Gbaya') ('gem' 'Germanic (Other)') ('ka' 'geo' 'Georgian') ('de' 'ger' 'German') ('gez' 'Geez') ('gil' 'Gilbertese') ('gd' 'gla' 'Gaelic; Scottish Gaelic') ('ga' 'gle' 'Irish') ('gl' 'glg' 'Galician') ('gv' 'glv' 'Manx') ('gmh' 'German, Middle High (ca.1050-1500)') ('goh' 'German, Old High (ca.750-1050)') ('gon' 'Gondi') ('gor' 'Gorontalo') ('got' 'Gothic') ('grb' 'Grebo') ('grc' 'Greek, Ancient (to 1453)') ('el' 'gre' 'Greek, Modern (1453-)') ('gn' 'grn' 'Guarani') ('gsw' 'Swiss German; Alemannic; Alsatian') ('gu' 'guj' 'Gujarati') ('gwi' 'Gwich''in') ('hai' 'Haida') ('ht' 'hat' 'Haitian; Haitian Creole') ('ha' 'hau' 'Hausa') ('haw' 'Hawaiian') ('he' 'heb' 'Hebrew') ('hz' 'her' 'Herero') ('hil' 'Hiligaynon') ('him' 'Himachali') ('hi' 'hin' 'Hindi') ('hit' 'Hittite') ('hmn' 'Hmong') ('ho' 'hmo' 'Hiri Motu') ('hsb' 'Upper Sorbian') ('hu' 'hun' 'Hungarian') ('hup' 'Hupa') ('iba' 'Iban') ('ig' 'ibo' 'Igbo') ('is' 'ice' 'Icelandic') ('io' 'ido' 'Ido') ('ii' 'iii' 'Sichuan Yi; Nuosu') ('ijo' 'Ijo languages') ('iu' 'iku' 'Inuktitut') ('ie' 'ile' 'Interlingue; Occidental') ('ilo' 'Iloko') ('ia' 'ina' 'Interlingua (International Auxiliary Language Association)') ('inc' 'Indic (Other)') ('id' 'ind' 'Indonesian') ('ine' 'Indo-European (Other)') ('inh' 'Ingush') ('ik' 'ipk' 'Inupiaq') ('ira' 'Iranian (Other)') ('iro' 'Iroquoian languages') ('it' 'ita' 'Italian') ('jv' 'jav' 'Javanese') ('jbo' 'Lojban') ('ja' 'jpn' 'Japanese') ('jpr' 'Judeo-Persian') ('jrb' 'Judeo-Arabic') ('kaa' 'Kara-Kalpak') ('kab' 'Kabyle') ('kac' 'Kachin; Jingpho') ('kl' 'kal' 'Kalaallisut; Greenlandic') ('kam' 'Kamba') ('kn' 'kan' 'Kannada') ('kar' 'Karen languages') ('ks' 'kas' 'Kashmiri') ('kr' 'kau' 'Kanuri') ('kaw' 'Kawi') ('kk' 'kaz' 'Kazakh') ('kbd' 'Kabardian') ('kha' 'Khasi') ('khi' 'Khoisan (Other)') ('km' 'khm' 'Central Khmer') ('kho' 'Khotanese') ('ki' 'kik' 'Kikuyu; Gikuyu') ('rw' 'kin' 'Kinyarwanda') ('ky' 'kir' 'Kirghiz; Kyrgyz') ('kmb' 'Kimbundu') ('kok' 'Konkani') ('kv' 'kom' 'Komi') ('kg' 'kon' 'Kongo') ('ko' 'kor' 'Korean') ('kos' 'Kosraean') ('kpe' 'Kpelle') ('krc' 'Karachay-Balkar') ('krl' 'Karelian') ('kro' 'Kru languages') ('kru' 'Kurukh') ('kj' 'kua' 'Kuanyama; Kwanyama') ('kum' 'Kumyk') ('ku' 'kur' 'Kurdish') ('kut' 'Kutenai') ('lad' 'Ladino') ('lah' 'Lahnda') ('lam' 'Lamba') ('lo' 'lao' 'Lao') ('la' 'lat' 'Latin') ('lv' 'lav' 'Latvian') ('lez' 'Lezghian') ('li' 'lim' 'Limburgan; Limburger; Limburgish') ('ln' 'lin' 'Lingala') ('lt' 'lit' 'Lithuanian') ('lol' 'Mongo') ('loz' 'Lozi') ('lb' 'ltz' 'Luxembourgish; Letzeburgesch') ('lua' 'Luba-Lulua') ('lu' 'lub' 'Luba-Katanga') ('lg' 'lug' 'Ganda') ('lui' 'Luiseno') ('lun' 'Lunda') ('luo' 'Luo (Kenya and Tanzania)') ('lus' 'Lushai') ('mk' 'mac' 'Macedonian') ('mad' 'Madurese') ('mag' 'Magahi') ('mh' 'mah' 'Marshallese') ('mai' 'Maithili') ('mak' 'Makasar') ('ml' 'mal' 'Malayalam') ('man' 'Mandingo') ('mi' 'mao' 'Maori') ('map' 'Austronesian (Other)') ('mr' 'mar' 'Marathi') ('mas' 'Masai') ('ms' 'may' 'Malay') ('mdf' 'Moksha') ('mdr' 'Mandar') ('men' 'Mende') ('mga' 'Irish, Middle (900-1200)') ('mic' 'Mi''kmaq; Micmac') ('min' 'Minangkabau') ('mis' 'Uncoded languages') ('mkh' 'Mon-Khmer (Other)') ('mg' 'mlg' 'Malagasy') ('mt' 'mlt' 'Maltese') ('mnc' 'Manchu') ('mni' 'Manipuri') ('mno' 'Manobo languages') ('moh' 'Mohawk') ('mo' 'mol' 'Moldavian') ('mn' 'mon' 'Mongolian') ('mos' 'Mossi') ('mul' 'Multiple languages') ('mun' 'Munda languages') ('mus' 'Creek') ('mwl' 'Mirandese') ('mwr' 'Marwari') ('myn' 'Mayan languages') ('myv' 'Erzya') ('nah' 'Nahuatl languages') ('nai' 'North American Indian') ('nap' 'Neapolitan') ('na' 'nau' 'Nauru') ('nv' 'nav' 'Navajo; Navaho') ('nr' 'nbl' 'Ndebele, South; South Ndebele') ('nd' 'nde' 'Ndebele, North; North Ndebele') ('ng' 'ndo' 'Ndonga') ('nds' 'Low German; Low Saxon; German, Low; Saxon, Low') ('ne' 'nep' 'Nepali') ('new' 'Nepal Bhasa; Newari') ('nia' 'Nias') ('nic' 'Niger-Kordofanian (Other)') ('niu' 'Niuean') ('nn' 'nno' 'Norwegian Nynorsk; Nynorsk, Norwegian') ('nb' 'nob' 'Bokml, Norwegian; Norwegian Bokml') ('nog' 'Nogai') ('non' 'Norse, Old') ('no' 'nor' 'Norwegian') ('nqo' 'N''Ko') ('nso' 'Pedi; Sepedi; Northern Sotho') ('nub' 'Nubian languages') ('nwc' 'Classical Newari; Old Newari; Classical Nepal Bhasa') ('ny' 'nya' 'Chichewa; Chewa; Nyanja') ('nym' 'Nyamwezi') ('nyn' 'Nyankole') ('nyo' 'Nyoro') ('nzi' 'Nzima') ('oc' 'oci' 'Occitan (post 1500); Provenal') ('oj' 'oji' 'Ojibwa') ('or' 'ori' 'Oriya') ('om' 'orm' 'Oromo') ('osa' 'Osage') ('os' 'oss' 'Ossetian; Ossetic') ('ota' 'Turkish, Ottoman (1500-1928)') ('oto' 'Otomian languages') ('paa' 'Papuan (Other)') ('pag' 'Pangasinan') ('pal' 'Pahlavi') ('pam' 'Pampanga; Kapampangan') ('pa' 'pan' 'Panjabi; Punjabi') ('pap' 'Papiamento') ('pau' 'Palauan') ('peo' 'Persian, Old (ca.600-400 B.C.)') ('fa' 'per' 'Persian') ('phi' 'Philippine (Other)') ('phn' 'Phoenician') ('pi' 'pli' 'Pali') ('pl' 'pol' 'Polish') ('pon' 'Pohnpeian') ('pt' 'por' 'Portuguese') ('pra' 'Prakrit languages') ('pro' 'Provenal, Old (to 1500)') ('ps' 'pus' 'Pushto; Pashto') ('qaa-qtz' 'Reserved for local use') ('qu' 'que' 'Quechua') ('raj' 'Rajasthani') ('rap' 'Rapanui') ('rar' 'Rarotongan; Cook Islands Maori') ('roa' 'Romance (Other)') ('rm' 'roh' 'Romansh') ('rom' 'Romany') ('ro' 'rum' 'Romanian') ('rn' 'run' 'Rundi') ('rup' 'Aromanian; Arumanian; Macedo-Romanian') ('ru' 'rus' 'Russian') ('sad' 'Sandawe') ('sg' 'sag' 'Sango') ('sah' 'Yakut') ('sai' 'South American Indian (Other)') ('sal' 'Salishan languages') ('sam' 'Samaritan Aramaic') ('sa' 'san' 'Sanskrit') ('sas' 'Sasak') ('sat' 'Santali') ('sr' 'scc' 'Serbian') ('scn' 'Sicilian') ('sco' 'Scots') ('hr' 'scr' 'Croatian') ('sel' 'Selkup') ('sem' 'Semitic (Other)') ('sga' 'Irish, Old (to 900)') ('sgn' 'Sign Languages') ('shn' 'Shan') ('sid' 'Sidamo') ('si' 'sin' 'Sinhala; Sinhalese') ('sio' 'Siouan languages') ('sit' 'Sino-Tibetan (Other)') ('sla' 'Slavic (Other)') ('sk' 'slo' 'Slovak') ('sl' 'slv' 'Slovenian') ('sma' 'Southern Sami') ('se' 'sme' 'Northern Sami') ('smi' 'Sami languages (Other)') ('smj' 'Lule Sami') ('smn' 'Inari Sami') ('sm' 'smo' 'Samoan') ('sms' 'Skolt Sami') ('sn' 'sna' 'Shona') ('sd' 'snd' 'Sindhi') ('snk' 'Soninke') ('sog' 'Sogdian') ('so' 'som' 'Somali') ('son' 'Songhai languages') ('st' 'sot' 'Sotho, Southern') ('es' 'spa' 'Spanish; Castilian') ('sc' 'srd' 'Sardinian') ('srn' 'Sranan Tongo') ('srr' 'Serer') ('ssa' 'Nilo-Saharan (Other)') ('ss' 'ssw' 'Swati') ('suk' 'Sukuma') ('su' 'sun' 'Sundanese') ('sus' 'Susu') ('sux' 'Sumerian') ('sw' 'swa' 'Swahili') ('sv' 'swe' 'Swedish') ('syc' 'Classical Syriac') ('syr' 'Syriac') ('ty' 'tah' 'Tahitian') ('tai' 'Tai (Other)') ('ta' 'tam' 'Tamil') ('tt' 'tat' 'Tatar') ('te' 'tel' 'Telugu') ('tem' 'Timne') ('ter' 'Tereno') ('tet' 'Tetum') ('tg' 'tgk' 'Tajik') ('tl' 'tgl' 'Tagalog') ('th' 'tha' 'Thai') ('bo' 'tib' 'Tibetan') ('tig' 'Tigre') ('ti' 'tir' 'Tigrinya') ('tiv' 'Tiv') ('tkl' 'Tokelau') ('tlh' 'Klingon; tlhIngan-Hol') ('tli' 'Tlingit') ('tmh' 'Tamashek') ('tog' 'Tonga (Nyasa)') ('to' 'ton' 'Tonga (Tonga Islands)') ('tpi' 'Tok Pisin') ('tsi' 'Tsimshian') ('tn' 'tsn' 'Tswana') ('ts' 'tso' 'Tsonga') ('tk' 'tuk' 'Turkmen') ('tum' 'Tumbuka') ('tup' 'Tupi languages') ('tr' 'tur' 'Turkish') ('tut' 'Altaic (Other)') ('tvl' 'Tuvalu') ('tw' 'twi' 'Twi') ('tyv' 'Tuvinian') ('udm' 'Udmurt') ('uga' 'Ugaritic') ('ug' 'uig' 'Uighur; Uyghur') ('uk' 'ukr' 'Ukrainian') ('umb' 'Umbundu') ('und' 'Undetermined') ('ur' 'urd' 'Urdu') ('uz' 'uzb' 'Uzbek') ('vai' 'Vai') ('ve' 'ven' 'Venda') ('vi' 'vie' 'Vietnamese') ('vo' 'vol' 'Volapk') ('vot' 'Votic') ('wak' 'Wakashan languages') ('wal' 'Walamo') ('war' 'Waray') ('was' 'Washo') ('cy' 'wel' 'Welsh') ('wen' 'Sorbian languages') ('wa' 'wln' 'Walloon') ('wo' 'wol' 'Wolof') ('xal' 'Kalmyk; Oirat') ('xh' 'xho' 'Xhosa') ('yao' 'Yao') ('yap' 'Yapese') ('yi' 'yid' 'Yiddish') ('yo' 'yor' 'Yoruba') ('ypk' 'Yupik languages') ('zap' 'Zapotec') ('zbl' 'Blissymbols; Blissymbolics; Bliss') ('zen' 'Zenaga') ('za' 'zha' 'Zhuang; Chuang') ('znd' 'Zande languages') ('zu' 'zul' 'Zulu') ('zun' 'Zuni') ('zxx' 'No linguistic content') ('zza' 'Zaza; Dimili; Dimli; Kirdki; Kirmanjki; Zazaki'))! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 11/20/2007 13:10'!
country
	^ country! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 11/20/2007 13:10'!
country: aString
	country := aString! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 5/31/2008 23:49'!
countryName
	"answers the country name in english and all capitals"
	^self country size = 2
		ifTrue: [ self class iso2Countries at: self country ]
		ifFalse: [ self class iso3Countries at: self country ]! !

!WALocale methodsFor: 'converting' stamp: 'jf 9/30/2009 01:10'!
greaseString
	^ String streamContents: 
		[ :stream | 
		stream nextPutAll: self language.
		self country isNil ifFalse: 
			[ stream
				nextPut: $-;
				nextPutAll: self country ] ]! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 11/20/2007 13:10'!
language
	^ language! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 11/20/2007 13:11'!
language: aString
	language := aString! !

!WALocale methodsFor: 'accessing' stamp: 'pmm 5/31/2008 23:50'!
languageName
	"answers the language name in english and all capitals"
	^self language size = 2
		ifTrue: [ self class iso2Languages at: self language ]
		ifFalse: [ self class iso3Languages at: self language ]! !

!WALocale methodsFor: 'printing' stamp: 'jf 9/30/2009 01:10'!
printOn: aStream 
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self greaseString;
		nextPut: $)! !

WAObject subclass: #WAMergedHeaderFields
	instanceVariableNames: 'delegates'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAMergedHeaderFields commentStamp: 'lr 2/22/2009 16:08' prior: 0!
Provides a read-only view onto multiple dictionaries. Note that this can lead to to duplicated keys that can only retrieved by iterating over all the associations.!

!WAMergedHeaderFields class methodsFor: 'instance creation' stamp: 'lr 2/21/2009 13:02'!
new
	self error: self name , ' is created with #on:'! !

!WAMergedHeaderFields class methodsFor: 'instance creation' stamp: 'lr 2/21/2009 13:01'!
on: anArray
	^ self basicNew initializeOn: anArray! !

!WAMergedHeaderFields methodsFor: 'enumerating' stamp: 'lr 2/21/2009 12:48'!
associationsDo: aBlock
	delegates do: [ :each | each associationsDo: aBlock ]! !

!WAMergedHeaderFields methodsFor: 'accessing' stamp: 'lr 2/21/2009 12:59'!
at: aKey
	^ self at: aKey ifAbsent: [ self errorKeyNotFound ]! !

!WAMergedHeaderFields methodsFor: 'accessing' stamp: 'lr 2/21/2009 13:00'!
at: aKey ifAbsent: aBlock
	delegates do: [ :each |
		each
			at: aKey
			ifPresent: [ :value | ^ value ] ].
	^ aBlock value! !

!WAMergedHeaderFields methodsFor: 'accessing' stamp: 'lr 2/22/2009 18:19'!
at: aKey ifPresent: aBlock
	delegates do: [ :each |
		each
			at: aKey
			ifPresent: [ :value | ^ aBlock value: value ] ].
	^ nil! !

!WAMergedHeaderFields methodsFor: 'private' stamp: 'lr 2/21/2009 12:59'!
errorKeyNotFound
	^ nil! !

!WAMergedHeaderFields methodsFor: 'testing' stamp: 'lr 2/21/2009 12:58'!
includesKey: aKey
	^ delegates anySatisfy: [ :each | each includesKey: aKey ]! !

!WAMergedHeaderFields methodsFor: 'initialization' stamp: 'lr 2/22/2009 18:20'!
initializeOn: anArray
	self initialize.
	delegates := anArray! !

!WAMergedHeaderFields methodsFor: 'testing' stamp: 'lr 2/22/2009 18:19'!
isEmpty
	^ delegates allSatisfy: [ :each | each isEmpty ]! !

!WAMergedHeaderFields methodsFor: 'enumerating' stamp: 'lr 2/21/2009 12:57'!
keys
	^ delegates
		inject: OrderedCollection new
		into: [ :result :each | result addAll: each keys; yourself ]! !

!WAMergedHeaderFields methodsFor: 'enumerating' stamp: 'lr 2/21/2009 12:47'!
keysAndValuesDo: aBlock
	delegates do: [ :each | each keysAndValuesDo: aBlock ]! !

!WAMergedHeaderFields methodsFor: 'enumerating' stamp: 'lr 2/21/2009 12:47'!
keysDo: aBlock
	delegates do: [ :each | each keysDo: aBlock ]! !

!WAMergedHeaderFields methodsFor: 'accessing' stamp: 'lr 2/22/2009 18:18'!
size
	^ delegates inject: 0 into: [ :result :each | result + each size ]! !

!WAMergedHeaderFields methodsFor: 'enumerating' stamp: 'lr 2/21/2009 12:57'!
values
	^ delegates
		inject: OrderedCollection new
		into: [ :result :each | result addAll: each values; yourself ]! !

!WAMergedHeaderFields methodsFor: 'enumerating' stamp: 'lr 2/21/2009 12:47'!
valuesDo: aBlock
	delegates do: [ :each | each valuesDo: aBlock ]! !

WAObject subclass: #WAMimeDocument
	instanceVariableNames: 'contents mimeType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAMimeDocument commentStamp: 'jf 9/28/2008 17:01' prior: 0!
WAMimeDocument is the abstract base class for mime documents. It is intened as a very basic, mime documents. Implementations are free to use more advance, native implentations as long as they conform to the protocol.

Instance Variables
	contentType:		<WAMimeType>

mimeType
	- the mime type of this document
!

!WAMimeDocument class methodsFor: 'instance creation' stamp: 'lr 10/18/2008 17:09'!
on: aCollection
	^ self on: aCollection mimeType: nil! !

!WAMimeDocument class methodsFor: 'instance creation' stamp: 'lr 10/18/2008 16:21'!
on: aCollection mimeType: aMimeType
	^ self on: aCollection mimeType: aMimeType fileName: nil! !

!WAMimeDocument class methodsFor: 'instance creation' stamp: 'jf 3/13/2009 18:14'!
on: aCollection mimeType: aMimeType fileName: aString
	^ self basicNew initializeOn: aCollection mimeType: aMimeType fileName: aString; yourself! !

!WAMimeDocument methodsFor: 'comparing' stamp: 'pmm 11/4/2008 11:17'!
= anObject
	^ (anObject isKindOf: WAMimeDocument)
		and: [ self mimeType = anObject mimeType
		and: [ self fileName = anObject fileName
		and: [ self contents = anObject contents ] ] ]! !

!WAMimeDocument methodsFor: 'compatibility' stamp: 'lr 10/18/2008 16:43'!
content
	^ self contents! !

!WAMimeDocument methodsFor: 'compatibility' stamp: 'lr 10/18/2008 16:47'!
contentStream
	^ self contents readStream! !

!WAMimeDocument methodsFor: 'compatibility' stamp: 'lr 10/18/2008 16:43'!
contentType
	^ self mimeType! !

!WAMimeDocument methodsFor: 'accessing' stamp: 'lr 10/18/2008 15:56'!
contents
	"Answer the content of the receiver as a Collection of Characters or bytes."
	
	^ contents! !

!WAMimeDocument methodsFor: 'accessing' stamp: 'lr 10/18/2008 15:57'!
contents: aCollection
	contents := aCollection! !

!WAMimeDocument methodsFor: 'accessing' stamp: 'lr 10/18/2008 15:20'!
fileName
	"Answer the file name of this document, or nil."
	
	^ fileName! !

!WAMimeDocument methodsFor: 'accessing' stamp: 'lr 10/18/2008 15:57'!
fileName: aString
	fileName := aString! !

!WAMimeDocument methodsFor: 'comparing' stamp: 'pmm 11/4/2008 11:17'!
hash
	^ (self mimeType hash
		bitXor: self fileName hash)
		bitXor: self contents hash! !

!WAMimeDocument methodsFor: 'initialization' stamp: 'jf 3/13/2009 18:14'!
initializeOn: aCollection mimeType: aMimeType fileName: aString
	self initialize.
	self contents: aCollection.
	self mimeType: aMimeType.
	self fileName: aString! !

!WAMimeDocument methodsFor: 'accessing' stamp: 'lr 10/18/2008 15:48'!
mimeType
	"Answer the file name of this document, or nil."
	
	^ mimeType! !

!WAMimeDocument methodsFor: 'accessing' stamp: 'lr 10/18/2008 17:09'!
mimeType: aMimeType
	mimeType := aMimeType isNil
		ifFalse: [ aMimeType seasideMimeType ]
		ifTrue: [ WAMimeType applicationOctetStream ]! !

!WAMimeDocument methodsFor: 'converting' stamp: 'lr 10/18/2008 15:21'!
seasideMimeDocument
	^ self! !

WAObject subclass: #WAMimeType
	instanceVariableNames: 'main sub parameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAMimeType commentStamp: 'pmm 1/4/2008 14:44' prior: 0!
A WAMimeType abstracts a Internet media type, it is a two-part identifier for file formats on the Internet.

Instance Variables
	main:		<String>
	parameters:		<WASmallDictionary>
	sub:		<String>

main
	- the main type

parameters
	- a lazily initialized dictionary of optional parameters

sub
	- the subtype
!

!WAMimeType class methodsFor: 'convenience' stamp: 'jf 8/26/2009 14:45'!
applicationAtomXml
	^ self main: 'application' sub: 'atom+xml'! !

!WAMimeType class methodsFor: 'convenience' stamp: 'pmm 9/2/2009 15:57'!
applicationJson
	^ self main: 'application' sub: 'json'! !

!WAMimeType class methodsFor: 'convenience' stamp: 'jf 9/22/2008 13:09'!
applicationOctetStream
	^ self main: 'application' sub: 'octet-stream'! !

!WAMimeType class methodsFor: 'convenience' stamp: 'pmm 2/21/2009 12:56'!
applicationRssXml
	^ self main: 'application' sub: 'rss+xml'! !

!WAMimeType class methodsFor: 'instance creation' stamp: 'jf 9/30/2009 00:26'!
fromString: aString 
	| main endOfSub sub parts parameters |
	main := aString copyUpTo: $/.
	endOfSub := aString indexOf: $;.
	endOfSub := endOfSub = 0 
		ifTrue: [ aString size ]
		ifFalse: [ endOfSub - 1 ].
	sub := aString 
		copyFrom: main size + 2
		to: endOfSub.
	endOfSub = aString size ifTrue: 
		[ ^ self 
			main: main
			sub: sub ].
	parts := (aString 
		copyFrom: endOfSub + 1
		to: aString size) findTokens: ';'.
	parameters := GRSmallDictionary new.
	parts do: 
		[ :each | 
		parameters 
			at: (each copyUpTo: $=) trimBoth
			put: (each copyAfter: $=) trimBoth ].
	^ self 
		main: main
		sub: sub
		parameters: parameters! !

!WAMimeType class methodsFor: 'convenience' stamp: 'jf 9/22/2008 13:09'!
imageGif
	^ self main: 'image' sub: 'gif'! !

!WAMimeType class methodsFor: 'convenience' stamp: 'jf 9/22/2008 13:09'!
imageJpeg
	^ self main: 'image' sub: 'jpeg'! !

!WAMimeType class methodsFor: 'convenience' stamp: 'jf 9/22/2008 13:09'!
imagePng
	^ self main: 'image' sub: 'png'! !

!WAMimeType class methodsFor: 'instance creation' stamp: 'pmm 11/20/2007 10:58'!
main: aMainString sub: aSubString
	^self new
		main: aMainString;
		sub: aSubString;
		yourself! !

!WAMimeType class methodsFor: 'instance creation' stamp: 'pmm 11/20/2007 10:58'!
main: aMainString sub: aSubString parameters: aDictionary
	^(self main: aMainString sub: aSubString)
		parameters: aDictionary;
		yourself! !

!WAMimeType class methodsFor: 'convenience' stamp: 'jf 9/22/2008 13:14'!
textCss
	^ self main: 'text' sub: 'css'! !

!WAMimeType class methodsFor: 'convenience' stamp: 'jf 9/22/2008 12:52'!
textHtml
	^ self main: 'text' sub: 'html'! !

!WAMimeType class methodsFor: 'convenience' stamp: 'jf 9/22/2008 12:59'!
textJavascript
	^ self main: 'text' sub: 'javascript'! !

!WAMimeType class methodsFor: 'convenience' stamp: 'jf 9/22/2008 12:52'!
textPlain
	^ self main: 'text' sub: 'plain'! !

!WAMimeType methodsFor: 'comparing' stamp: 'pmm 1/4/2008 15:08'!
= other
	^(other isKindOf: WAMimeType)
		and: [ self main = other main
		and: [ self sub = other sub ] ]! !

!WAMimeType methodsFor: 'parameters' stamp: 'pmm 9/6/2009 12:33'!
charSet
	^self parameters at: 'charset'! !

!WAMimeType methodsFor: 'parameters' stamp: 'pmm 11/21/2007 15:17'!
charset: aString
	self parameters at: 'charset' put: aString! !

!WAMimeType methodsFor: 'converting' stamp: 'jf 9/30/2009 01:10'!
greaseString
	^ String streamContents: 
		[ :stream | 
		stream
			nextPutAll: self main;
			nextPut: $/;
			nextPutAll: self sub.
		parameters isNil ifFalse: 
			[ parameters keysAndValuesDo: 
				[ :key :value | 
				stream
					nextPut: $;;
					nextPutAll: key;
					nextPut: $=;
					nextPutAll: value ] ] ]! !

!WAMimeType methodsFor: 'comparing' stamp: 'pmm 1/4/2008 15:14'!
hash
	^self main hash bitXor: self sub hash! !

!WAMimeType methodsFor: 'testing' stamp: 'pmm 2/20/2009 10:26'!
isBinary
	"answers whether the contents of a document of the receiving mime type are binary"
	| subTypes |
	self main = 'text' ifTrue: [ ^false ].
	self main = 'application' ifFalse: [ ^true ].
	subTypes := self sub findTokens: '+'.
	^ subTypes noneSatisfy: [ :each | 
		#('x-javascript' 'xml') includes: each ]! !

!WAMimeType methodsFor: 'testing' stamp: 'pmm 1/4/2008 14:40'!
isNonStandard
	"tests if the receiver is a non-standard mime type that is not registered with IANA"
	^(self main beginsWith: 'x-')
		or: [ (self main beginsWith: 'X-')
		or: [ (self sub beginsWith: 'x-')
		or: [ self sub beginsWith: 'X-' ] ] ]! !

!WAMimeType methodsFor: 'testing' stamp: 'pmm 1/4/2008 14:39'!
isVendorSpecific
	"tests if the receiver is a vendor specific mimetype"
	^self sub beginsWith: 'vnd.'! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:54'!
main
	^ main! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:57'!
main: aString
	main := aString! !

!WAMimeType methodsFor: 'testing' stamp: 'pmm 11/21/2007 15:12'!
matches: aMimeType
	"aMimeType is the pattern to match, it is a normal WAMimeType instance where main or sub can be wildcards"
	^(aMimeType main = '*'
		or: [ aMimeType main = self main ])
		and: [
			aMimeType sub = '*'
				or: [ aMimeType sub = self sub ] ]! !

!WAMimeType methodsFor: 'parameters' stamp: 'pmm 11/21/2007 15:14'!
parameterAt: aKey put: aValue
	self parameters at: aKey put: aValue! !

!WAMimeType methodsFor: 'accessing' stamp: 'jf 9/30/2009 00:26'!
parameters
	parameters isNil ifTrue: [ parameters := GRSmallDictionary new ].
	^ parameters! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:54'!
parameters: aDictionary
	parameters := aDictionary! !

!WAMimeType methodsFor: 'printing' stamp: 'jf 9/30/2009 01:10'!
printOn: aStream 
	super printOn: aStream.
	aStream
		nextPut: $(;
		nextPutAll: self greaseString;
		nextPut: $)! !

!WAMimeType methodsFor: 'converting' stamp: 'jf 9/22/2008 12:14'!
seasideMimeType
	^ self! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:54'!
sub
	^ sub! !

!WAMimeType methodsFor: 'accessing' stamp: 'pmm 11/20/2007 10:55'!
sub: aString
	sub := aString! !

WAObject subclass: #WAMutex
	instanceVariableNames: 'semaphore owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WAMutex commentStamp: 'jf 2/5/2009 12:49' prior: 0!
WAMutex provides mutual exclusion properties.

Only one process at a time can execute code within its #critical: method. Other processes attempting to call #critical: will block until the first process leaves the critical section. The process that owns the mutex (the one currently in the critical section), however, may call #critical: repeatedly without fear of blocking.

The process currently inside the critical section can be terminated by calling #terminateOwner. This will result in the process being unwound and the critical section being freed.!

!WAMutex methodsFor: 'copying' stamp: 'jf 2/5/2009 12:45'!
copy
	^ self species new! !

!WAMutex methodsFor: 'mutual exclusion' stamp: 'jf 2/5/2009 11:17'!
critical: aBlock
	| process |
	process := Processor activeProcess.
	^ (owner == process)
		ifTrue: [ aBlock value ]
		ifFalse: [
			semaphore critical: [
				owner := process.
				aBlock ensure: [ owner := nil ] ] ]! !

!WAMutex methodsFor: 'initialization' stamp: 'jf 9/30/2009 00:19'!
initialize
	super initialize.
	semaphore := GRPlatform current semaphoreClass forMutualExclusion! !

!WAMutex methodsFor: 'accessing' stamp: 'jf 2/5/2009 10:57'!
owner
	^ owner! !

!WAMutex methodsFor: 'mutual exclusion' stamp: 'jf 9/30/2009 00:19'!
terminateOwner
	owner isNil ifFalse: [ GRPlatform current terminateProcess: owner ]! !

!WAObject class methodsFor: 'error handling' stamp: 'jf 3/13/2009 16:41'!
defaultErrorClass
	^ WAError! !

!WAObject methodsFor: 'dynamic variables' stamp: 'jf 2/3/2009 14:57'!
requestContext
	"Answer the current WARequestContext instance."

	^ WACurrentRequestContext value! !

WAObject subclass: #WAOpeningConditionalComment
	instanceVariableNames: 'condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAOpeningConditionalComment commentStamp: 'pmm 1/28/2008 07:06' prior: 0!
Opens a WAConditionalComment and encodes the condition.!

!WAOpeningConditionalComment class methodsFor: 'instance creation' stamp: 'pmm 10/11/2006 17:38'!
condition: aString
	^self new
		condition: aString;
		yourself! !

!WAOpeningConditionalComment methodsFor: 'accessing' stamp: 'lr 3/27/2007 11:36'!
condition
	^ condition! !

!WAOpeningConditionalComment methodsFor: 'accessing' stamp: 'pmm 10/11/2006 17:31'!
condition: aString
	condition := aString! !

!WAOpeningConditionalComment methodsFor: 'printing' stamp: 'pmm 11/25/2007 21:53'!
encodeOn: aDocument
	aDocument
		nextPutAll: '<!!--[';
		nextPutAll: self condition;
		nextPutAll: ']>'! !

WAOpeningConditionalComment subclass: #WAOpeningRevealedConditionalComment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document-Elements'!

!WAOpeningRevealedConditionalComment commentStamp: 'pmm 1/28/2008 07:07' prior: 0!
Opens a WARevealedConditionalComment and encodes the condition.!

!WAOpeningRevealedConditionalComment methodsFor: 'printing' stamp: 'pmm 11/25/2007 21:54'!
encodeOn: aDocument
	aDocument
		nextPutAll: '<!!--[';
		nextPutAll: self condition;
		nextPutAll: ']><!!-->'! !

WAObject subclass: #WAPainter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Rendering'!

!WAPainter commentStamp: 'jf 2/13/2009 19:48' prior: 0!
A Painter is an object that renders onto a Document using a Renderer (typically a subclass of WACanvas). The class of the Renderer is specified by #rendererClass.

Subclasses should implement #renderContentOn: to do the actual rendering.

Painters do not store or backtrack state and do not provide call/answer semantics or decorations. They are often created for each request, used, and then discarded. If you want any of the above features, you should use a subclass of WAPresenter or WAComponent.

To cause a Painter to render itself, you should pass it to the #render: message of a Renderer. For example, from within a Component you could do the following:

	renderContentOn: html
		html render: MyPainterSubclass new!

!WAPainter methodsFor: 'visiting' stamp: 'jf 10/22/2008 09:15'!
accept: aVisitor
	aVisitor visitPainter: self! !

!WAPainter methodsFor: 'rendering' stamp: 'jf 9/9/2009 19:21'!
renderContentOn: aRenderer
	"This is the main rendering method of WAPainter. It will be called with an instance of
	the Renderer class returned by #rendererClass whenever this Painter is asked to render
	itself. By convention, implementations of this method that expect a Canvas renderer
	use 'html' as the parameter name."
	
	self subclassResponsibility! !

!WAPainter methodsFor: 'rendering' stamp: 'jf 2/13/2009 19:41'!
renderOn: aRenderer
	"This method allows Painters to be passed into the #render: method of a Renderer.
	It should not normally be overridden. Subclasses should override #renderContentOn:.
	
	DO NOT call this method directly. Instead, pass this Painter as a parameter to the
	#render: method of aRenderer."
	
	self renderWithContext: aRenderer context! !

!WAPainter methodsFor: 'rendering' stamp: 'jf 2/13/2009 19:42'!
renderWithContext: aRenderContext
	"This is the main entry point when attempting to render a Painter.
	It should not normally be overridden. Subclasses should override #renderContentOn:.
	
	You DO NOT normally need to call this method directly. Usually you have an instance
	of a Renderer (e.g. a WARenderCanvas) and can call the #render: method."
	
	aRenderContext visitor visit: self! !

!WAPainter methodsFor: 'rendering' stamp: 'jf 7/24/2009 12:29'!
rendererClass
	"Returns a subclass of WARenderer to use when rendering this Painter."
	
	^ WARenderer default! !

!WAPainter methodsFor: 'updating' stamp: 'lr 9/8/2009 12:40'!
updateRoot: anHtmlRoot
	"Override this method to modify the Root object of a Document while rendering. This
	method is usually called by a WAUpdateRootVisitor.
	
	If you are using Painters within a tree of Presenters/Components, this method will not
	be called unless the Painter is included in the list of children of the Presenter."! !

!WAPainter methodsFor: 'updating' stamp: 'jf 9/5/2009 16:44'!
updateUrl: aUrl
	"Override this method to modify the WAUrl object which will be used as a base URL
	while rendering. This method is usually called by a WAUpdateUrlVisitor.
	
	If you are using Painters within a tree of Presenters/Components, this method will not
	be called unless the Painter is included in the list of children of the Presenter."! !

WAObject subclass: #WAPathConsumer
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandling'!

!WAPathConsumer commentStamp: 'pmm 9/6/2009 22:08' prior: 0!
A WAPathConsumer keeps track of the unconsumed path elements in request handling.

Instance Variables
	path:		<Collection<String>>

path
	- the collection of unconsumed path elements
!

!WAPathConsumer class methodsFor: 'instance creation' stamp: 'pmm 8/31/2009 10:39'!
path: aCollectionOfStrings
	^self basicNew initializeWith: aCollectionOfStrings! !

!WAPathConsumer methodsFor: 'accessing' stamp: 'pmm 8/31/2009 10:47'!
atEnd
	"Answer whether there are any unconsumed path elements left."
	^path isEmpty! !

!WAPathConsumer methodsFor: 'initialize-release' stamp: 'lr 9/4/2009 09:48'!
initializeWith: aCollectionOfStrings
	self initialize.
	path := aCollectionOfStrings! !

!WAPathConsumer methodsFor: 'accessing' stamp: 'pmm 8/31/2009 10:47'!
next
	"Remove the first unconsumed path element and answer it."
	^path removeFirst! !

!WAPathConsumer methodsFor: 'accessing' stamp: 'pmm 9/1/2009 08:48'!
nextIfPresentDo: aOneArgumentBlock
	"Evaluate the given block with #next if not #atEnd."
	self atEnd
		ifFalse: [ aOneArgumentBlock value: self next ]! !

!WAPathConsumer methodsFor: 'accessing' stamp: 'pmm 8/31/2009 10:47'!
peek
	"Answer the first unconsumed path element without removing it."
	^path first! !

!WAPathConsumer methodsFor: 'accessing' stamp: 'jf 9/29/2009 23:40'!
try: aString
	"See if the next element in the stream matches aString.
	If it does, consume the element and return true.
	If it does not or we are at the end of the stream, simply return false."
	
	(self atEnd or: [ (self peek = aString) not ]) ifTrue: [ ^ false ].
	
	self next.
	^ true! !

WAObject subclass: #WAQualifiedValue
	instanceVariableNames: 'value quality'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAQualifiedValue commentStamp: 'pmm 1/4/2008 14:45' prior: 0!
A WAQualifiedValue is an Object with an assigned quality value.

Instance Variables
	quality:		<Float>
	value:		<Object>

quality
	- between 0.0 and 1.0 or Float infinity if no value is given

value
	- the qualified object!

WAQualifiedValue subclass: #WAAccept
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAAccept commentStamp: 'pmm 5/31/2008 23:46' prior: 0!
A WAAccept is a WAQualifiedValue with a value that is an instance of WAMimeType. It represents how much a user agent preferes a certain mime type.!

!WAAccept class methodsFor: 'private' stamp: 'pmm 11/21/2007 21:56'!
valueClass
	^WAMimeType! !

WAQualifiedValue subclass: #WAAcceptCharset
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAAcceptCharset commentStamp: 'pmm 9/10/2008 22:50' prior: 0!
A WAAcceptCharset is a WAQualifiedValue with a value that is an instance of String. It represents how much a user agent preferes a certain character set for the response.!

!WAAcceptCharset class methodsFor: 'private' stamp: 'pmm 9/10/2008 22:51'!
valueClass
	^String! !

WAQualifiedValue subclass: #WAAcceptEncoding
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAAcceptEncoding commentStamp: 'pmm 9/10/2008 22:51' prior: 0!
A WAAcceptCharset is a WAQualifiedValue with a value that is an instance of String. It represents how much a user agent preferes a certain encoding for the response.!

!WAAcceptEncoding class methodsFor: 'private' stamp: 'pmm 9/10/2008 22:51'!
valueClass
	^String! !

WAQualifiedValue subclass: #WAAcceptLanguage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAAcceptLanguage commentStamp: 'pmm 5/31/2008 23:47' prior: 0!
A WAAcceptLanguage is a WAQualifiedValue with a value that is an instance of WALocale. It represents how much a user agent preferes a certain locale.!

!WAAcceptLanguage class methodsFor: 'private' stamp: 'pmm 11/21/2007 21:59'!
valueClass
	^WALocale! !

!WAQualifiedValue class methodsFor: 'instance creation' stamp: 'pmm 8/28/2009 08:33'!
fromString: aString
	^Array streamContents: [ :stream |
		| values |
		values := aString findTokens: ','.
		values do: [ :each |
			| value quality |
			value := self valueClass fromString: (each copyUpTo: $;) trimBoth.
			quality := (each includes: $;)
				ifTrue: [ Float readFrom: ((each copyAfter: $;) copyAfter: $=) readStream ]
				ifFalse: [ 1.0 ].
			stream nextPut: (self value: value quality: quality) ] ]! !

!WAQualifiedValue class methodsFor: 'instance creation' stamp: 'pmm 11/21/2007 21:54'!
value: anObject quality: aFloat
	^self new
		value: anObject;
		quality: aFloat;
		yourself! !

!WAQualifiedValue class methodsFor: 'private' stamp: 'pmm 11/21/2007 21:51'!
valueClass
	self subclassResponsibility! !

!WAQualifiedValue methodsFor: 'comparing' stamp: 'pmm 9/10/2008 23:07'!
<= other
	^self quality <= other quality! !

!WAQualifiedValue methodsFor: 'accessing' stamp: 'pmm 11/21/2007 21:47'!
quality
	^ quality! !

!WAQualifiedValue methodsFor: 'accessing' stamp: 'pmm 11/21/2007 21:48'!
quality: aFloat
	quality := aFloat! !

!WAQualifiedValue methodsFor: 'accessing' stamp: 'pmm 11/21/2007 21:48'!
value
	^ value! !

!WAQualifiedValue methodsFor: 'accessing' stamp: 'pmm 11/21/2007 21:47'!
value: anObject
	value := anObject! !

WAObject subclass: #WARenderContext
	instanceVariableNames: 'visitor actionUrl actionBaseUrl resourceUrl callbacks document properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Rendering'!

!WARenderContext commentStamp: 'jf 2/13/2009 19:55' prior: 0!
A RenderContext provides all the state needed by a Renderer to do its work.

It is a decoupling device between whatever is initiating rendering and the Renderer itself.!

!WARenderContext methodsFor: 'accessing' stamp: 'jf 2/21/2009 18:22'!
absoluteUrlForResource: aString 
	| url |
	aString isNil ifTrue: [ ^ nil ].
	url := self resourceUrl.
	(url isNil or: [ aString includesSubString: '://' ]) ifTrue: [ ^ WAUrl absolute: aString ].
	^ url copy addToPath: aString; yourself! !

!WARenderContext methodsFor: 'accessing' stamp: 'lr 3/9/2009 19:08'!
actionBaseUrl
	"Answer the action URL, that was not modified by #updateUrl:."
	
	^ actionBaseUrl! !

!WARenderContext methodsFor: 'accessing' stamp: 'lr 3/9/2009 19:08'!
actionBaseUrl: aUrl
	actionBaseUrl := aUrl! !

!WARenderContext methodsFor: 'accessing' stamp: 'lr 3/9/2009 19:08'!
actionUrl
	"Answer the action URL that was modified by #updateUrl:."

	^ actionUrl! !

!WARenderContext methodsFor: 'accessing' stamp: 'jf 2/21/2009 17:41'!
actionUrl: aUrl
	actionUrl := aUrl! !

!WARenderContext methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
advanceKey
	self 
		greaseDeprecatedApi: 'WARenderContext>>#advanceKey'
		details: 'Use WACallbackRegistry>>#advanceKey. The callback registry is available from WARenderContext or WARenderCanvas by sending #callbacks.'.
	^ self callbacks advanceKey! !

!WARenderContext methodsFor: 'callbacks' stamp: 'lr 4/19/2006 08:05'!
callbackAt: aString
	^ callbacks at: aString ifAbsent: [ ]! !

!WARenderContext methodsFor: 'accessing' stamp: 'lr 2/14/2006 20:55'!
callbacks
	^ callbacks! !

!WARenderContext methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
callbacksFor: anObject 
	self 
		greaseDeprecatedApi: 'WARenderContext>>#callbacksFor:'
		details: 'Use #callbacks. Callbacks are no longer evaluated in the context of an owning object.'.
	^ self callbacks! !

!WARenderContext methodsFor: 'private' stamp: 'jf 11/3/2008 20:39'!
defaultVisitor
	^ WARenderVisitor context: self! !

!WARenderContext methodsFor: 'initialization' stamp: 'lr 2/20/2009 14:56'!
destroy
	self document destroy.
	document := nil! !

!WARenderContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document
	"Answer the value of document"

	^ document! !

!WARenderContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document: anObject
	"Set the value of document"

	document := anObject! !

!WARenderContext methodsFor: 'accessing' stamp: 'jf 1/23/2009 00:19'!
document: aDocument during: aBlock
	"Set the value of document for the duration of aBlock"
	| previous |
	previous := document.
	[ document := aDocument.
	aBlock value ]
		ensure: [ document := previous ]! !

!WARenderContext methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
increaseKey
	self 
		greaseDeprecatedApi: 'WARenderContext>>#increaseKey'
		details: 'Use WACallbackRegistry>>increaseKey. The callback registry is available from WARenderContext or WARenderCanvas by sending #callbacks.'.
	^ self callbacks increaseKey! !

!WARenderContext methodsFor: 'initialization' stamp: 'lr 12/28/2008 16:15'!
initialize
	super initialize.
	callbacks := WACallbackRegistry new! !

!WARenderContext methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
nextKey
	self 
		greaseDeprecatedApi: 'WARenderContext>>#nextKey'
		details: 'Use WACallbackRegistry>>nextKey. The callback registry is available from WARenderContext or WARenderCanvas by sending #callbacks.'.
	^ self callbacks nextKey! !

!WARenderContext methodsFor: 'copying' stamp: 'jf 2/21/2009 17:42'!
postCopy
	super postCopy.
	visitor := visitor copyForRenderContext: self.
	actionUrl := actionUrl copy.
	resourceUrl := resourceUrl copy.
	properties := properties copy! !

!WARenderContext methodsFor: 'accessing' stamp: 'jf 9/30/2009 00:26'!
properties
	"Answer a property dictionary."
	^ properties ifNil: [ properties := GRSmallDictionary new ]! !

!WARenderContext methodsFor: 'accessing' stamp: 'jf 2/21/2009 17:40'!
resourceUrl
	^ resourceUrl! !

!WARenderContext methodsFor: 'accessing' stamp: 'jf 2/21/2009 17:40'!
resourceUrl: anObject
	resourceUrl := anObject! !

!WARenderContext methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
session
	self 
		greaseDeprecatedApi: 'WARenderContext>>#session'
		details: 'The session is no longer stored in the render context. You can get at the session in the current request context by calling "self session" from any subclass of WAObject.'.
	^ super session! !

!WARenderContext methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
session: aSession 
	self 
		greaseDeprecatedApi: 'WARenderContext>>#session:'
		details: 'The session is no longer stored in the render context.'! !

!WARenderContext methodsFor: 'documents' stamp: 'lr 10/28/2007 14:42'!
urlForDocument: anObject
	^ self urlForDocument: anObject mimeType: nil! !

!WARenderContext methodsFor: 'documents' stamp: 'avi 5/22/2004 18:02'!
urlForDocument: anObject mimeType: mimeString
	^ self urlForDocument: anObject mimeType: mimeString fileName: nil! !

!WARenderContext methodsFor: 'documents' stamp: 'jf 2/9/2009 17:33'!
urlForDocument: anObject mimeType: mimeType fileName: fileName
	| handler |
	handler := (WADocumentHandler
		document: anObject
		mimeType: mimeType
		fileName: fileName).
	^self requestContext registry
		register: handler;
		urlFor: handler! !

!WARenderContext methodsFor: 'accessing' stamp: 'jf 11/3/2008 20:38'!
visitor
	^ visitor ifNil: [ visitor := self defaultVisitor ]! !

!WARenderContext methodsFor: 'accessing' stamp: 'jf 11/3/2008 15:36'!
visitor: anObject
	visitor := anObject! !

WAObject subclass: #WARenderer
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Rendering'!

WARenderer class
	instanceVariableNames: 'default'!

!WARenderer commentStamp: 'jf 2/13/2009 19:57' prior: 0!
A Renderer provides methods for rendering data (typically HTML) onto a Document. It gets all the information needed to do its work from a RenderContext, which is passed in on initialization.

Renderer are typically controlled by a Painter.!

WARenderer class
	instanceVariableNames: 'default'!

!WARenderer class methodsFor: 'instance creation' stamp: 'jf 2/15/2009 21:39'!
builder
	^ WABuilder on: self! !

!WARenderer class methodsFor: 'instance creation' stamp: 'jf 1/23/2009 12:00'!
context: aRenderContext
	^ self basicNew initializeWithContext: aRenderContext; yourself! !

!WARenderer class methodsFor: 'defaults' stamp: 'jf 7/19/2009 18:12'!
default
	^ default ifNil: [ default := WARenderer ]! !

!WARenderer class methodsFor: 'defaults' stamp: 'jf 7/19/2009 18:12'!
default: anObject
	default := anObject! !

!WARenderer class methodsFor: 'defaults' stamp: 'jf 7/19/2009 18:15'!
resetDefault
	WARenderer default: nil! !

!WARenderer class methodsFor: 'defaults' stamp: 'jf 7/19/2009 18:13'!
selectAsDefault
	WARenderer default: self! !

!WARenderer class methodsFor: 'defaults' stamp: 'jf 7/19/2009 18:15'!
unselectAsDefault
	(WARenderer default = self) ifTrue: [ WARenderer resetDefault ]! !

!WARenderer methodsFor: 'public' stamp: 'jf 2/21/2009 18:23'!
absoluteUrlForResource: aString
	"Answer a resource URL for aString. The URL will always be absolute (ie. it will begin
	with a / or a URL scheme like http://. If aString already looks like a URL, an instance
	of WAUrl will be returned for it. If it looks like a path, it will be appended to the
	resource base URL configured in the RenderContext if there is one."

	^ self context absoluteUrlForResource: aString! !

!WARenderer methodsFor: 'public' stamp: 'lr 3/9/2009 19:23'!
actionBaseUrl
	^ self context actionBaseUrl! !

!WARenderer methodsFor: 'public' stamp: 'jf 10/19/2008 03:02'!
actionUrl
	^ self context actionUrl! !

!WARenderer methodsFor: 'accessing' stamp: 'jf 10/19/2008 02:57'!
callbacks
	"Answer the callback registry."

	^ self context callbacks! !

!WARenderer methodsFor: 'accessing' stamp: 'jf 10/19/2008 02:42'!
context
	"Answer the rendering context."

	^ context! !

!WARenderer methodsFor: 'accessing' stamp: 'jf 10/19/2008 02:59'!
document
	^ self context document! !

!WARenderer methodsFor: 'private' stamp: 'jf 2/13/2009 19:36'!
flush
	"Close any open elements and write any remaining data."! !

!WARenderer methodsFor: 'initialization' stamp: 'jf 3/13/2009 18:16'!
initializeWithContext: aRenderContext
	self initialize.
	context := aRenderContext! !

!WARenderer methodsFor: 'public' stamp: 'jf 2/13/2009 19:37'!
nextId
	"Return a identifier string that is unique within this RenderContext."
	
	^ 'id' , self callbacks advanceKey! !

!WARenderer methodsFor: 'public' stamp: 'jf 2/13/2009 19:37'!
peekNextId
	"Return the indentifier string that will be returned by the next call to #nextId."

	^ 'id' , self callbacks nextKey! !

!WARenderer methodsFor: 'public' stamp: 'jf 2/13/2009 19:42'!
render: anObject
	"Render anObject using this Renderer."
	
	anObject renderOn: self! !

!WARenderer methodsFor: 'public' stamp: 'jf 10/19/2008 01:56'!
text: anObject
	"Emit anObject onto the target document."

	self document print: anObject! !

!WARenderer methodsFor: 'public' stamp: 'jf 2/21/2009 10:28'!
urlForAction: aBlock
	"Answer an action URL that will evaluate aBlock when it is requested."

	^ self actionUrl withParameter: (self callbacks store: (WAActionCallback on: aBlock))! !

WAObject subclass: #WARequest
	instanceVariableNames: 'method uri version fields remoteAddress headers cookies body'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WARequest commentStamp: 'pmm 9/6/2009 12:48' prior: 0!
I am a server independent http request object. Instance of me can be aquired through WAObject >> #currentRequest.

Instance Variables
	url:				<WAUrl>
	fields:			<Dictionary<String, Object>>
	headers:		<Dictionary<String, String>>
	nativeRequest:	<Object>
	cookies:			<Collection<WARequestCookie>>
	method:			<String>
	remoteAddress:	<String>
	body:				<String>

url
	- The request url without parameters. For example if the client requested 'http://www.google.com/search?q=seaside' then the contents of url would be '/search'. To get the parameters use #fields. This url is fully decoded. Use the #host method to get the host name. Dependening on the server adapter the #scheme may be 'http' or 'https' if the original request was HTTPS.

headers
	- The header of the HTTP request. This is a Dictionary mapping lowercase strings to other strings.
	
fields
	- The HTTP request parameters. These are the GET and POST parameters in combined into a single dictionary. In general this is a dictionary mapping Strings to Strings. In the case of multivalued paramters or parameters specified in both GET and POST it maps Strings to a Collection of Strings.
	
cookies
	- The collection of cookies (instance of WARequestCookie) the client sent. Note not all clients support all fields. E.g. you might send a path but the client might not return it. Note there can be several cookies with the same key but a different domain or path. See the #cookiesAt: method.
	
nativeRequest
	- The underlying request object of the web server (Kom, Swazoo, OpenTalk, FastCGI, ...). Accessing this makes your code unportable.
	
method
	- the HTTP method, should be upper case. In general only 'GET' and 'POST' are encountered in Seaside. SqueakSource also supports 'PUT'.
	
remoteAddress
	- The IP address of the client. If the server is behind a reverse proxy then this is '127.0.0.1'. This could in theory also be an IPv6 address.
	
body
	- The undecoded, raw request body as a String, may be nil. See the "accessing-body" protocol for accessing it.!

!WARequest class methodsFor: 'configuration' stamp: 'jf 7/31/2009 12:55'!
defaultMethod
	^ 'GET'! !

!WARequest class methodsFor: 'configuration' stamp: 'jf 7/31/2009 12:56'!
defaultUri
	^ '/' seasideUrl! !

!WARequest class methodsFor: 'configuration' stamp: 'jf 7/31/2009 09:33'!
defaultVersion
	^ (Array with: 1 with: 1)! !

!WARequest class methodsFor: 'instance creation' stamp: 'jf 7/31/2009 09:33'!
method: methodString uri: aUrlOrString
	^ self method: methodString uri: aUrlOrString version: self defaultVersion! !

!WARequest class methodsFor: 'instance creation' stamp: 'jf 7/28/2009 23:50'!
method: methodString uri: aUrlOrString version: versionArray
	^ self basicNew
		initializeWithMethod: methodString
			uri: aUrlOrString
			version: versionArray;
		yourself! !

!WARequest class methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
method: methodString url: urlOrString headers: headDict fields: fieldDict cookies: cookieDict 
	self 
		greaseDeprecatedApi: 'WARequest class>>#method:url:headers:fields:cookies:'
		details: 'Create Requests with #method:uri:version: or #method:uri: and use accessors to set other values.'.
	^ (self 
		method: methodString
		uri: urlOrString)
		setHeaders: headDict;
		setFields: fieldDict;
		setCookies: cookieDict;
		yourself! !

!WARequest class methodsFor: 'instance creation' stamp: 'jf 7/31/2009 12:56'!
new
	^ self
		method: self defaultMethod
		uri: self defaultUri
		version: self defaultVersion! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 9/14/2008 11:09'!
accept
	"The Accept request-header field can be used to specify certain media types which are acceptable for the response. Accept headers can be used to indicate that the request is specifically limited to a small set of desired types, as in the case of a request for an in-line image.
	
	Answers an OrderedCollection of WAAccept with the values in the order the client sent them."
	^ WAAccept fromString: (self headerAt: 'accept' ifAbsent: [ ^nil ])! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 9/14/2008 11:10'!
acceptCharset
	"The Accept-Charset request-header field can be used to indicate what character sets are acceptable for the response. This field allows clients capable of understanding more comprehensive or special- purpose character sets to signal that capability to a server which is capable of representing documents in those character sets.
	
	Answers an OrderedCollection of WAAcceptCharset with the values in the order the client sent them."
	^ WAAcceptCharset fromString: (self headerAt: 'accept-charset' ifAbsent: [ ^nil ])! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 9/14/2008 11:11'!
acceptEncoding
	"The Accept-Encoding request-header field is similar to Accept, but restricts the content-codings (section 3.5) that are acceptable in the response.
	
	Answers an OrderedCollection of WAAcceptEncoding with the values in the order the client sent them."
	^ WAAcceptEncoding fromString: (self headerAt: 'accept-encoding' ifAbsent: [ ^nil ])! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 9/14/2008 11:11'!
acceptLanguage
	"The Accept-Language request-header field is similar to Accept, but restricts the set of natural languages that are preferred as a response to the request.
	
	Answers an OrderedCollection of WAAcceptLanguage with the values in the order the client sent them."
	^ WAAcceptLanguage fromString: (self headerAt: 'accept-language' ifAbsent: [ ^nil ])! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 13:37'!
at: key
	^ fields at: key! !

!WARequest methodsFor: 'accessing' stamp: 'JF 5/16/2003 09:40'!
at: key ifAbsent: aBlock
	^ fields at: key ifAbsent: aBlock! !

!WARequest methodsFor: 'accessing' stamp: 'ac 11/12/2005 00:46'!
at: key ifPresent: aBlock
	^ fields at: key ifPresent: aBlock! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 4/22/2008 07:32'!
authorization
	"Answer the basic authorization string from the request. This is the username and the password separated by a colon."
	
	| authorization |
	authorization := self headerAt: 'authorization'.
	^ authorization isNil ifFalse: [ self decodeAuthorization: authorization ]! !

!WARequest methodsFor: 'accessing-body' stamp: 'jf 9/30/2009 00:27'!
bodyDecodeUsing: aCharSetName 
	"Answer the body decoded using the given character set name. Answer nil if there's no body."
	^ body isNil ifFalse: [ (GRCodec forEncoding: aCharSetName) decode: body ]! !

!WARequest methodsFor: 'accessing-body' stamp: 'dkh 9/15/2009 11:41'!
bodyDecoded
	"Answer the body decoded using the character set in the request header. Answer nil if no body is present. Signal an error if not character set is present in the request header."
	| contentType charSet |
	contentType := self contentType.
	charSet := contentType isNil ifFalse: [ contentType charSet ].
	^charSet isNil
		ifTrue: [ WAIllegalStateException signal: 'no content type of request body can not be determined' ]
		ifFalse: [ self bodyDecodeUsing: charSet ]! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 9/6/2009 12:36'!
contentType
	"The Content-Type entity-header field indicates the media type of the entity-body sent to the recipient or, in the case of the HEAD method, the media type that would have been sent had the request been a GET.
	
	Answer an instance of WAMimeType or nil."
	
	| contentType |
	contentType := self headerAt: 'content-type'.
	^ contentType isNil ifFalse: [ WAMimeType fromString: contentType ]! !

!WARequest methodsFor: 'accessing-cookies' stamp: 'lr 2/28/2009 22:44'!
cookieAt: aKey
	"Answer the first found cookie with the given key, there might be several cookies with the name key but different paths, in this case use #cookiesAt:."

	^ self cookies
		detect: [ :each | each key = aKey ]
		ifNone: [ nil ]! !

!WARequest methodsFor: 'accessing-cookies' stamp: 'pmm 3/22/2008 15:23'!
cookies
	^ cookies ifNil: [ #() ]! !

!WARequest methodsFor: 'accessing-cookies' stamp: 'lr 2/28/2009 22:43'!
cookiesAt: aKey
	"Answer all the cookies with the given key."
	
	^ self cookies
		select: [ :each | each key = aKey ]! !

!WARequest methodsFor: 'private' stamp: 'jf 9/30/2009 00:19'!
decodeAuthorization: aString 
	^ GRPlatform current base64Decode: (aString findTokens: ' ') last! !

!WARequest methodsFor: 'initialization' stamp: 'jf 7/31/2009 09:26'!
destroy
	method := uri := version := fields := remoteAddress := headers := cookies := nil! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 12:51'!
fields
	^ fields! !

!WARequest methodsFor: 'accessing' stamp: 'pmm 9/13/2008 11:07'!
headerAt: aKey
	^ self headerAt: aKey ifAbsent: [ nil ]! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:18'!
headerAt: aKey ifAbsent: aBlock
	^ headers at: aKey ifAbsent: aBlock! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:16'!
headers
	^ headers! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/29/2006 07:28'!
host
	^ self headerAt: 'host'! !

!WARequest methodsFor: 'testing' stamp: 'mb 3/31/2006 09:41'!
includesKey: key
	^ fields includesKey: key! !

!WARequest methodsFor: 'initialization' stamp: 'jf 7/31/2009 10:32'!
initializeWithMethod: methodString uri: aUrlOrString version: aVersion
	self initialize.
	method := methodString asUppercase.
	uri := aUrlOrString seasideUrl.
	version := aVersion.
	headers := WAHeaderFields new.
	fields := WAHeaderFields new.
	cookies := OrderedCollection new.
	remoteAddress := nil! !

!WARequest methodsFor: 'testing' stamp: 'lr 1/16/2009 13:45'!
isGet
	^ self method = 'GET'! !

!WARequest methodsFor: 'testing' stamp: 'jf 7/31/2009 10:33'!
isHttp10
	^ version isHttp10! !

!WARequest methodsFor: 'testing' stamp: 'jf 7/31/2009 10:33'!
isHttp11
	^ version isHttp11! !

!WARequest methodsFor: 'testing' stamp: 'lr 1/16/2009 13:45'!
isPost
	^ self method = 'POST'! !

!WARequest methodsFor: 'testing' stamp: 'lr 7/3/2006 09:25'!
isXmlHttpRequest
	^ (self headerAt: 'x-requested-with') = 'XMLHttpRequest'! !

!WARequest methodsFor: 'accessing' stamp: 'ab 8/26/2003 19:33'!
method
	^ method! !

!WARequest methodsFor: 'accessing' stamp: 'lr 2/12/2008 08:09'!
password
	"Answer the password from basic authentication."
	
	| authorization |
	^ (authorization := self authorization) isNil
		ifFalse: [ authorization copyAfter: $: ]! !

!WARequest methodsFor: 'printing' stamp: 'jf 9/30/2009 01:10'!
printOn: aStream 
	super printOn: aStream.
	aStream
		nextPutAll: ' method: ';
		nextPutAll: self method.
	aStream
		nextPutAll: ' uri: ';
		nextPutAll: self uri greaseString.
	aStream nextPutAll: ' version: '.
	self version printOn: aStream! !

!WARequest methodsFor: 'accessing-body' stamp: 'jf 9/7/2009 15:26'!
rawBody
	"Answer the raw, undecoded body. May be nil.
	
	Use #bodyDecoded or #bodyDecodeUsing: to access the decoded contents."
	
	^body! !

!WARequest methodsFor: 'accessing-headers' stamp: 'ac 6/17/2006 16:28'!
referer
	^ self headerAt: 'referer'! !

!WARequest methodsFor: 'accessing' stamp: 'pmm 5/11/2008 22:00'!
remoteAddress
	"answer the IP address of the client (String)"
	^ remoteAddress! !

!WARequest methodsFor: 'initialization' stamp: 'pmm 9/6/2009 13:14'!
setBody: aString
	body := aString! !

!WARequest methodsFor: 'initialization' stamp: 'jf 7/31/2009 09:53'!
setCookies: cookieCollection
	cookies := cookieCollection! !

!WARequest methodsFor: 'initialization' stamp: 'jf 7/31/2009 09:53'!
setFields: fieldDictionary
	fields := fieldDictionary! !

!WARequest methodsFor: 'initialization' stamp: 'jf 7/31/2009 09:53'!
setHeaders: headerDictionary
	headers := headerDictionary! !

!WARequest methodsFor: 'initialization' stamp: 'jf 7/31/2009 09:55'!
setRemoteAddress: addressString
	remoteAddress := addressString! !

!WARequest methodsFor: 'accessing' stamp: 'jf 7/28/2009 23:49'!
uri
	^ uri! !

!WARequest methodsFor: 'accessing' stamp: 'jf 7/28/2009 23:49'!
url
	^ self uri! !

!WARequest methodsFor: 'accessing' stamp: 'lr 2/12/2008 08:09'!
user
	"Answer the username from basic authentication."
	
	| authorization |
	^ (authorization := self authorization) isNil
		ifFalse: [ authorization copyUpTo: $: ]! !

!WARequest methodsFor: 'accessing-headers' stamp: 'pmm 10/12/2006 06:26'!
userAgent
	^ self headerAt: 'user-agent'! !

!WARequest methodsFor: 'accessing' stamp: 'jf 7/28/2009 23:09'!
version
	^ version! !

!WARequest methodsFor: 'accessing' stamp: 'jf 7/31/2009 10:33'!
version: aVersion
	version := aVersion! !

WAObject subclass: #WARequestContext
	instanceVariableNames: 'handlers request response codec consumer properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandling'!

!WARequestContext commentStamp: 'lr 9/13/2008 14:24' prior: 0!
WARequestContext encapsulates all the knowledge that shuld be available while processing a single request. It does not matter if this is a request to a static file, an AJAX request, a long Comet request or a normal Seaside requestion.

The request context is valid only during the request that caused it. It should not be stored. Neither within instance variables, nor within the execution stack so that it might be captured by a continuation. In both cases this might lead to memory leaks.!

!WARequestContext class methodsFor: 'instance creation' stamp: 'lr 1/21/2009 14:58'!
new
	self error: self name , ' has to be instantiated with a request and response object.'! !

!WARequestContext class methodsFor: 'instance creation' stamp: 'jf 9/30/2009 00:27'!
request: aRequest response: aResponse 
	^ self 
		request: aRequest
		response: aResponse
		codec: GRNullCodec new! !

!WARequestContext class methodsFor: 'instance creation' stamp: 'lr 1/12/2009 08:28'!
request: aRequest response: aResponse codec: aCodec
	^ self basicNew initializeWithRequest: aRequest response: aResponse codec: aCodec! !

!WARequestContext methodsFor: 'accessing' stamp: 'jf 7/18/2009 22:29'!
codec
	"Answer the Codec that should be used when preparing strings to be returned in the Response."

	^ codec! !

!WARequestContext methodsFor: 'accessing' stamp: 'pmm 8/31/2009 10:51'!
consumer
	"Answer the path consumer."
	
	^ consumer! !

!WARequestContext methodsFor: 'initialization' stamp: 'jf 7/18/2009 22:38'!
destroy
	"Clear references to objects when the receiver is no longer required. This helps avoid circular references and reduces memory consumption. This method is called by the ServerAdaptor after request processing is finished."
	
	self request destroy.
	self response destroy.
	handlers := request := response := codec := properties := nil! !

!WARequestContext methodsFor: 'accessing-dynamic' stamp: 'jf 7/18/2009 22:36'!
handler
	"Answer the current RequestHandler or nil."

	^ self handlers isEmpty ifFalse: [ self handlers first ]! !

!WARequestContext methodsFor: 'accessing' stamp: 'jf 7/18/2009 22:37'!
handlers
	"Answer an OrderedCollection of RequestHandlers that are processing this request. The list is ordered such that the most recent handler is first in the list."

	^ handlers! !

!WARequestContext methodsFor: 'initialization' stamp: 'pmm 8/31/2009 11:17'!
initializeWithRequest: aRequest response: aResponse codec: aCodec
	self initialize.
	handlers := OrderedCollection new.
	request := aRequest.
	response := aResponse.
	codec := aCodec.
	aRequest isNil ifFalse: [
		consumer := WAPathConsumer path: aRequest url path copy ]! !

!WARequestContext methodsFor: 'accessing-dynamic' stamp: 'jf 9/23/2009 22:12'!
newCookie
	"Create a new cookie. Try to restrict it as much as possible to make stealing it as hard as possible. Some of these restrictions may be too severe for some applications, in which case the sender can relax them."
	
	| cookie baseUrl |
	baseUrl := self handler baseUrl.
	cookie := WACookie new
		path: baseUrl pathString;
		httpOnly: true;
		yourself.
	baseUrl hostname isNil ifFalse: [ cookie domain: baseUrl hostname ].
	baseUrl scheme = 'https' ifTrue: [ cookie secure: true ].
	(baseUrl port notNil and: [ baseUrl hostname notNil ]) ifTrue: [ cookie port: baseUrl port ].
	^ cookie! !

!WARequestContext methodsFor: 'accessing-dynamic' stamp: 'jf 9/23/2009 22:13'!
newDocument
	"Answer a new Document configured to write onto our Response's stream using the
	current Codec. Try to use the Document class specified by the closest Handler
	but fall back on WAHtmlDocument if there is none."
	
	^ (self handler isNil
		ifTrue: [ WAHtmlDocument ]
		ifFalse: [ self handler documentClass ])
			on: self response stream codec: self codec! !

!WARequestContext methodsFor: 'printing' stamp: 'jf 9/30/2009 01:10'!
printOn: aStream 
	super printOn: aStream.
	self request isNil 
		ifTrue: [ aStream nextPutAll: ' url: <nil>' ]
		ifFalse: 
			[ aStream
				nextPutAll: ' url: ';
				print: self request url greaseString ]! !

!WARequestContext methodsFor: 'accessing' stamp: 'jf 9/30/2009 00:26'!
properties
	"Answer a dictionary of request-related properties."
	^ properties ifNil: [ properties := GRSmallDictionary new ]! !

!WARequestContext methodsFor: 'actions' stamp: 'jf 7/24/2009 10:51'!
push: aRequestHandler while: aBlock
	"Push aRequestHandler onto the handler stack while evaluating aBlock."
	
	handlers addFirst: aRequestHandler.
	^ [ WACurrentRequestContext use: self during: aBlock ]
		ensure: [ handlers removeFirst ]! !

!WARequestContext methodsFor: 'accessing-dynamic' stamp: 'jf 7/18/2009 22:34'!
registry
	"Answer the closest Registry or nil."

	^ handlers 
		detect: [ :each | each isRegistry ]
		ifNone: [ nil ]! !

!WARequestContext methodsFor: 'accessing' stamp: 'jf 7/18/2009 22:26'!
request
	"Answer the current Request object."
	
	^ request! !

!WARequestContext methodsFor: 'actions' stamp: 'jf 7/18/2009 22:25'!
respond
	"Signal a desire to end request processing and return the current Response to the user agent."
	
	WAResponseNotification signal! !

!WARequestContext methodsFor: 'actions' stamp: 'jf 7/18/2009 22:26'!
respond: aBlock
	"Evaluate aBlock with the current Response as a parameter and then signal a desire to end request processing and return the Response to the user agent."

	aBlock value: self response.
	self respond! !

!WARequestContext methodsFor: 'accessing' stamp: 'jf 7/18/2009 22:26'!
response
	"Answer the current Response object."
	
	^ response! !

!WARequestContext methodsFor: 'accessing-dynamic' stamp: 'jf 9/23/2009 22:07'!
responseGenerator
	"Answer a ResponseGenerator as configured in the closest RequestHandler."

	^ (self handler isNil 
		ifTrue: [ WAResponseGenerator ]
		ifFalse: [ self handler responseGenerator ])
			on: self! !

WAObject subclass: #WARequestCookie
	instanceVariableNames: 'key path domain ports value version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WARequestCookie commentStamp: 'pmm 6/1/2008 00:04' prior: 0!
A WARequestCookie is the cookie the user agent sent to the server.

Instance Variables
	domain:		<String>
	key:		<String>
	path:		<String>
	ports:		<Collection<Integer>>
	value:		<String>
	version:		<Integer>

domain
	- xxxxx

key
	- xxxxx

path
	- xxxxx

ports
	- xxxxx

value
	- xxxxx

version
	- the version of the cookie specification supported, currently only 1 is known
!

WARequestCookie subclass: #WACookie
	instanceVariableNames: 'expiry secure discard comment commentUrl httpOnly maxAge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WACookie commentStamp: 'pmm 11/17/2008 20:31' prior: 0!
I represent a cookie, a piece of information that is stored on the client and read and writable by the server. I am basically a key/value pair of strings.
You can never trust information in a cookie, the client is free to edit it.
I model only a part of the full cookie specification.

Browser support:
http://www.mnot.net/blog/2006/10/27/cookie_fun

Netscape spec
http://cgi.netscape.com/newsref/std/cookie_spec.html

Cookie spec
http://tools.ietf.org/html/rfc2109

Cookie 2 spec
http://tools.ietf.org/html/rfc2965

HttpOnly
http://msdn2.microsoft.com/en-us/library/ms533046.aspx
https://bugzilla.mozilla.org/show_bug.cgi?id=178993

Compared to WARequestCookie I represent the information that is sent to the user agent.!

!WACookie class methodsFor: 'convenience' stamp: 'pmm 3/22/2008 11:00'!
combine: aCollectionOfCookies using: aOneArgumentBlock
	"combines several cookies into one HTTP header line
	aOneArgumentBlock takes a cookie as an argument and returns a string,
	it is supposed to send one of #oldNetscapeString #rfc2109String #rfc2965String to the argument"
	^String streamContents: [ :stream |
		aCollectionOfCookies
			do: [ :each |
				stream nextPutAll: (aOneArgumentBlock value: each) ]
			separatedBy: [ stream nextPutAll: ', ' ] ]! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:34'!
comment
	^ comment! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:34'!
comment: aString
	comment := aString! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:34'!
commentUrl
	^ commentUrl! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:35'!
commentUrl: aUrl
	commentUrl := aUrl! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:34'!
discard
	^ discard! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:34'!
discard: aBoolean
	discard := aBoolean! !

!WACookie methodsFor: 'api' stamp: 'pmm 3/22/2008 12:37'!
expireIn: aDuration
	"sets the lifetime of the receiver mesaured in a duration"
	self expiry: DateAndTime now + aDuration.
	self maxAge: aDuration asSeconds! !

!WACookie methodsFor: 'api' stamp: 'pmm 4/5/2008 15:44'!
expireInPast
	self maxAge: 0.
	self expiry: (DateAndTime now - (Duration days: 10 hours: 0 minutes: 0 seconds: 0)).! !

!WACookie methodsFor: 'api' stamp: 'pmm 3/22/2008 12:37'!
expireInSeconds: anInteger
	"sets the lifetime of the receiver mesaured in seconds"
	self expiry: (Duration days: 0 hours: 0 minutes: 0 seconds: anInteger).
	self maxAge: anInteger! !

!WACookie methodsFor: 'accessing' stamp: 'avi 5/18/2004 22:53'!
expiry
	^ expiry! !

!WACookie methodsFor: 'accessing' stamp: 'mb 9/22/2006 12:22'!
expiry: aDateTime
	expiry := aDateTime asUTC! !

!WACookie methodsFor: 'private' stamp: 'jf 9/30/2009 00:32'!
expiryString
	^ GRPrinter cookieTimestamp print: expiry! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 22:39'!
httpOnly
	^ httpOnly! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 22:39'!
httpOnly: anObject
	httpOnly := anObject! !

!WACookie methodsFor: 'initialization' stamp: 'pmm 3/3/2008 20:41'!
initialize
	super initialize.
	self secure: false.
	self discard: false.
	self httpOnly: false.
	self version: 1! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 3/22/2008 12:31'!
maxAge
	^ maxAge! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 3/22/2008 12:32'!
maxAge: anInteger
	"Optional.  The Max-Age attribute defines the lifetime of the
	cookie, in seconds.  The delta-seconds value is a decimal non-
	negative integer.  After delta-seconds seconds elapse, the client
	should discard the cookie.  A value of zero means the cookie
	should be discarded immediately."
	maxAge := anInteger! !

!WACookie methodsFor: 'writing' stamp: 'pmm 4/5/2008 14:19'!
oldNetscapeString
	"Serializes the receiver accroding to the orginal Netscape spec.
	This has the broadest browser support but limited features.
	It can not be used with HTTP header combining.
	See class comment for a link to the spec."
	^String streamContents: [ :stream |
		self writeKeyValueQuoted: false on: stream.
		self writeExpiresOn: stream.
		self writePathQuoted: false on: stream.
		self writeDomainQuoted: false on: stream.
		self writeSecureOn: stream.
		self writeHttpOnlyOn: stream ]! !

!WACookie methodsFor: 'writing' stamp: 'pmm 4/5/2008 14:17'!
oldNetscapeStringWithoutKey
	"same as oldNetscapeString except that the key is not included, used for Kom hacks"
	^String streamContents: [ :stream |
		self value isNil ifFalse: [
			stream nextPutAll: self value ].
		self writeExpiresOn: stream.
		self writePathQuoted: false on: stream.
		self writeDomainQuoted: false on: stream.
		self writeSecureOn: stream.
		self writeHttpOnlyOn: stream ]! !

!WACookie methodsFor: 'writing' stamp: 'pmm 4/5/2008 14:20'!
rfc2109String
	"Serializes the receiver accroding to RFC 2109.
	Almost no browser support.
	It can be used with HTTP header combining.
	See class comment for a link to the spec."
	^String streamContents: [ :stream |
		self writeKeyValueQuoted: true on: stream.
		self writeCommentOn: stream.
		self writeMaxAgeOn: stream.
		self writePathQuoted: true on: stream.
		self writeDomainQuoted: true on: stream.
		self writeSecureOn: stream.
		self writeHttpOnlyOn: stream.
		self writeVersionOn: stream ]! !

!WACookie methodsFor: 'writing' stamp: 'pmm 4/5/2008 14:21'!
rfc2965String
	"Serializes the receiver accroding to RFC 2965.
	This has the most features but is only supported in Opera.
	It can be used together with other serialization forms.
	It can be used with HTTP header combining.
	See class comment for a link to the spec."
	^String streamContents: [ :stream |
		self writeKeyValueQuoted: true on: stream.
		self writeCommentOn: stream.
		self writeCommentUrlOn: stream.
		self writeMaxAgeOn: stream.
		self writePathQuoted: true on: stream.
		self writePortsOn: stream.
		self writeDomainQuoted: true on: stream.
		self writeSecureOn: stream.
		self writeHttpOnlyOn: stream.
		self writeDiscardOn: stream.
		self writeVersionOn: stream ]! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:33'!
secure
	^ secure! !

!WACookie methodsFor: 'accessing' stamp: 'pmm 2/20/2008 06:35'!
secure: aBoolean
	secure := aBoolean! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 2/25/2008 07:33'!
write: aString asQuotedStringOn: aStream

	aStream nextPut: $".
	aString do: [ :each |
		each = $" 
			ifTrue: [ aStream nextPutAll: '\"']
			ifFalse: [ aStream nextPut: each ] ].
	aStream nextPut: $"! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 20:25'!
write: aString quoted: aBoolean on: aStream
	aBoolean
		ifTrue: [
			self
				write: aString
				asQuotedStringOn: aStream ]
		ifFalse: [ aStream nextPutAll: aString ]! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 21:18'!
writeCommentOn: aStream
	self comment isNil ifTrue: [ ^self ].
	
	aStream nextPutAll: '; Comment='.
	self
		write: self comment
		asQuotedStringOn: aStream! !

!WACookie methodsFor: 'writing-private' stamp: 'jf 9/30/2009 01:10'!
writeCommentUrlOn: aStream 
	self commentUrl isNil ifTrue: [ ^ self ].
	aStream nextPutAll: '; CommentURL='.
	self 
		write: self commentUrl greaseString
		asQuotedStringOn: aStream! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 20:32'!
writeDiscardOn: aStream
	(self discard notNil and: [ self discard ])
		ifTrue: [ aStream nextPutAll: '; Discard' ]! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 21:02'!
writeDomainQuoted: aBoolean on: aStream
	domain isNil ifTrue: [ ^self ].

	aStream nextPutAll: '; domain='.
	self
		write: self domain
		quoted: aBoolean
		on: aStream! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 20:22'!
writeExpiresOn: aStream
	expiry isNil ifTrue: [ ^self ].

	aStream
		nextPutAll: '; expires=';
		nextPutAll: self expiryString! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 20:42'!
writeHttpOnlyOn: aStream
	self httpOnly
		ifTrue: [ aStream nextPutAll: '; HttpOnly' ]! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 20:26'!
writeKeyValueQuoted: aBoolean on: aStream
	aStream nextPutAll: self key.
	aStream nextPut: $=.
	self
		write: (self value ifNil: [ '' ])
		quoted: aBoolean
		on: aStream! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/22/2008 12:39'!
writeMaxAgeOn: aStream
	maxAge isNil ifTrue: [ ^self ].
	
	aStream nextPutAll: '; Max-Age="'.
	aStream print: maxAge.
	aStream nextPut: $".! !

!WACookie methodsFor: 'writing' stamp: 'pmm 3/3/2008 20:50'!
writeOn: aStream
	aStream nextPutAll: self oldNetscapeString! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 21:02'!
writePathQuoted: aBoolean on: aStream
	path isNil ifTrue: [ ^self ].

	aStream nextPutAll: '; path='.
	self
		write: self path
		quoted: aBoolean
		on: aStream! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 21:24'!
writePortsOn: aStream
	ports isEmptyOrNil ifTrue: [ ^self ].
	
	aStream nextPutAll: '; Port="'.
	self ports
		do: [ :each | aStream print: each ]
		separatedBy: [ aStream nextPut: $, ].
	aStream nextPut: $".! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 20:42'!
writeSecureOn: aStream
	self secure
		ifTrue: [ aStream nextPutAll: '; Secure' ]! !

!WACookie methodsFor: 'writing-private' stamp: 'pmm 3/3/2008 21:00'!
writeVersionOn: aStream
	aStream nextPutAll: '; Version='.
	aStream print: self version! !

!WARequestCookie class methodsFor: 'accessing' stamp: 'pmm 3/22/2008 13:55'!
actions
	^Dictionary new
		at: '$Domain' put: [ :cookie :value | cookie domain: value ];
		at: '$Path' put: [ :cookie :value | cookie path: value ];
		at: '$Port' put: [ :cookie :value | cookie initializePorts: value ];
		yourself! !

!WARequestCookie class methodsFor: 'instance creation' stamp: 'jf 9/30/2009 01:04'!
fromString: aString 
	"Creates an array of cookies from a HTTP Cookie: header value."
	| version tokens cookieLine current |
	cookieLine := aString.
	aString isEmptyOrNil ifTrue: 
		[ ^ #() ].
	tokens := cookieLine findTokens: $;.
	current := nil.
	^ Array streamContents: 
		[ :cookies | 
		tokens do: 
			[ :each | 
			| key value action |
			key := self keyFrom: each.
			value := self valueFrom: each.
			key = '$Version' 
				ifTrue: [ version := value greaseInteger ]
				ifFalse: 
					[ action := self actions 
						at: key
						ifAbsent: [ nil ].
					action isNil 
						ifTrue: 
							[ current := self 
								key: key
								value: value.
							current version: version.
							cookies nextPut: current ]
						ifFalse: 
							[ action 
								value: current
								value: value ] ] ] ]! !

!WARequestCookie class methodsFor: 'instance creation' stamp: 'pmm 2/21/2008 21:30'!
key: keyString value: valueString
	^ self new
		key: keyString;
		value: valueString;
		yourself! !

!WARequestCookie class methodsFor: 'private' stamp: 'YM 8/29/2008 16:05'!
keyFrom: aString
	^(aString copyUpTo: $=) trimBoth! !

!WARequestCookie class methodsFor: 'private' stamp: 'YM 8/29/2008 16:04'!
trimBlanksAndQuotes: aString
	| trimmed |
	trimmed := aString trimBoth.
	^(trimmed size > 2
		and: [ trimmed first = $"
		and: [ trimmed last = $" ] ])
			ifTrue: [ trimmed copyFrom: 2 to: trimmed size - 1 ]
			ifFalse: [ trimmed ]! !

!WARequestCookie class methodsFor: 'private' stamp: 'pmm 2/24/2008 20:39'!
valueFrom: aString
	^(aString includes: $=)
		ifTrue: [ self trimBlanksAndQuotes: (aString copyAfter: $=) ]! !

!WARequestCookie methodsFor: 'comparing' stamp: 'pmm 3/22/2008 15:58'!
= other
	"cookies are identified by the triple name/domain/path"
	^ self species = other species
		and: [ self key = other key
		and: [ self domain = other domain
		and: [ self path = other path ] ] ]! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 06:42'!
domain
	^ domain! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 06:42'!
domain: aString
	domain := aString! !

!WARequestCookie methodsFor: 'comparing' stamp: 'pmm 3/22/2008 15:58'!
hash
	"see #="
	^(self key hash
		bitXor: self domain hash)
		bitXor: self path hash! !

!WARequestCookie methodsFor: 'initialization' stamp: 'jf 9/30/2009 01:04'!
initializePorts: aString 
	self ports: ((aString findTokens: $,) collect: [ :each | each greaseInteger ])! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 21:30'!
key
	^ key! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 21:30'!
key: aString
	key := aString! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 06:42'!
path
	^ path ifNil: ['/']! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 06:42'!
path: aString
	path := aString! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 3/22/2008 20:09'!
port: anInteger
	self ports: (Array with: anInteger)! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 06:43'!
ports
	^ ports! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 06:43'!
ports: aCollection
	ports := aCollection! !

!WARequestCookie methodsFor: 'copying' stamp: 'pmm 4/5/2008 15:22'!
postCopy
	super postCopy.
	ports := ports copy! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 21:31'!
value
	^ value! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 21:31'!
value: aString
	value := aString! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 22:36'!
version
	^ version! !

!WARequestCookie methodsFor: 'accessing' stamp: 'pmm 2/21/2008 22:36'!
version: anInteger
	version := anInteger! !

WAObject subclass: #WARequestFilter
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Filter'!

WARequestFilter subclass: #WAAuthenticationFilter
	instanceVariableNames: 'authenticator realm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Filter'!

!WAAuthenticationFilter commentStamp: 'lr 8/31/2008 13:03' prior: 0!
WAAuthenticationFilter protects a request handler with username and password using the standard HTTP basic authentication. This passes username and password in clear-text, unless used over an encripted HTTPS connection. You should set the authenticator, and object that is able to validate usernames and passwords by implementing #verifyPassword:forUser:.!

!WAAuthenticationFilter methodsFor: 'accessing' stamp: 'lr 8/31/2008 15:05'!
authenticator
	"Answer the object used for authentication. Defaults to the owning handler."

	^ authenticator ifNil: [ self handler ]! !

!WAAuthenticationFilter methodsFor: 'accessing' stamp: 'lr 8/31/2008 12:54'!
authenticator: anObject
	authenticator := anObject! !

!WAAuthenticationFilter methodsFor: 'processing' stamp: 'lr 2/20/2009 11:09'!
handleFiltered: aRequestContext 
	(self verifyRequest: aRequestContext request) 
		ifTrue: [ super handleFiltered: aRequestContext ]
		ifFalse: [
			aRequestContext responseGenerator
				authenticate: self realm;
				respond ]! !

!WAAuthenticationFilter methodsFor: 'accessing' stamp: 'jf 2/13/2009 09:13'!
realm
	"Answer the realm to be displayed in the authentication dialog."
	
	^ realm ifNil: [ realm := 'Seaside' ]! !

!WAAuthenticationFilter methodsFor: 'accessing' stamp: 'lr 8/31/2008 12:54'!
realm: anObject
	realm := anObject! !

!WAAuthenticationFilter methodsFor: 'testing' stamp: 'lr 8/31/2008 13:10'!
verifyRequest: aRequest
	^ self authenticator verifyPassword: aRequest password forUser: aRequest user! !

WARequestFilter subclass: #WAConfiguredRequestFilter
	instanceVariableNames: 'configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Filter'!

!WAConfiguredRequestFilter methodsFor: 'configuration' stamp: 'jf 3/4/2009 10:24'!
configuration
	^ configuration! !

!WAConfiguredRequestFilter methodsFor: 'configuration' stamp: 'jf 3/4/2009 10:23'!
defaultConfiguration
	"Return the configuration (normally a new instance of WAUserConfiguration) to be
	used with the Filter upon initialization."
	
	self subclassResponsibility! !

!WAConfiguredRequestFilter methodsFor: 'initialization' stamp: 'jf 3/4/2009 10:19'!
initialize
	super initialize.
	configuration := self defaultConfiguration! !

WAConfiguredRequestFilter subclass: #WAExceptionFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Filter'!

!WAExceptionFilter methodsFor: 'configuration' stamp: 'jf 3/4/2009 10:22'!
defaultConfiguration
	^ WAUserConfiguration new
		addParent: WAExceptionFilterConfiguration instance;
		yourself! !

!WAExceptionFilter methodsFor: 'configuration' stamp: 'jf 3/4/2009 10:26'!
exceptionHandler
	^ self configuration at: #exceptionHandler! !

!WAExceptionFilter methodsFor: 'processing' stamp: 'jf 3/4/2009 10:53'!
handleFiltered: aRequestContext
	(self exceptionHandler)
		handleExceptionsDuring: [ super handleFiltered: aRequestContext ]
		context: aRequestContext! !

!WAExceptionFilter methodsFor: 'testing' stamp: 'jf 3/4/2009 10:44'!
isExceptionFilter
	^ true! !

WARequestFilter subclass: #WAProtectionFilter
	instanceVariableNames: 'remoteAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Filter'!

!WAProtectionFilter commentStamp: 'lr 8/11/2009 10:56' prior: 0!
The protection filter ensures that the wrapped request handler only accepts requests from the same IP. Do add this filter to a WASession for example to avoid session hijacking, do not add it to static request handlers such as WAApplication or WADispatcher as this might restrict access to the handler if your IP changes.

Note that checking for IP addresses is not bullet proof and should never be used as the sole security measure for a web application as IP addresses can be easily spoofed.!

!WAProtectionFilter methodsFor: 'processing' stamp: 'lr 2/20/2009 11:08'!
handleFiltered: aRequestContext 
	(self verifyRequest: aRequestContext request) 
		ifTrue: [ super handleFiltered: aRequestContext ]
		ifFalse: [ 
			aRequestContext responseGenerator
				forbidden;
				respond ]! !

!WAProtectionFilter methodsFor: 'private' stamp: 'lr 8/31/2008 13:15'!
remoteAddress
	^ remoteAddress! !

!WAProtectionFilter methodsFor: 'private' stamp: 'jf 9/13/2008 16:15'!
remoteAddressFromRequest: aRequest
	remoteAddress ifNil: [
		remoteAddress := aRequest
			headerAt: 'x-forwarded-for'
			ifAbsent: [ aRequest remoteAddress ]	].
	^ aRequest remoteAddress! !

!WAProtectionFilter methodsFor: 'testing' stamp: 'lr 8/31/2008 13:15'!
verifyRequest: aRequest
	^ (self remoteAddressFromRequest: aRequest) = self remoteAddress! !

!WARequestFilter methodsFor: 'copying' stamp: 'lr 9/13/2008 15:08'!
copyTo: aRequestHandler
	^ self copy setNext: (self next copyTo: aRequestHandler)! !

!WARequestFilter methodsFor: 'processing' stamp: 'jf 1/14/2009 09:45'!
handleFiltered: aRequestContext 
	"Pass on the aRequestContext to the next filter or handler. Subclasses might override this method to customize the request and response handling."
	
	self next handleFiltered: aRequestContext! !

!WARequestFilter methodsFor: 'accessing' stamp: 'lr 8/31/2008 12:46'!
handler
	"Answer the owning request handler."

	^ self next handler! !

!WARequestFilter methodsFor: 'initialization' stamp: 'lr 8/31/2008 12:47'!
initialize
	super initialize.
	next := WAValueHolder new! !

!WARequestFilter methodsFor: 'testing' stamp: 'jf 3/4/2009 10:44'!
isExceptionFilter
	^ false! !

!WARequestFilter methodsFor: 'accessing' stamp: 'lr 8/31/2008 12:46'!
next
	"Answer the next filter or request handler."
	
	^ next contents! !

!WARequestFilter methodsFor: 'copying' stamp: 'lr 9/13/2008 15:23'!
postCopy
	super postCopy.
	next := next copy! !

!WARequestFilter methodsFor: 'initialization' stamp: 'lr 9/13/2008 14:55'!
setNext: aFilter
	next contents: aFilter! !

WARequestFilter subclass: #WATrailingSlashFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Filter'!

!WATrailingSlashFilter commentStamp: 'lr 8/11/2009 10:57' prior: 0!
Enforces a trailing slash on the wrapped request handler.!

!WATrailingSlashFilter methodsFor: 'processing' stamp: 'lr 8/11/2009 11:10'!
handleFiltered: aRequestContext
	(self shouldRedirect: aRequestContext)
		ifFalse: [ super handleFiltered: aRequestContext ]
		ifTrue: [ self redirectWithTrailingSlash: aRequestContext ]! !

!WATrailingSlashFilter methodsFor: 'processing' stamp: 'lr 9/5/2009 10:55'!
redirectWithTrailingSlash: aRequestContext 
	aRequestContext responseGenerator
		redirectTo: (aRequestContext request url copy
			takeServerParametersFromRequest: aRequestContext request;
			slash: true;
			yourself);
		respond! !

!WATrailingSlashFilter methodsFor: 'testing' stamp: 'lr 8/11/2009 11:12'!
shouldRedirect: aRequestContext
	^ aRequestContext request isGet and: [ aRequestContext request url slash not ]! !

WARequestFilter subclass: #WATransactionFilter
	instanceVariableNames: 'closed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Filter'!

!WATransactionFilter commentStamp: 'lr 8/11/2009 10:59' prior: 0!
This filter provides the implementation of WAComponent>>#isolate:. It rejects all requests as soon as the filter has been closed.!

!WATransactionFilter methodsFor: 'actions' stamp: 'lr 8/31/2008 16:14'!
close
	closed := true! !

!WATransactionFilter methodsFor: 'processing' stamp: 'lr 2/20/2009 11:09'!
handleFiltered: aRequestContext 
	self isClosed 
		ifFalse: [ super handleFiltered: aRequestContext ]
		ifTrue: [ 
			aRequestContext responseGenerator
				pageExpired;
				respond ]! !

!WATransactionFilter methodsFor: 'initialization' stamp: 'lr 8/31/2008 16:14'!
initialize
	super initialize.
	closed := false! !

!WATransactionFilter methodsFor: 'testing' stamp: 'lr 8/31/2008 16:14'!
isClosed
	^ closed! !

WAObject subclass: #WARequestHandler
	instanceVariableNames: 'filter parent configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandling'!

!WARequestHandler commentStamp: 'jf 7/18/2009 23:36' prior: 0!
WARequestHandler is an abstract class whose subclasses handle http requests. Most of the methods are either empty or return a default value. 

Subclasses must implement the following messages:
	handleFiltered:	process the request

!

WARequestHandler subclass: #WADispatcher
	instanceVariableNames: 'defaultName handlers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandling'!

WADispatcher class
	instanceVariableNames: 'default'!

!WADispatcher commentStamp: 'jf 7/24/2009 09:34' prior: 0!
WADispatcher takes http requests and dispatches them to the correct handler (WAApplication, WAFileHandler, WANotFoundHandler, etc). 

WADispatcher class>>default is the top level dispatcher. When a Seaside application is registered as "foo" the application is added to the top level dispatcher. The application is added to the entryPoints of the dispatcher at the key "foo". If a Seaside application is registered as "bar/foo" then the application isadded to a  dispatcher's entryPoints at the key "foo". That dispatcher is in the top level dispatcher's  entryPoints at the key "bar". 
  
When a http request is received it is sent to WADispatcher class>>default to find the correct handler for the request. If a handler exists for the request is sent to that handler. Otherwise the request is sent to WANotFoundHandler.

The VW port maintains multiple copies of the tree of dispatchers rooted at WADispatcher class>>default. One copy is for each different URL that can reach Seaside (http://..../seaside/go/counter - normal, http://..../counter - SeasideShortPath, http://..../seaside/stream/counter - streaming). 

Instance Variables:
	defaultName	<String>
	entryPoints	<(Dictionary of: WAEntryPoint)>	 the keys are strings, which are the names and URL path segments for the handler at that key
!

WADispatcher class
	instanceVariableNames: 'default'!

!WADispatcher class methodsFor: 'accessing' stamp: 'pmm 9/5/2009 12:58'!
default
	^ default ifNil: [ default := self new ]! !

!WADispatcher class methodsFor: 'accessing' stamp: 'lr 2/10/2008 15:28'!
description
	^ 'Dispatcher'! !

!WADispatcher class methodsFor: 'initialization' stamp: 'jf 9/13/2008 11:08'!
resetDefault
	default := nil.! !

!WADispatcher methodsFor: 'accessing' stamp: 'lr 2/12/2007 20:07'!
defaultName
	^ defaultName! !

!WADispatcher methodsFor: 'accessing' stamp: 'lr 2/10/2008 17:45'!
defaultName: aString
	defaultName := aString! !

!WADispatcher methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
entryPointAt: aString 
	self 
		greaseDeprecatedApi: 'WADispatcher>>#entryPointAt:'
		details: 'Use WADispatcher>>#handlerAt:'.
	^ self handlerAt: aString! !

!WADispatcher methodsFor: 'handling' stamp: 'pmm 9/5/2009 10:51'!
handleFiltered: aRequestContext
	| handlerName consumer |
	consumer := aRequestContext consumer.
	handlerName := consumer atEnd
		ifTrue: [ self defaultName ]
		ifFalse: [ consumer next ].
	self handleFiltered: aRequestContext named: handlerName! !

!WADispatcher methodsFor: 'handling' stamp: 'jf 9/23/2009 23:26'!
handleFiltered: aRequestContext named: aString
	(self 
		handlerAt: aString 
		ifAbsent: [ aRequestContext responseGenerator notFound; respond ])
			handle: aRequestContext! !

!WADispatcher methodsFor: 'accessing' stamp: 'jf 9/23/2009 23:24'!
handlerAt: aString
	^ self
			handlerAt: aString
			with: [ :dispatcher :token |
				dispatcher handlers at: token ] ! !

!WADispatcher methodsFor: 'accessing' stamp: 'jf 9/23/2009 23:30'!
handlerAt: aString ifAbsent: aBlock
	^ self
		handlerAt: (aString
			ifNil: [ ^ aBlock value ])
		with: [ :dispatcher :token |
			dispatcher handlers
				at: token
				ifAbsent: [ ^ aBlock value ] ]! !

!WADispatcher methodsFor: 'accessing' stamp: 'jf 9/23/2009 23:30'!
handlerAt: aString with: aBlock
	^ (aString findTokens: '/') inject: self into: aBlock! !

!WADispatcher methodsFor: 'accessing' stamp: 'jf 9/23/2009 23:31'!
handlers
	^ handlers! !

!WADispatcher methodsFor: 'initialization' stamp: 'jf 9/23/2009 23:31'!
initialize
	super initialize.
	handlers := Dictionary new! !

!WADispatcher methodsFor: 'testing' stamp: 'mb 5/26/2006 08:51'!
isDispatcher
	^ true! !

!WADispatcher methodsFor: 'accessing' stamp: 'jf 9/23/2009 23:33'!
nameOfHandler: aRequestHandler 
	"Answer the name of the given request handler. Signal an error the given handler is not registered in the receiver."
	^ handlers keyAtValue: aRequestHandler! !

!WADispatcher methodsFor: 'copying' stamp: 'jf 9/30/2009 01:34'!
postCopy
	super postCopy.
	handlers := handlers valuesCollect: [ :each | each copy setParent: self; yourself ]! !

!WADispatcher methodsFor: 'registration' stamp: 'jf 9/30/2009 01:33'!
register: aRequestHandler at: aString 
	aString ifNil: [ WAError signal: 'Registration key cannot be nil.' ].
	handlers 
		at: aString
		put: (aRequestHandler setParent: self; yourself).
	^ aRequestHandler! !

!WADispatcher methodsFor: 'registration' stamp: 'jf 9/23/2009 23:32'!
unregister: aRequestHandler
	handlers 
		removeKey: aRequestHandler name
		ifAbsent: [ ^ nil ].
	^ aRequestHandler unregistered! !

!WADispatcher methodsFor: 'accessing' stamp: 'jf 9/27/2009 23:55'!
urlFor: aRequestHandler
	^ self baseUrl
		addToPath: (handlers
			keyAtValue: aRequestHandler
			ifAbsent: [ WAUnregisteredHandlerError signal ]);
		yourself! !

WARequestHandler subclass: #WADocumentHandler
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandling'!

!WADocumentHandler commentStamp: 'jf 7/24/2009 09:32' prior: 0!
WADocumentHandler handles requests for images, text documents and binary files (byte arrays). This class is not normally used directly. A number of WA*Tag classes implement document:mimeType:fileName: which use WADocumentHandler. Given a document, #document:mimeType:fileName: creates a WADocumentHandler for the document, registers the handler with a Registry, and adds the correct url in the tag for the document.

Instance Variables:
	document	<WAMIMEDocument>	MIMEDocument object representing this document and mimeType, generates stream used to write document for the response.!

!WADocumentHandler class methodsFor: 'instance creation' stamp: 'jf 3/13/2009 18:06'!
document: anObject
	^ self basicNew initializeOn: anObject seasideMimeDocument; yourself! !

!WADocumentHandler class methodsFor: 'instance creation' stamp: 'lr 10/18/2008 17:05'!
document: anObject mimeType: aMimeType
	^ self document: anObject mimeType: aMimeType fileName: nil! !

!WADocumentHandler class methodsFor: 'instance creation' stamp: 'lr 10/18/2008 17:04'!
document: anObject mimeType: aMimeType fileName: aString
	^ self document: (anObject seasideMimeDocument
		mimeType: aMimeType;
		fileName: aString;
		yourself)! !

!WADocumentHandler methodsFor: 'comparing' stamp: 'lr 10/18/2008 16:55'!
= anObject
	^ self species = anObject species and: [ self document = anObject document]! !

!WADocumentHandler methodsFor: 'accessing' stamp: 'ab 2/12/2003 13:41'!
document
	^ document! !

!WADocumentHandler methodsFor: 'handling' stamp: 'lr 5/20/2009 20:11'!
handleFiltered: aRequestContext
	aRequestContext respond: [ :response |
		response
			cacheForever;
			document: self document ]! !

!WADocumentHandler methodsFor: 'comparing' stamp: 'lr 10/18/2008 16:55'!
hash
	^ self document hash! !

!WADocumentHandler methodsFor: 'initialization' stamp: 'jf 3/13/2009 18:06'!
initializeOn: aDocument
	self initialize.
	document := aDocument! !

!WADocumentHandler methodsFor: 'copying' stamp: 'lr 10/18/2008 17:01'!
postCopy
	super postCopy.
	document := document copy! !

WARequestHandler subclass: #WAFileHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Libraries'!

WAFileHandler class
	instanceVariableNames: 'default'!

!WAFileHandler commentStamp: 'rew 10/19/2007 10:48' prior: 0!
Seaside serves static files using WALibrary subclasses. WAFileHandler handles all requests for WALibrary files (or methods) for all applications on the Seaside server. WAFileHandler is registered with the default WADispatcher automatically.!

WAFileHandler class
	instanceVariableNames: 'default'!

!WAFileHandler class methodsFor: 'accessing' stamp: 'lr 2/10/2008 19:59'!
default
	^ default! !

!WAFileHandler class methodsFor: 'accessing' stamp: 'jf 9/28/2008 16:27'!
default: aFileHandler
	default := aFileHandler! !

!WAFileHandler class methodsFor: 'accessing' stamp: 'lr 2/10/2008 15:28'!
description
	^ 'File Library'! !

!WAFileHandler methodsFor: 'configuration' stamp: 'jf 11/9/2008 17:45'!
defaultConfiguration
	^ super defaultConfiguration
		removeParent: WARequestHandlingConfiguration instance;
		addParent: WAFileHandlerConfiguration instance;
		yourself! !

!WAFileHandler methodsFor: 'configuration' stamp: 'jf 11/9/2008 17:41'!
fileHandlerListingClass
	^ self preferenceAt: #fileHandlerListingClass! !

!WAFileHandler methodsFor: 'handling' stamp: 'jf 9/1/2009 00:38'!
handleFiltered: aRequestContext
	self responseForContext: aRequestContext! !

!WAFileHandler methodsFor: 'accessing' stamp: 'lr 1/10/2009 16:03'!
libraries
	^ WAFileLibrary allSubclasses! !

!WAFileHandler methodsFor: 'accessing' stamp: 'lr 1/10/2009 16:04'!
libraryAt: aSymbol ifAbsent: aBlock
	^ self libraries 
		detect: [ :each | each handlesFolder: aSymbol ]
		ifNone: aBlock! !

!WAFileHandler methodsFor: 'private' stamp: 'lr 2/20/2009 11:08'!
responseAt: aPath forContext: aRequestContext 
	| libraryClass |
	aPath isEmpty
		ifTrue: [ ^ (self fileHandlerListingClass on: self context: aRequestContext) responseForLibraries ].
	libraryClass := self 
		libraryAt: aPath first asSymbol
		ifAbsent: [ ^ aRequestContext responseGenerator notFound; respond ].
	aPath size > 1 
		ifTrue: [
			libraryClass 
				documentAt: aPath second
				forContext: aRequestContext.
			" won't be executed if a document is found "
			aRequestContext responseGenerator
				notFound;
				respond ]
		ifFalse: [ (self fileHandlerListingClass on: self context: aRequestContext) responseForLibrary: libraryClass default ]! !

!WAFileHandler methodsFor: 'private' stamp: 'mlucas-smith 9/7/2009 19:56'!
responseForContext: aRequestContext
	| libraryClass consumer |
	consumer := aRequestContext consumer.
	consumer atEnd
		ifTrue: [ ^ (self fileHandlerListingClass on: self context: aRequestContext) responseForLibraries ].
	libraryClass := self 
		libraryAt: consumer next asSymbol
		ifAbsent: [ ^ aRequestContext responseGenerator notFound; respond ].
	consumer atEnd
		ifTrue: [
			| listingClass |
			listingClass := (self fileHandlerListingClass on: self context: aRequestContext).
			listingClass responseForLibrary: libraryClass default ]
		ifFalse: [
			libraryClass 
				documentAt: consumer next
				forContext: aRequestContext.
			" won't be executed if a document is found "
			aRequestContext responseGenerator
				notFound;
				respond ]! !

WARequestHandler subclass: #WARegistry
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandling'!

!WARegistry commentStamp: 'jf 7/24/2009 09:36' prior: 0!
WARegistry maintains a set of handlers indexed by a key which it assigns when the handler is registerd. WARegistry checks incoming request URLs for a key and looks for a matching active request handler. If one exists, the request is sent to the proper handler. If not, the request is either a new request (in which case #handleDefaultRequest: is called) or a request to a now-inactive handler (in which case #handleExpiredRequest: is called). These two methods allow subclasses to properly handle these requests.

Subclasses must implement the following messages:
	handleDefaultRequest:
		Handle a request without a session key, ie a new request.
	handlerField
		The URL parameter in which to store the request handler key.

Instance Variables:
	cache - an instance of WACache to hold the stored request handlers
!

!WARegistry class methodsFor: 'initialization' stamp: 'jf 10/27/2008 11:26'!
clearAll
	self allSubInstancesDo: [ :each | each clear ]! !

!WARegistry class methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
clearAllHandlers
	self 
		greaseDeprecatedApi: 'WARegistry class>>#clearAllHandlers'
		details: 'Use #clearAll instead.'.
	^ self clearAll! !

!WARegistry class methodsFor: 'testing' stamp: 'jf 8/27/2009 21:15'!
isAbstract
	^ self name = #WARegistry! !

!WARegistry methodsFor: 'handling-helpers' stamp: 'jf 1/29/2009 21:32'!
addCookieForHandler: aRequestHandler to: aRequestContext
	"Create a new handler key cookie and att it to the response."
	
	aRequestContext response addCookie: 
		(aRequestContext newCookie
			key: self keyCookieName;
			value: (self keyFor: aRequestHandler);
			discard: true;
			comment: 'the Seaside Session Cookie';
			commentUrl: 'http://www.seaside.st/documentation/sessionCookie';
			yourself)! !

!WARegistry methodsFor: 'handling-helpers' stamp: 'jf 1/29/2009 21:33'!
addDeletionOfCookie: aCookie to: aRequestContext
	"Request the deletion of aCookie in the response."

	aRequestContext response deleteCookie: aCookie path: self baseUrl pathString.! !

!WARegistry methodsFor: 'accessing' stamp: 'jf 10/7/2008 18:14'!
cache
	^ cache! !

!WARegistry methodsFor: 'accessing' stamp: 'jf 1/10/2009 18:43'!
cache: aCache
	cache := aCache! !

!WARegistry methodsFor: 'public' stamp: 'jf 1/29/2009 21:34'!
clear
	"Remove all registered handlers."

	self cache clear! !

!WARegistry methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
clearHandlers
	self 
		greaseDeprecatedApi: 'WARegistry>>#clearHandlers'
		details: 'Use #clear.'.
	^ self clear! !

!WARegistry methodsFor: 'handling-helpers' stamp: 'jf 1/29/2009 21:30'!
cookieFromContext: aRequestContext ifAbsent: absentBlock
	"Answer the handler key cookie. If none is found, return the result of evaluating absentBlock.
	There can be several cookies with the correct key so we try to find the one with the most specific path."

	| candidates requestUrl |
	candidates := aRequestContext request cookiesAt: self keyCookieName.
	
	candidates isEmptyOrNil
		ifTrue: [ ^ absentBlock value ].
	candidates size = 1 
		ifTrue: [ ^ candidates first ].
		
	requestUrl := aRequestContext request url.
	candidates := candidates collect: [ :each |
		each -> (each path seasideUrl relativeTo: requestUrl) ].
	
	candidates := candidates reject: [ :each |
		| path |
		path := each value.
		path notEmpty and: [ path first = '..' ] ].

	candidates isEmpty
		ifTrue: [ ^ absentBlock value ].
		
	candidates size > 1
		ifTrue: [
			candidates sort: [ :a :b |
				 a value size <= b value size ] ].
	
	^ candidates first key! !

!WARegistry methodsFor: 'configuration' stamp: 'jf 1/30/2009 11:03'!
defaultConfiguration
	^ super defaultConfiguration
		removeParent: WARequestHandlingConfiguration instance;
		addParent: WARegistryConfiguration instance;
		yourself! !

!WARegistry methodsFor: 'handling-helpers' stamp: 'jf 1/29/2009 20:48'!
dispatch: aRequestContext to: aRequestHandler
	"This method is used by the handling methods to trigger the dispatch of a request
	to the specified handler."
	
	aRequestHandler handle: aRequestContext
! !

!WARegistry methodsFor: 'public' stamp: 'jf 1/29/2009 21:34'!
ensureKeyFor: aRequestHandler
	"Ensure the request handler is registered and returns its key."
	
	^ self keyFor: aRequestHandler ifAbsent: [ self register: aRequestHandler ]! !

!WARegistry methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
ensureKeyForHandler: aRequestHandler 
	self 
		greaseDeprecatedApi: 'WARegistry>>#ensureKeyForHandler:'
		details: 'Use #ensureKeyFor:.'.
	^ self ensureKeyFor: aRequestHandler! !

!WARegistry methodsFor: 'handling-helpers' stamp: 'jf 1/30/2009 12:38'!
handle: aRequestContext registering: aRequestHandler
	"Register a new handler and then dispatch the request to it. A cookie may need
	to be added to the response with the handler's key."
	
	self register: aRequestHandler.
	self useCookies ifTrue: [ self addCookieForHandler: aRequestHandler to: aRequestContext ].
	self dispatch: aRequestContext to: aRequestHandler.! !

!WARegistry methodsFor: 'handling' stamp: 'lr 2/20/2009 11:08'!
handleDefault: aRequestContext 
	"This method is called whenever a request is received with no key specified. This method can be overridden by subclasses to register a new handler to handle the request."
	
	aRequestContext responseGenerator
		notFound;
		respond! !

!WARegistry methodsFor: 'handling' stamp: 'lr 2/20/2009 11:06'!
handleExpired: aRequestContext 
	"This method is called whenever a request is received with a key that does not match a registered handler."
	
	aRequestContext responseGenerator
		expiredKey;
		respond! !

!WARegistry methodsFor: 'handling' stamp: 'jf 9/1/2009 00:37'!
handleFiltered: aRequestContext
	| cookie key handler urlKey |
	urlKey := self urlKeyFromContext: aRequestContext ifAbsent: [ nil ].
	cookie := self useCookies
		ifFalse: [ nil ]
		ifTrue: [ self cookieFromContext: aRequestContext ifAbsent: [ nil ] ].
	key := self keyFromFieldValue: urlKey cookie: cookie.
	key isNil
		ifTrue: [ self handleDefault: aRequestContext ]
		ifFalse: [
			handler := self cache at: key ifAbsent: [ nil ].
			handler isNil
				ifTrue: [
					cookie notNil ifTrue: [ self addDeletionOfCookie: cookie to: aRequestContext ].
					self handleExpired: aRequestContext ]
				ifFalse: [
					((cookie isNil or: [ (cookie value = key) not ]) and: [ self useCookies ])
						ifTrue: [ self addCookieForHandler: handler to: aRequestContext ] ].
					self handleKeyed: aRequestContext with: handler ]! !

!WARegistry methodsFor: 'handling' stamp: 'jf 1/29/2009 20:48'!
handleKeyed: aRequestContext with: aRequestHandler
	"This method is called whenever a request is received with a key that matches
	a registered handler."
	
	self dispatch: aRequestContext to: aRequestHandler! !

!WARegistry methodsFor: 'enumerating' stamp: 'dkh 9/4/2009 06:39'!
handlersDo: aBlock

	self keysAndHandlersDo: [:key :value | aBlock value: value ]! !

!WARegistry methodsFor: 'testing' stamp: 'jf 9/28/2009 01:21'!
hasCookieInContext: aRequestContext
	self cookieFromContext: aRequestContext ifAbsent: [ ^ false ].
	^ true! !

!WARegistry methodsFor: 'initialization' stamp: 'jf 9/18/2008 21:00'!
initialize
	super initialize.
	cache := WACache new! !

!WARegistry methodsFor: 'testing' stamp: 'jf 2/1/2009 22:59'!
isRegistry
	^ true! !

!WARegistry methodsFor: 'handling-helpers' stamp: 'jf 1/29/2009 21:21'!
keyCookieName
	"Returns the key (name) of the key cookie."
	
	^ self keyField! !

!WARegistry methodsFor: 'handling-helpers' stamp: 'jf 1/29/2009 21:21'!
keyField
	"Returns the name of the URL query field used to store the key."
	
	^ '_key'! !

!WARegistry methodsFor: 'public' stamp: 'pmm 1/10/2009 13:46'!
keyFor: aRequestHandler
	^ self
		keyFor: aRequestHandler
		ifAbsent: [ WAUnregisteredHandlerError signal ]! !

!WARegistry methodsFor: 'public' stamp: 'jf 2/6/2009 19:25'!
keyFor: aRequestHandler ifAbsent: absentBlock
	^ (self cache keyAtValue: aRequestHandler) ifNil: [ absentBlock value ]! !

!WARegistry methodsFor: 'handling-helpers' stamp: 'jf 1/29/2009 21:27'!
keyFromFieldValue: aStringOrNil cookie: aCookieOrNil
	"Combine the keys from the URL and cookie.
	If we have a URL key we always use that. If not, we use the cookie if it is present."
	
	aStringOrNil isNil ifFalse: [ ^ aStringOrNil ].
	aCookieOrNil isNil ifFalse: [ ^ aCookieOrNil value ].
	^ nil
	! !

!WARegistry methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
keyOrNilForHandler: aRequestHandler 
	self 
		greaseDeprecatedApi: 'WARegistry>>#keyOrNilForHandler:'
		details: 'Use #keyFor:ifAbsent:.'.
	^ self 
		keyFor: aRequestHandler
		ifAbsent: [ nil ]! !

!WARegistry methodsFor: 'enumerating' stamp: 'dkh 9/4/2009 06:38'!
keysAndHandlersDo: aBlock

	self cache keysAndValuesDo: aBlock! !

!WARegistry methodsFor: 'copying' stamp: 'jf 9/27/2009 22:00'!
postCopy
	super postCopy.
	"Since our handlers are dynamically registered and temporary, it makes
	sense not to copy them."
	cache := cache copyEmpty! !

!WARegistry methodsFor: 'public' stamp: 'jf 9/30/2009 01:34'!
register: aRequestHandler
	^ self cache store: (aRequestHandler setParent: self; yourself)! !

!WARegistry methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
registerRequestHandler: aRequestHandler 
	self 
		greaseDeprecatedApi: 'WARegistry>>#registerRequestHandler:'
		details: 'Use register:.'.
	^ self register: aRequestHandler! !

!WARegistry methodsFor: 'public' stamp: 'jf 10/27/2008 11:12'!
unregister: aRequestHandler
	^ self cache remove: aRequestHandler! !

!WARegistry methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
unregisterRequestHandler: aRequestHandler 
	self 
		greaseDeprecatedApi: 'WARegistry>>#unregisterRequestHandler:'
		details: 'Use #unregister:.'.
	^ self unregister: aRequestHandler! !

!WARegistry methodsFor: 'notifications' stamp: 'jf 10/27/2008 11:24'!
unregistered
	super unregistered.
	self clear! !

!WARegistry methodsFor: 'accessing' stamp: 'pmm 1/10/2009 13:46'!
urlFor: aRequestHandler
	^ self
		urlFor: aRequestHandler
		ifAbsent: [ WAUnregisteredHandlerError signal ]! !

!WARegistry methodsFor: 'accessing' stamp: 'jf 9/28/2009 01:32'!
urlFor: aRequestHandler ifAbsent: absentBlock
	"Return the URL for the given request handler. If the handler is not registered, return
	the result of absentBlock.
	This URL will include the handler's key; if you don't want this, use #baseUrl instead."

	| key url |
	key := self keyFor: aRequestHandler ifAbsent: [ ^ absentBlock value ].
	url := self baseUrl.
	"Another option would be to have the Registry cache the cookie in the request context."
	(self hasCookieInContext: self requestContext)
		ifFalse: [ url addParameter: self keyField value: key ].
		
	^ url! !

!WARegistry methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
urlForRequestHandler: aRequestHandler addHandlerField: aBoolean 
	| key url |
	self 
		greaseDeprecatedApi: 'WARegistry>>#urlForRequestHandler:addHandlerField:'
		details: 'Use #urlFor: or #urlFor:ifAbsent:. In any case where you do not want the handler field, simply use #baseUrl.'.
	key := self ensureKeyForHandler: aRequestHandler.
	url := self baseUrl.
	aBoolean ifTrue: 
		[ url 
			addParameter: self keyField
			value: key ].
	^ url! !

!WARegistry methodsFor: 'handling-helpers' stamp: 'jok 3/12/2009 10:22'!
urlKeyFromContext: aRequestContext ifAbsent: absentBlock
	"Answer the key found in the request URL. If none is found, return the result of evaluating absentBlock.
	In some circumstances, HTTP fields are collections of values. In that case we use the first value."
	
	| keyString |
	keyString := aRequestContext request at: self keyField ifAbsent: [ ^ absentBlock value ].
	^ (keyString isString not and: [ keyString isSequenceable ])
		ifTrue: [ 
			keyString isEmpty
				ifTrue: [ absentBlock value ]
				ifFalse: [ keyString first ] ]
		ifFalse: [ keyString ]! !

!WARegistry methodsFor: 'configuration' stamp: 'jf 1/30/2009 12:36'!
useCookies
	^ self configuration at: #useCookies! !

!WARequestHandler class methodsFor: 'accessing' stamp: 'lr 9/29/2009 22:49'!
concreteSubclasses
	^ self allSubclasses reject: [ :each | each isAbstract ]! !

!WARequestHandler class methodsFor: 'accessing' stamp: 'jf 9/30/2009 01:10'!
description
	^ self name greaseString! !

!WARequestHandler class methodsFor: 'testing' stamp: 'jf 10/2/2009 10:17'!
isAbstract
	^ self name = #WARequestHandler! !

!WARequestHandler methodsFor: 'filters' stamp: 'lr 11/3/2008 21:43'!
addFilter: aFilter
	"Add aFilter to the receiver. Answer the filter added."

	^ self addFilterLast: aFilter! !

!WARequestHandler methodsFor: 'filters' stamp: 'lr 11/3/2008 21:46'!
addFilterFirst: aFilter
	"Add aFilter as the first one in the filter chain. Answer the filter added."

	aFilter setNext: self filter.
	self setFilter: aFilter.
	^ aFilter! !

!WARequestHandler methodsFor: 'filters' stamp: 'lr 11/3/2008 21:46'!
addFilterLast: aFilter
	"Add aFilter as the last one in the filter chain. Answer the filter added."

	| previous current |
	previous := nil.
	current := self filter.
	[ current = self ] whileFalse: [
		previous := current.
		current := current next ].
	aFilter setNext: current.
	previous isNil
		ifTrue: [ self setFilter: aFilter ]
		ifFalse: [ previous setNext: aFilter ].
	^ aFilter! !

!WARequestHandler methodsFor: 'private' stamp: 'jf 9/23/2009 22:10'!
authConfigurationError: aString
	WAAuthConfigurationError signal: aString! !

!WARequestHandler methodsFor: 'accessing' stamp: 'jf 9/27/2009 23:48'!
basePath
	^ self baseUrl pathString! !

!WARequestHandler methodsFor: 'accessing' stamp: 'jf 9/30/2009 01:30'!
baseUrl
	| url |
	
	url := self basicBaseUrl.
	self serverPath isNil ifFalse: [ url parsePath: self serverPath ].
	self serverProtocol isNil ifFalse: [ url scheme: self serverProtocol ].
	self serverHostname isNil ifFalse: [ url hostname: self serverHostname ].
	self serverPort isNil ifFalse: [ url port: self serverPort ].

	^ url! !

!WARequestHandler methodsFor: 'private' stamp: 'jf 9/28/2009 00:17'!
basicBaseUrl
	^ self isRoot
		ifTrue: [ WAUrl new ]
		ifFalse: [ self parent urlFor: self ]! !

!WARequestHandler methodsFor: 'configuration' stamp: 'jf 9/23/2009 21:54'!
charSet
	^ self preferenceAt: #charSet! !

!WARequestHandler methodsFor: 'configuration' stamp: 'jf 9/23/2009 21:53'!
configuration
	^ configuration! !

!WARequestHandler methodsFor: 'configuration' stamp: 'jf 9/23/2009 21:54'!
configuration: aConfiguration
	configuration := aConfiguration! !

!WARequestHandler methodsFor: 'copying' stamp: 'lr 9/13/2008 15:21'!
copyTo: aRequestHandler
	^ aRequestHandler! !

!WARequestHandler methodsFor: 'configuration' stamp: 'jf 9/23/2009 21:54'!
defaultConfiguration
	^ WAUserConfiguration new
		addParent: WARequestHandlingConfiguration instance;
		yourself! !

!WARequestHandler methodsFor: 'deprecated' stamp: 'jf 9/30/2009 01:02'!
description
	self 
		greaseDeprecatedApi: 'WARequestHandler>>#description'
		details: 'Use WARequestHandler class>>#description.'.
	^ self class description! !

!WARequestHandler methodsFor: 'configuration' stamp: 'jf 9/23/2009 21:54'!
documentClass
	^ self preferenceAt: #documentClass! !

!WARequestHandler methodsFor: 'filters-convenience' stamp: 'jf 9/21/2009 00:10'!
exceptionHandler: anExceptionHandlerClass
	| theFilter |
	theFilter := self filters
		detect: [ :ea | ea isExceptionFilter ]
		ifNone: [ self addFilter: WAExceptionFilter new ].
	
	theFilter configuration at: #exceptionHandler put: anExceptionHandlerClass! !

!WARequestHandler methodsFor: 'private-accessing' stamp: 'lr 8/31/2008 13:36'!
filter
	^ filter contents! !

!WARequestHandler methodsFor: 'filters' stamp: 'lr 8/31/2008 15:40'!
filters
	"Answer an ordered colleciton of all filters active in the receiver."
	
	| current result |
	current := self filter.
	result := OrderedCollection new.
	[ current = self ] whileFalse: [
		result add: current.
		current := current next ].
	^ result! !

!WARequestHandler methodsFor: 'handling' stamp: 'jf 1/13/2009 22:06'!
handle: aRequestContext
	"Handle a request described by aRequestContext. Do not override this method; instead subclass #handleFiltered: to allow filters to process the request first."

	aRequestContext push: self while: [ self filter handleFiltered: aRequestContext ]! !

!WARequestHandler methodsFor: 'handling' stamp: 'lr 1/12/2009 20:11'!
handleFiltered: aRequestContext 
	"Handle aRequestContext by either dispatching to a different request handler of by producing a response and singalling the result."

	self subclassResponsibility! !

!WARequestHandler methodsFor: 'filters' stamp: 'lr 8/31/2008 14:07'!
handler
	^ self! !

!WARequestHandler methodsFor: 'initialization' stamp: 'jf 9/23/2009 21:55'!
initialize
	super initialize.
	configuration := self defaultConfiguration.
	filter := WAValueHolder with: self! !

!WARequestHandler methodsFor: 'testing' stamp: 'mb 5/26/2006 08:49'!
isDispatcher
	^ false! !

!WARequestHandler methodsFor: 'testing' stamp: 'jf 2/1/2009 22:58'!
isRegistry
	^ false! !

!WARequestHandler methodsFor: 'testing' stamp: 'jf 9/23/2009 22:17'!
isRoot
	^ self parent isNil! !

!WARequestHandler methodsFor: 'accessing' stamp: 'jf 9/30/2009 01:36'!
name
	^ self isRoot
		ifTrue: [ '' ]
		ifFalse: [ self parent nameOfHandler: self ]! !

!WARequestHandler methodsFor: 'accessing' stamp: 'jf 9/29/2009 23:09'!
parent
	^ parent! !

!WARequestHandler methodsFor: 'enumerating' stamp: 'jf 9/23/2009 22:11'!
parentChildPairsDo: aTwoArgumentBlock
	"Evaluate the given two argument block for all the direct parent-child handler pairs in the handler chain up the receiver."
	self parent isNil ifFalse: [
		self parent parentChildPairsDo: aTwoArgumentBlock.
		aTwoArgumentBlock value: self parent value: self ].! !

!WARequestHandler methodsFor: 'copying' stamp: 'jf 9/29/2009 23:10'!
postCopy
	super postCopy.
	filter := filter copy.
	self setFilter: (self filter copyTo: self).
	configuration := configuration copy.
	parent := nil! !

!WARequestHandler methodsFor: 'configuration' stamp: 'jf 9/23/2009 21:54'!
preferenceAt: aSymbol
	^ self configuration at: aSymbol! !

!WARequestHandler methodsFor: 'configuration' stamp: 'jf 9/23/2009 21:54'!
preferenceAt: aSymbol put: anObject
	^ self configuration at: aSymbol put: anObject! !

!WARequestHandler methodsFor: 'filters' stamp: 'lr 9/13/2008 14:55'!
removeFilter: aFilter
	"Remove aFilter from the receiver. Answer the removed filter or nil."

	| previous current |
	previous := nil.
	current := self filter.
	[ current = self ] whileFalse: [
		current = aFilter ifTrue: [
			previous isNil
				ifTrue: [ self setFilter: current next ]
				ifFalse: [ previous setNext: current next ].
			^ aFilter setNext: nil ].
		previous := current.
		current := current next ].
	^ nil! !

!WARequestHandler methodsFor: 'configuration' stamp: 'jf 9/23/2009 21:54'!
responseGenerator
	^ self preferenceAt: #responseGenerator! !

!WARequestHandler methodsFor: 'configuration' stamp: 'jf 9/23/2009 21:54'!
serverHostname
	^ self preferenceAt: #serverHostname! !

!WARequestHandler methodsFor: 'configuration' stamp: 'jf 9/23/2009 21:54'!
serverPath
	^ self preferenceAt: #serverPath! !

!WARequestHandler methodsFor: 'configuration' stamp: 'jf 9/23/2009 21:54'!
serverPort
	^ self preferenceAt: #serverPort! !

!WARequestHandler methodsFor: 'configuration' stamp: 'jf 9/23/2009 21:54'!
serverProtocol
	^ self preferenceAt: #serverProtocol! !

!WARequestHandler methodsFor: 'private-accessing' stamp: 'lr 9/13/2008 15:21'!
setFilter: aFilter
	filter contents: aFilter! !

!WARequestHandler methodsFor: 'parent/child' stamp: 'jf 9/29/2009 23:10'!
setParent: aRequestHandler
	parent notNil ifTrue: [ parent unregister: self ].
	parent := aRequestHandler! !

!WARequestHandler methodsFor: 'parent/child' stamp: 'jf 9/27/2009 23:27'!
unregister: aRequestHandler
	"Request handlers that act as containers should implement this method to
	remove aRequestHandler from their collections and send #unregistered to
	aRequestHandler. This method is also called by #setParent:."! !

!WARequestHandler methodsFor: 'parent/child' stamp: 'jf 9/29/2009 23:10'!
unregistered
	"This method is called to notify a RequestHandler that it has been removed
	from its container. Subclasses should override to perfrom cleanup actions."
	parent := nil! !

!WARequestHandler methodsFor: 'accessing' stamp: 'jf 9/28/2009 00:06'!
urlFor: aRequestHandler
	"Return the URL for the given request handler, which should be a
	child of the receiver. The default implementation simply returns the
	receiver's baseUrl, but subclasses should override to add a relevant
	paramter or path segment tha identifies the particular chid."

	^ self baseUrl! !

!WARequestHandler methodsFor: 'authentication' stamp: 'jf 9/30/2009 00:19'!
verifyPassword: password forUser: username 
	"This method is called by WAAuthMain to verify the username provided
	in the HTTP request. The default implementation compares them against
	the configuration values provided by WAAuthConfiguration. WAAuthMain
	can also be used by itself if you implement this method in your
	own Application subclass to do something different."
	| loginPref hashPref |
	loginPref := self preferenceAt: #login.
	hashPref := self preferenceAt: #passwordHash.
	loginPref ifNil: 
		[ self authConfigurationError: 'Login not defined. The default authentication method requires a WAAuthConfiguration' ].
	hashPref ifNil: 
		[ self authConfigurationError: 'Password not defined. The default authentication method requires a WAAuthConfiguration' ].
	(username isEmptyOrNil or: [ password isEmptyOrNil ]) ifTrue: [ ^ false ].
	^ loginPref = username and: [ hashPref = (GRPlatform current secureHashFor: password) ]! !

WAObject subclass: #WAResponse
	instanceVariableNames: 'headers cookies status message'
	classVariableNames: 'StatusMessages'
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAResponse commentStamp: 'lr 1/23/2009 09:54' prior: 0!
A WAResponse is an abstract HTTP response objects. It is independent of the used server adapter.

Instance Variables
	status:		<Integer> The HTTP status code.
	message:	<String> The HTTP status message.
	headers:	<WAHeaderFileds> A dictionary with the header fields.
	cookies:		<OrderedCollection> A collection of cookies.
!

WAResponse subclass: #WABufferedResponse
	instanceVariableNames: 'contentsStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WABufferedResponse commentStamp: 'lr 1/23/2009 09:57' prior: 0!
A WABufferedResponse is a concrete implementation of a HTTP response. Its contentsStream is used to represent the body of the message.

Instance Variables
	contentsStream:		<WriteStream> The contents of this message.!

!WABufferedResponse class methodsFor: 'instance creation' stamp: 'jf 9/30/2009 00:19'!
new
	^ self on: GRPlatform current readWriteCharacterStream! !

!WABufferedResponse class methodsFor: 'instance creation' stamp: 'lr 2/7/2009 13:34'!
on: aStream
	^ self basicNew initializeOn: aStream! !

!WABufferedResponse methodsFor: 'streaming' stamp: 'jf 9/30/2009 00:19'!
binary
	"put the response stream into binary mode. For buffered response, 
	 replace the contentStream with a ByteArray based stream."
	contentsStream := GRPlatform current readWriteByteStream! !

!WABufferedResponse methodsFor: 'accessing' stamp: 'lr 1/21/2009 18:28'!
contents
	^ contentsStream contents! !

!WABufferedResponse methodsFor: 'initialization' stamp: 'lr 2/20/2009 14:40'!
destroy
	super destroy.
	contentsStream := nil! !

!WABufferedResponse methodsFor: 'initialization' stamp: 'lr 9/4/2009 10:01'!
initializeOn: aStream
	super initializeOn: aStream.
	contentsStream := aStream! !

!WABufferedResponse methodsFor: 'accessing' stamp: 'lr 1/22/2009 08:40'!
stream
	^ contentsStream! !

!WABufferedResponse methodsFor: 'writing' stamp: 'lr 1/21/2009 18:34'!
writeContentOn: aStream 
	aStream nextPutAll: self contents! !

!WABufferedResponse methodsFor: 'writing' stamp: 'lr 1/22/2009 08:44'!
writeHeadersOn: aStream 
	self 
		headerAt: 'Content-Length'
		put: contentsStream size.
	super writeHeadersOn: aStream! !

!WAResponse class methodsFor: 'initialization' stamp: 'lr 1/16/2009 10:40'!
initialize
	self initializeStatusMessages! !

!WAResponse class methodsFor: 'initialization' stamp: 'lr 1/16/2009 13:47'!
initializeStatusMessages
	StatusMessages := Dictionary new.
	StatusMessages
		at: 100 put: 'Continue';
		at: 101 put: 'Switching Protocols';
		at: 102 put: 'Processing';
		at: 200 put: 'OK';
		at: 201 put: 'Created';
		at: 202 put: 'Accepted';
		at: 203 put: 'Non-Authoritative Information';
		at: 204 put: 'No Content';
		at: 205 put: 'Reset Content';
		at: 206 put: 'Partial Content';
		at: 207 put: 'Multi-Status';
		at: 300 put: 'Multiple Choices';
		at: 301 put: 'Moved Permanently';
		at: 302 put: 'Found';
		at: 303 put: 'See Other';
		at: 304 put: 'Not Modified';
		at: 305 put: 'Use Proxy';
		at: 307 put: 'Temporary Redirect';
		at: 400 put: 'Bad Request';
		at: 401 put: 'Unauthorized';
		at: 402 put: 'Payment Required';
		at: 403 put: 'Forbidden';
		at: 404 put: 'Not Found';
		at: 405 put: 'Method Not Allowed';
		at: 406 put: 'Not Acceptable';
		at: 407 put: 'Proxy Authentication Required';
		at: 408 put: 'Request Timeout';
		at: 409 put: 'Conflict';
		at: 410 put: 'Gone';
		at: 411 put: 'Length Required';
		at: 412 put: 'Precondition Failed';
		at: 413 put: 'Request Entity Too Large';
		at: 414 put: 'Request-URI Too Long';
		at: 415 put: 'Unsupported Media Type';
		at: 416 put: 'Requested Range Not Satisfiable';
		at: 417 put: 'Expectation Failed';
		at: 418 put: 'I''m a teapot';
		at: 422 put: 'Unprocessable Entity';
		at: 423 put: 'Locked';
		at: 424 put: 'Failed Dependency';
		at: 500 put: 'Internal Server Error';
		at: 501 put: 'Not Implemented';
		at: 502 put: 'Bad Gateway';
		at: 503 put: 'Service Unavailable';
		at: 504 put: 'Gateway Timeout';
		at: 505 put: 'HTTP Version Not Supported';
		at: 507 put: 'Insufficient Storage'! !

!WAResponse class methodsFor: 'accessing' stamp: 'lr 1/16/2009 13:47'!
messageForStatus: anInteger
	^ StatusMessages at: anInteger ifAbsent: [ nil ]! !

!WAResponse methodsFor: 'accessing-cookies' stamp: 'lr 1/17/2009 17:19'!
addCookie: aCookie
	"Add the cookie aCookies to the receiver."

	^ self cookies add: aCookie! !

!WAResponse methodsFor: 'convenience-headers' stamp: 'jf 9/30/2009 01:10'!
attachmentWithFileName: aString 
	aString notNil ifTrue: 
		[ self 
			headerAt: 'Content-Disposition'
			put: 'attachment; filename="' , aString greaseString , '"' ]! !

!WAResponse methodsFor: 'status' stamp: 'lr 1/13/2009 08:18'!
authenticationFailed
	"Indicate that the request requires HTTP authentication."
	
	self status: 401! !

!WAResponse methodsFor: 'status' stamp: 'pmm 9/12/2009 21:05'!
badRequest
	"The request could not be understood by the server due to malformed syntax. The client SHOULD NOT repeat the request without modifications."
	
	self status: 400! !

!WAResponse methodsFor: 'convenience-status' stamp: 'jf 9/30/2009 01:10'!
basicAuthenticationRealm: aString 
	self 
		headerAt: 'WWW-Authenticate'
		put: 'Basic realm="' , aString greaseString , '"'.
	self authenticationFailed! !

!WAResponse methodsFor: 'streaming' stamp: 'dkh 9/4/2009 09:09'!
binary
	"put the response stream into binary mode"
	
	self subclassResponsibility! !

!WAResponse methodsFor: 'convenience-caching' stamp: 'lr 1/13/2009 08:43'!
cacheFor: aDuration
	"Configure the receiver to be cached for aDuration."

	self removeHeaderAt: 'Pragma'. "Proxies"
	self headerAt: 'Expires' putDate: DateAndTime now + aDuration. "HTTP 1.0"
	self headerAt: 'Cache-Control' put: 'max-age=' , aDuration asSeconds printString. "HTTP 1.1"! !

!WAResponse methodsFor: 'convenience-caching' stamp: 'lr 1/13/2009 08:45'!
cacheForever
	"Configure the response to be cached by user agents."
	
	self removeHeaderAt: 'Pragma'. "Proxies"
	self headerAt: 'Expires' putDate: self cacheForeverExpiryDate. "HTTP 1.0"
	self removeHeaderAt: 'Cache-Control'. "HTTP 1.1"! !

!WAResponse methodsFor: 'configuration' stamp: 'lr 1/13/2009 08:34'!
cacheForeverExpiryDate
	"Answer the expiry date that should be used if the response should be cached forever.
	
	Note that according to HTTP 1.1 says: To mark a response as 'never expires,' an origin server sends an Expires date approximately one year from the time the response is sent. HTTP/1.1 servers SHOULD NOT send Expires dates more than one year in the future."
	
	^ (DateAndTime now) + (Duration days: 300 hours: 0 minutes: 0 seconds: 0)! !

!WAResponse methodsFor: 'convenience-accessing' stamp: 'lr 1/21/2009 18:37'!
contentType
	^ self headerAt: 'Content-Type' ifAbsent: [ WAMimeType textPlain ]! !

!WAResponse methodsFor: 'convenience-accessing' stamp: 'lr 1/13/2009 09:27'!
contentType: aMimeType
	self headerAt: 'Content-Type' put: aMimeType! !

!WAResponse methodsFor: 'accessing' stamp: 'lr 1/17/2009 17:22'!
cookies
	"Answer the cookies of this response."

	^ cookies! !

!WAResponse methodsFor: 'status' stamp: 'pmm 9/12/2009 21:07'!
created
	"The request has been fulfilled and resulted in a new resource being created."
	
	self status: 201! !

!WAResponse methodsFor: 'accessing-cookies' stamp: 'jf 9/23/2009 22:14'!
deleteCookie: aCookie 
	"Try to get the path from the closest entry point in the context. This path
	is used in case the browser did not provide the path information in the cookie.
	Trouble is, this method may be called in a context where WACurrentRequestContext
	is not defined or where there is no RequestHandler. In this case, we just use nil and
	pray the cookie has path information or was created without any."
	
	| path |
	path := [ self requestContext handler baseUrl pathString ] 
		on: Error
		do: [ :err | nil ].
	self 
		deleteCookie: aCookie
		path: path! !

!WAResponse methodsFor: 'accessing-cookies' stamp: 'pmm 1/23/2009 21:04'!
deleteCookie: aCookie path: aString
	"Delete the cookie in the browser.
	
	The spec sez:
	If a CGI script wishes to delete a cookie, it can do so by returning a cookie with the same name, and an expires time which is in the past. The path and name must match exactly in order for the expiring cookie to replace the valid cookie. This requirement makes it difficult for anyone but the originator of a cookie to delete a cookie.
	
	The trouble is:
	Browsers that follow the Netscape spec don't send path information"
	| cookie |
	cookie := (WACookie 
		key: aCookie key
		value: '')
		path: aCookie path;
		version: aCookie version;
		yourself.
	(aCookie version isNil and: [ aString notNil ]) ifTrue:  [
		"old Netscape cookie with no path information"
		cookie path: aString ].
	cookie expireInPast.
	self addCookie: cookie! !

!WAResponse methodsFor: 'accessing-cookies' stamp: 'pmm 7/12/2008 07:51'!
deleteCookieAt: aKeyString
	"Delete the cookie in the browser. This method is quite unrelyable. Consider using #deleteCookie:"
	self deleteCookie: (WARequestCookie key: aKeyString value: '')! !

!WAResponse methodsFor: 'initialization' stamp: 'lr 2/20/2009 14:40'!
destroy
	headers := cookies := nil! !

!WAResponse methodsFor: 'convenience-caching' stamp: 'lr 1/13/2009 08:45'!
doNotCache
	"Configure the receiver to not be cached at all."
	
	self headerAt: 'Pragma' put: 'no-cache'. "Proxies"
	self headerAt: 'Expires' putDate: self doNotCacheExpiryDate. "HTTP 1.0"
	self headerAt: 'Cache-Control' put: 'no-cache, must-revalidate'. "HTTP 1.1"
	! !

!WAResponse methodsFor: 'configuration' stamp: 'lr 1/13/2009 08:38'!
doNotCacheExpiryDate
	"Answer the expiry date that should be used if the response should not be cached at all."
	
	^ DateAndTime year: 2000 month: 1 day: 1 hour: 0 minute: 0 second: 0! !

!WAResponse methodsFor: 'documents' stamp: 'dkh 9/4/2009 09:07'!
document: aDocument
	| document mimeType |
	document := aDocument seasideMimeDocument.
	self attachmentWithFileName: document fileName.
	mimeType := document mimeType.
	self contentType: mimeType.
	mimeType isBinary
		ifTrue: [ self binary ].
	self nextPutAll: document content! !

!WAResponse methodsFor: 'documents' stamp: 'lr 1/13/2009 09:12'!
document: anObject mimeType: aMimeType
	self document: (anObject seasideMimeDocument 
		mimeType: aMimeType;
		yourself)! !

!WAResponse methodsFor: 'documents' stamp: 'lr 1/13/2009 09:14'!
document: anObject mimeType: aMimeType fileName: aString
	self document: (anObject seasideMimeDocument 
		mimeType: aMimeType;
		fileName: aString;
		yourself)! !

!WAResponse methodsFor: 'status' stamp: 'lr 1/13/2009 08:18'!
forbidden
	"Indicate that the server understood the request but refused to fulfill it."
	
	self status: 403! !

!WAResponse methodsFor: 'status' stamp: 'lr 1/13/2009 08:17'!
found
	"Indicate that the resource reside temporarily under a different URI."
	
	self status: 302! !

!WAResponse methodsFor: 'status' stamp: 'lr 1/13/2009 08:17'!
gone
	"Indicate that the resource is no longer available at the server and no forwarding address is known."
	
	self status: 410! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'lr 1/16/2009 16:38'!
headerAt: aString
	"Answer the header with aString."
	
	^ self headers at: aString! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'jf 9/30/2009 01:10'!
headerAt: aString append: aValue 
	"Appends a response header with aString and aValue. This method allows response headers to have multiple values."
	^ self headers 
		at: aString
		append: aValue greaseString! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'lr 1/17/2009 17:35'!
headerAt: aString ifAbsent: aBlock
	"Answer the header with aString, if none answer the result of evaluating aBlock."
	
	^ self headers at: aString ifAbsent: aBlock! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'lr 1/21/2009 14:53'!
headerAt: aString put: aValue
	"Set a response header with aString and aValue. If the header had already been set, the new value overwrites the previous one."
	
	^ self headers at: aString put: aValue! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'jf 9/30/2009 00:32'!
headerAt: aKeyString putDate: aDateAndTime 
	"Convenience method that sets a response header with aString and aDateAndTime. If the header had already been set, the new value overwrites the previous one."
	^ self 
		headerAt: aKeyString
		put: (GRPrinter httpDate print: aDateAndTime)! !

!WAResponse methodsFor: 'accessing' stamp: 'lr 1/17/2009 17:22'!
headers
	"Answer the headers of this response."
	
	^ headers! !

!WAResponse methodsFor: 'configuration' stamp: 'lr 1/17/2009 17:23'!
httpVersion
	"Answer the HTTP version to be used."

	^ 'HTTP/1.1'! !

!WAResponse methodsFor: 'initialization' stamp: 'lr 1/17/2009 17:21'!
initialize
	super initialize.
	status := 200.
	message := 'OK'.
	headers := WAHeaderFields new.
	cookies := OrderedCollection new! !

!WAResponse methodsFor: 'initialization' stamp: 'lr 9/4/2009 09:44'!
initializeOn: aStream 
	self initialize! !

!WAResponse methodsFor: 'convenience-headers' stamp: 'jf 9/30/2009 01:10'!
inlineWithFileName: aString 
	aString notNil ifTrue: 
		[ self 
			headerAt: 'Content-Disposition'
			put: 'inline; filename="' , aString greaseString , '"' ]! !

!WAResponse methodsFor: 'status' stamp: 'lr 1/13/2009 08:17'!
internalError
	"Indicate an error inside the server which prevented it from fulfilling the request."

	self status: 500! !

!WAResponse methodsFor: 'testing' stamp: 'lr 1/13/2009 09:32'!
isCommitted
	"Answer a boolean indicating if the response header has been committed."
	
	^ false! !

!WAResponse methodsFor: 'convenience-headers' stamp: 'jf 9/30/2009 01:10'!
location: aUrlOrString 
	self 
		headerAt: 'Location'
		put: aUrlOrString greaseString! !

!WAResponse methodsFor: 'accessing' stamp: 'lr 1/16/2009 10:38'!
message
	"Answer the message associated with this response."

	^ message! !

!WAResponse methodsFor: 'status' stamp: 'pmm 9/5/2009 16:42'!
movedPermanently
	"The requested resource has been assigned a new permanent URI and any future references to this resource SHOULD use one of the returned URIs."
	
	self status: 301! !

!WAResponse methodsFor: 'streaming' stamp: 'lr 1/23/2009 18:43'!
nextPutAll: aStringOrByteArray
	"Append the elements of aCollection to the body part of the response."
	
	self stream nextPutAll: aStringOrByteArray! !

!WAResponse methodsFor: 'status' stamp: 'lr 1/13/2009 08:17'!
notFound
	"Indicate that the requested resource is not available."
	
	self status: 404! !

!WAResponse methodsFor: 'status' stamp: 'lr 1/13/2009 08:18'!
notImplemented
	"Indicate the HTTP server does not support the functionality needed to fulfill the request."
	
	self status: 501! !

!WAResponse methodsFor: 'status' stamp: 'pmm 9/2/2009 16:12'!
preconditionFailed
	"The precondition given in one or more of the request-header fields evaluated to false when it was tested on the server. This response code allows the client to place preconditions on the current resource metainformation (header field data) and thus prevent the requested method from being applied to a resource other than the one intended."
	
	self status: 412! !

!WAResponse methodsFor: 'printing' stamp: 'lr 1/16/2009 13:47'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: ' status: '; print: self status.
	aStream nextPutAll: ' message: '; print: self message! !

!WAResponse methodsFor: 'convenience-status' stamp: 'pmm 9/5/2009 16:41'!
redirectTo: aUrlOrString
	self location: aUrlOrString.
	self found! !

!WAResponse methodsFor: 'convenience-status' stamp: 'jf 9/30/2009 01:10'!
refreshAfter: aDuration location: aUrl 
	self 
		headerAt: 'Refresh'
		put: aDuration asSeconds greaseString , '; ' , aUrl greaseString! !

!WAResponse methodsFor: 'accessing-headers' stamp: 'lr 1/16/2009 16:38'!
removeHeaderAt: aString
	"Removes all occurences of the header value aString."

	^ self headers removeKey: aString! !

!WAResponse methodsFor: 'convenience' stamp: 'lr 1/19/2009 18:23'!
respond
	WAResponseNotification signal! !

!WAResponse methodsFor: 'accessing' stamp: 'lr 1/16/2009 10:38'!
status
	"Answer the status code associated with this response."

	^ status! !

!WAResponse methodsFor: 'accessing-status' stamp: 'lr 1/16/2009 10:39'!
status: aNumber
	"Set the status to aNumber and associate the default message."

	self status: aNumber message: (self class messageForStatus: aNumber)! !

!WAResponse methodsFor: 'accessing-status' stamp: 'lr 1/16/2009 10:39'!
status: aNumber message: aString
	"Set the status to aNumber and the message to aString."
	
	status := aNumber.
	message := aString! !

!WAResponse methodsFor: 'accessing' stamp: 'lr 1/22/2009 08:49'!
stream
	"Answer a write stream, this is where contents should be written to."
	
	self subclassResponsibility! !

!WAResponse methodsFor: 'writing' stamp: 'lr 1/13/2009 09:43'!
writeContentOn: aStream
	self subclassResponsibility! !

!WAResponse methodsFor: 'writing' stamp: 'lr 1/22/2009 08:47'!
writeCookiesOn: aStream
	cookies do: [ :each | 
		aStream nextPutAll: 'Set-Cookie: '.
		each writeOn: aStream.
		aStream crlf ]! !

!WAResponse methodsFor: 'writing' stamp: 'jf 9/30/2009 01:10'!
writeHeadersOn: aStream 
	headers keysAndValuesDo: 
		[ :key :value | 
		aStream
			nextPutAll: key;
			nextPutAll: ': ';
			nextPutAll: value greaseString;
			crlf ]! !

!WAResponse methodsFor: 'writing' stamp: 'lr 1/13/2009 09:41'!
writeOn: aStream
	self writeStatusOn: aStream.
	self writeHeadersOn: aStream.
	self writeCookiesOn: aStream.
	aStream crlf.
	self writeContentOn: aStream! !

!WAResponse methodsFor: 'writing' stamp: 'jf 9/30/2009 01:10'!
writeStatusOn: aStream 
	aStream nextPutAll: self httpVersion.
	aStream
		nextPut: $ ;
		nextPutAll: self status greaseString.
	self message isNil ifFalse: 
		[ aStream
			nextPut: $ ;
			nextPutAll: self message ].
	aStream crlf! !

WAResponse subclass: #WAStreamedResponse
	instanceVariableNames: 'committed externalStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAStreamedResponse commentStamp: 'lr 1/23/2009 11:07' prior: 0!
A WAStreamedResponse is a HTTP response that directly writes to an external write stream. This response class is used to implement efficient HTTP response streaming, as it can directly write do the socket while content is still generated.

Instance Variables
	committed:		<Boolean>	Whether the status and header was written to the stream.
	externalStream:		<WriteStream>	The external stream to write to.!

!WAStreamedResponse class methodsFor: 'instance creation' stamp: 'lr 1/13/2009 08:15'!
on: aStream
	^ self basicNew initializeOn: aStream! !

!WAStreamedResponse methodsFor: 'accessing-cookies' stamp: 'lr 1/17/2009 17:20'!
addCookie: aCookie
	self committedCheck.
	^ super addCookie: aCookie! !

!WAStreamedResponse methodsFor: 'streaming' stamp: 'dkh 9/4/2009 09:09'!
binary
	"put the response stream into binary mode"

	externalStream binary! !

!WAStreamedResponse methodsFor: 'private' stamp: 'lr 1/16/2009 16:38'!
committedCheck
	"Raises a singal if this response is already committed."

	self isCommitted 
		ifTrue: [ WAIllegalStateException signal ]! !

!WAStreamedResponse methodsFor: 'initialization' stamp: 'lr 2/20/2009 14:40'!
destroy
	super destroy.
	externalStream := nil! !

!WAStreamedResponse methodsFor: 'public' stamp: 'lr 2/7/2009 16:11'!
flush
	"Flush the status code and header fields, if they haven't been written yet."

	self isCommitted
		ifFalse: [ self writeOn: externalStream ].
	externalStream flush! !

!WAStreamedResponse methodsFor: 'accessing-headers' stamp: 'lr 1/16/2009 16:40'!
headerAt: aString append: aValue
	self committedCheck.
	^ super headerAt: aString append: aValue! !

!WAStreamedResponse methodsFor: 'accessing-headers' stamp: 'lr 1/16/2009 16:39'!
headerAt: aString put: aValue
	self committedCheck.
	^ super headerAt: aString put: aValue! !

!WAStreamedResponse methodsFor: 'initialization' stamp: 'lr 9/4/2009 10:00'!
initializeOn: aStream 
	super initializeOn: aStream.
	committed := false.
	externalStream := aStream! !

!WAStreamedResponse methodsFor: 'testing' stamp: 'lr 1/13/2009 10:00'!
isCommitted
	^ committed! !

!WAStreamedResponse methodsFor: 'accessing-headers' stamp: 'lr 1/16/2009 16:41'!
removeHeaderAt: aString
	self committedCheck.
	^ super removeHeaderAt: aString! !

!WAStreamedResponse methodsFor: 'accessing-status' stamp: 'lr 1/16/2009 16:33'!
status: aNumber message: aString
	self committedCheck.
	super status: aNumber message: aString! !

!WAStreamedResponse methodsFor: 'accessing' stamp: 'lr 1/22/2009 08:41'!
stream
	self flush.
	^ externalStream! !

!WAStreamedResponse methodsFor: 'writing' stamp: 'lr 1/13/2009 10:00'!
writeContentOn: aStream 
	committed := true! !

WAObject subclass: #WAResponseGenerator
	instanceVariableNames: 'requestContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-RequestHandling'!

!WAResponseGenerator commentStamp: 'lr 2/20/2009 11:16' prior: 0!
The response generator configures the response of the provided request context according to the called generation method. This class can be subclassed to provide custom response templates.!

!WAResponseGenerator class methodsFor: 'instance creation' stamp: 'lr 1/12/2009 14:59'!
on: aRequestContext
	^ self basicNew initializeOn: aRequestContext! !

!WAResponseGenerator methodsFor: 'generation' stamp: 'lr 2/15/2009 10:01'!
authenticate: aString
	"Asks for authentication to the domain aString."

	self response basicAuthenticationRealm: aString! !

!WAResponseGenerator methodsFor: 'generation' stamp: 'lr 2/15/2009 09:36'!
expiredKey
	"The session key has expired, redirect the request to the home directory preserving the path as good as possible."

	| url |
	self request isXmlHttpRequest
		ifTrue: [ ^ self forbidden ].
	url := WAUrl new.
	url addAllToPath: self request url path.
	url takeServerParametersFromRequest: self request.
	self request isGet ifTrue: [
		self request fields keysAndValuesDo: [ :key :value |
			(url isSeasideField: key) 
				ifFalse: [ url addParameter: key value: value ] ] ].
	self response redirectTo: url! !

!WAResponseGenerator methodsFor: 'generation' stamp: 'jf 9/30/2009 01:10'!
forbidden
	"The resource is forbidden to access and the request was not processed."
	self response
		forbidden;
		contentType: WAMimeType textPlain;
		nextPutAll: 'Error: you are forbidden to access "';
		nextPutAll: self request url greaseString;
		nextPutAll: '"'! !

!WAResponseGenerator methodsFor: 'initialization' stamp: 'lr 1/12/2009 14:59'!
initializeOn: aRequestContext
	self initialize.
	requestContext := aRequestContext! !

!WAResponseGenerator methodsFor: 'generation' stamp: 'lr 2/15/2009 09:37'!
internalError: anException
	"An internal error occured while processing the request."

	self response 
		internalError;
		contentType: WAMimeType textPlain;
		nextPutAll: 'Internal Error: ';
		nextPutAll: (anException messageText ifNil: [ String new ])! !

!WAResponseGenerator methodsFor: 'generation' stamp: 'jf 9/30/2009 01:10'!
notFound
	"The resource could not be found and the request processing was aborted."
	self response
		notFound;
		contentType: WAMimeType textPlain;
		nextPutAll: self request url greaseString;
		nextPutAll: ' not found'! !

!WAResponseGenerator methodsFor: 'generation' stamp: 'lr 2/15/2009 09:39'!
notImplemented
	"The functionality requested is not implemented and the request processing was aborted."

	self response 
		notImplemented;
		contentType: WAMimeType textPlain;
		nextPutAll: 'Not Implemented'! !

!WAResponseGenerator methodsFor: 'generation' stamp: 'lr 2/15/2009 09:40'!
pageExpired
	"The page is no longer in the cache and the request could not be processed."

	self response
		doNotCache;
		contentType: WAMimeType textPlain;
		nextPutAll: 'This page has expired, please use the back-button to navigate to the last valid page.'! !

!WAResponseGenerator methodsFor: 'generation' stamp: 'lr 2/15/2009 09:41'!
redirectTo: aUrlOrString
	"Redirect to a new location."
	
	self response redirectTo: aUrlOrString! !

!WAResponseGenerator methodsFor: 'generation' stamp: 'jf 9/30/2009 01:10'!
refreshAfter: aDuration location: aUrl message: aString 
	"Show aString for aDuration, then redirect to aUrl."
	self response
		contentType: WAMimeType textPlain;
		refreshAfter: aDuration
			location: aUrl
			message: aString , (String with: Character cr) , 'You are being redirected to ' , aUrl greaseString! !

!WAResponseGenerator methodsFor: 'accessing' stamp: 'lr 2/20/2009 10:39'!
request
	"Answer the current request."

	^ self requestContext request! !

!WAResponseGenerator methodsFor: 'accessing' stamp: 'lr 2/20/2009 10:39'!
requestContext
	"Answer the current request context."

	^ requestContext! !

!WAResponseGenerator methodsFor: 'actions' stamp: 'lr 1/19/2009 18:20'!
respond
	"Tell the current request context to return the response."

	self requestContext respond! !

!WAResponseGenerator methodsFor: 'accessing' stamp: 'lr 2/20/2009 10:39'!
response
	"Answer the current response."

	^ self requestContext response! !

WAObject subclass: #WARoot
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WARoot commentStamp: 'pmm 6/1/2008 00:23' prior: 0!
A WARoot is the root node of a document.
!

WARoot subclass: #WAHtmlRoot
	instanceVariableNames: 'docType htmlAttrs headAttrs bodyAttrs headElements title styles scripts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAHtmlRoot commentStamp: 'jf 1/23/2009 12:04' prior: 0!
A WAHtmlRoot is the root element of an HTML Document (<html>).

Instance Variables
	bodyAttrs:		<WAHtmlAttributes>
	context:			<WARenderContext>
	docType:		<String>
	headAttrs:		<WAHtmlAttributes>
	headElements:	<OrderedCollection<WAHtmlElement>>
	htmlAttrs:		<WAHtmlAttributes>
	scripts:			<Set<String>>
	styles:			<Set<String>>
	title:			<String>

bodyAttrs
	- the attributes of the <body> element

context
	- the context used to render the contents of the <body> element

docType
	- the document type

headAttrs
	- the attributes of the <head> element

headElements
	- the elements inside the <head> section

htmlAttrs
	- the attriebutes of the <html> element

scripts
	- contains the strings returned by WAPresenter >> #script

styles
	- contains the strings returned by WAPresenter >> #style

title
	- the title of the HTML document, the contents of the <title> element
!

!WAHtmlRoot methodsFor: 'adding' stamp: 'lr 10/28/2007 14:42'!
add: aHtmlElement
	"Add a HTML head element to the receiver."

	^ headElements add: aHtmlElement! !

!WAHtmlRoot methodsFor: 'adding' stamp: 'lr 6/2/2008 09:34'!
addScript: aString
	"Include the script aString into the receiver."

	scripts ifNil: [ scripts := Set new ].
	scripts add: aString! !

!WAHtmlRoot methodsFor: 'adding' stamp: 'lr 6/2/2008 09:34'!
addStyle: aString
	"Include the style-sheet aString into the receiver."

	styles ifNil: [ styles := Set new ].
	styles add: aString! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 4/9/2007 10:30'!
base
	^ self add: (WABaseElement root: self)! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 4/9/2007 10:44'!
beXhtml10Strict
	self docType: '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 4/9/2007 10:45'!
beXhtml10Transitional
	self docType: '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 4/9/2007 10:45'!
beXhtml11
	self docType: '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">'! !

!WAHtmlRoot methodsFor: 'accessing-attributes' stamp: 'lr 3/27/2007 12:07'!
bodyAttributes
	^ bodyAttrs ifNil: [ bodyAttrs := WAHtmlAttributes new ]! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'jf 1/23/2009 13:07'!
closeOn: aDocument
	self writeFootOn: aDocument! !

!WAHtmlRoot methodsFor: 'convenience' stamp: 'lr 3/27/2007 13:14'!
contentBase: urlString
	self base url: urlString! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 3/27/2007 12:11'!
docType
	^ docType! !

!WAHtmlRoot methodsFor: 'doctype' stamp: 'lr 10/28/2007 14:42'!
docType: aString
	"Set the document-type of the receiver. The table at http://www.w3.org/TR/2002/NOTE-xhtml-media-types-20020430/ summarizes the recommendation to content authors for labeling their XHTML documents:

Media type				XHTML 1.0 (HTML compatible)	XHTML 1.0 (other)	XHTML Basic / 1.1	XHTML+MathML
text/html				MAY							SHOULD NOT			SHOULD NOT			SHOULD NOT
application/xhtml+xml	SHOULD							SHOULD				SHOULD				SHOULD
application/xml			MAY							MAY				MAY				MAY
text/xml					MAY							MAY				MAY				MAY"

	docType := aString! !

!WAHtmlRoot methodsFor: 'accessing-attributes' stamp: 'lr 3/27/2007 12:07'!
headAttributes
	^ headAttrs ifNil: [ headAttrs := WAHtmlAttributes new ]! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'lr 3/9/2009 21:16'!
headElements
	^ headElements! !

!WAHtmlRoot methodsFor: 'accessing' stamp: 'lr 3/9/2009 21:16'!
headElements: anOrderedCollection
	headElements := anOrderedCollection! !

!WAHtmlRoot methodsFor: 'accessing-attributes' stamp: 'lr 3/27/2007 12:07'!
htmlAttributes
	^ htmlAttrs ifNil: [ htmlAttrs := WAHtmlAttributes new ]! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 10/28/2007 14:42'!
if
	^ WAConditionalComment root: self! !

!WAHtmlRoot methodsFor: 'initialization' stamp: 'jf 8/30/2008 16:31'!
initialize
	super initialize.
	headElements := OrderedCollection new.
	title := docType := String new! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'pmm 4/6/2007 14:18'!
javascript
	^ self script beJavascript; yourself! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 10/28/2007 14:42'!
link
	^ self add: (WALinkElement root: self)! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 4/9/2007 10:30'!
meta
	^ self add: (WAMetaElement root: self)! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'jf 1/23/2009 13:06'!
openOn: aDocument
	self writeHeadOn: aDocument! !

!WAHtmlRoot methodsFor: 'convenience' stamp: 'lr 4/9/2007 10:43'!
redirectTo: aLocationString delay: aNumber
	self meta redirectAfter: aNumber to: aLocationString! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'pmm 11/25/2007 21:57'!
revealedIf
	^ WARevealedConditionalComment root: self! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 10/28/2007 14:42'!
script
	^ self add: (WAScriptElement root: self)! !

!WAHtmlRoot methodsFor: 'elements' stamp: 'lr 3/24/2008 18:06'!
stylesheet
	^ self link beStylesheet; beCss; yourself! !

!WAHtmlRoot methodsFor: 'accessing-properties' stamp: 'lr 3/27/2007 12:11'!
title
	^ title! !

!WAHtmlRoot methodsFor: 'accessing-properties' stamp: 'lr 3/27/2007 12:11'!
title: aString
	title := aString! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 4/9/2007 10:40'!
writeElementsOn: aDocument
	aDocument openTag: 'title'; nextPutAll: title; closeTag: 'title'.
	headElements do: [ :each | aDocument print: each ]! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 3/27/2007 13:20'!
writeFootOn: aDocument
	aDocument closeTag: 'body'.
	aDocument closeTag: 'html'! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'lr 5/16/2007 21:53'!
writeHeadOn: aDocument
	aDocument nextPutAll: docType.
	aDocument openTag: 'html' attributes: htmlAttrs.
	aDocument openTag: 'head' attributes: headAttrs.
	self writeElementsOn: aDocument.
	self writeStylesOn: aDocument.
	self writeScriptsOn: aDocument.
	aDocument closeTag: 'head'.
	aDocument openTag: 'body' attributes: bodyAttrs! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'pmm 4/6/2007 14:18'!
writeScriptsOn: aDocument
	scripts ifNil: [ ^ self ].
	scripts do: [ :each |
		aDocument print: ((WAScriptElement root: self)
			beJavascript;
			document: each;
			yourself) ]! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'pmm 4/6/2007 14:18'!
writeStylesOn: aDocument
	styles ifNil: [ ^ self ].
	styles do: [ :each |
		aDocument print: ((WALinkElement root: self)
			beStylesheet; beCss;
			document: each;
			yourself) ]! !

!WARoot class methodsFor: 'instance creation' stamp: 'jf 1/23/2009 13:19'!
context: aRenderContext
	^ self new setContext: aRenderContext! !

!WARoot methodsFor: 'accessing' stamp: 'jf 2/21/2009 18:25'!
absoluteUrlForResource: aString
	^ self context absoluteUrlForResource: aString! !

!WARoot methodsFor: 'writing' stamp: 'jf 1/23/2009 13:06'!
closeOn: aDocument! !

!WARoot methodsFor: 'accessing' stamp: 'jf 1/23/2009 13:19'!
context
	^ context! !

!WARoot methodsFor: 'writing' stamp: 'jf 1/23/2009 13:05'!
openOn: aDocument! !

!WARoot methodsFor: 'initialization' stamp: 'jf 1/23/2009 13:19'!
setContext: aRenderContext
	context := aRenderContext! !

WARoot subclass: #WAXmlRoot
	instanceVariableNames: 'charSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Document'!

!WAXmlRoot class methodsFor: 'accessing' stamp: 'pmm 9/20/2009 14:13'!
defaultCharSet
	^ 'UTF-8'! !

!WAXmlRoot methodsFor: 'accessing' stamp: 'jf 1/23/2009 18:40'!
charSet
	charSet isNil ifTrue: [
		charSet := self class defaultCharSet ].
	^charSet! !

!WAXmlRoot methodsFor: 'accessing' stamp: 'jf 1/23/2009 18:40'!
charSet: aString
	charSet := aString! !

!WAXmlRoot methodsFor: 'writing' stamp: 'jf 1/23/2009 18:38'!
openOn: aDocument
	self writePreambleOn: aDocument! !

!WAXmlRoot methodsFor: 'writing' stamp: 'jf 1/23/2009 18:36'!
writePreambleOn: aDocument
	aDocument nextPutAll: '<?xml version="1.0" encoding="'.
	aDocument nextPutAll: self charSet.
	aDocument nextPutAll: '"?>'! !

WAObject subclass: #WAServerAdaptor
	instanceVariableNames: 'manager port requestHandler codec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Server'!

!WAServerAdaptor commentStamp: 'pmm 6/1/2008 00:14' prior: 0!
A WAServer is the abstract base class for all servers. Actual servers do not have to subclass it but have to support the protocol:
 - #codec
 - #usesSmalltalkEncoding

Instance Variables
	codec:		<WACodec>

codec
	- the codec used for response conversion from characters to bytes!

!WAServerAdaptor class methodsFor: 'testing' stamp: 'jf 1/4/2009 22:17'!
isAbstract
	^ self name = #WAServerAdaptor! !

!WAServerAdaptor class methodsFor: 'instance creation' stamp: 'jf 10/30/2008 16:14'!
manager: aServerManager
	^ aServerManager register: 
		(self basicNew
			initializeWithManager: aServerManager;
			yourself)! !

!WAServerAdaptor class methodsFor: 'instance creation' stamp: 'yann.monclair 9/5/2009 18:01'!
new
	^ self manager: WAServerManager default! !

!WAServerAdaptor class methodsFor: 'instance creation' stamp: 'jf 3/17/2009 14:29'!
port: anInteger
	^ self new
		port: anInteger;
		yourself! !

!WAServerAdaptor methodsFor: 'private' stamp: 'jf 10/30/2008 13:28'!
basicStart
	self subclassResponsibility! !

!WAServerAdaptor methodsFor: 'private' stamp: 'jf 10/30/2008 13:29'!
basicStop
	self subclassResponsibility! !

!WAServerAdaptor methodsFor: 'testing' stamp: 'jf 1/4/2009 22:04'!
canStart
	^ self manager canStart: self! !

!WAServerAdaptor methodsFor: 'testing' stamp: 'jf 1/4/2009 22:03'!
canStop
	^ self manager canStop: self! !

!WAServerAdaptor methodsFor: 'accessing' stamp: 'jf 10/31/2008 09:12'!
codec
	^ codec! !

!WAServerAdaptor methodsFor: 'accessing' stamp: 'lr 2/7/2009 10:01'!
codec: aCodec
	codec := aCodec! !

!WAServerAdaptor methodsFor: 'converting' stamp: 'lr 2/7/2009 15:06'!
contextFor: aNativeRequest
	"Answer a request context for aNativeRequest."

	^ WARequestContext
		request: (self requestFor: aNativeRequest)
		response: (self responseFor: aNativeRequest)
		codec: self codec! !

!WAServerAdaptor methodsFor: 'defaults' stamp: 'jf 9/30/2009 00:27'!
defaultCodec
	^ GRNullCodec new! !

!WAServerAdaptor methodsFor: 'defaults' stamp: 'jf 10/29/2008 16:54'!
defaultPort
	^ 8080! !

!WAServerAdaptor methodsFor: 'defaults' stamp: 'jf 10/31/2008 09:08'!
defaultRequestHandler
	^ WADispatcher default! !

!WAServerAdaptor methodsFor: 'processing' stamp: 'lr 2/7/2009 10:42'!
handle: aRequestContext
	"Handle the basic request-response loop."

	self handleRequest: aRequestContext.
	self handlePadding: aRequestContext! !

!WAServerAdaptor methodsFor: 'processing' stamp: 'jf 2/15/2009 22:02'!
handlePadding: aRequestContext
	"If you create an error page that's too small, Microsoft Internet Explorer will display its own error page that includes a link to the MSN network search engine rather than your own error page. See <http://www.404-error-page.com/404-error-page-too-short-problem-microsoft-ie.shtml> for details."
	
	| size |
	size := aRequestContext response stream size.
	^ (size < 512 and: [ #(400 403 404 405 406 408 409 410 500 501 505) includes: aRequestContext response status ])
		ifTrue: [ aRequestContext response nextPutAll: (String new: (512 - size) withAll: $ ) ]! !

!WAServerAdaptor methodsFor: 'processing' stamp: 'lr 2/7/2009 10:49'!
handleRequest: aRequestContext
	"Pass the request context to the appropriate request handler."
	
	[ self requestHandler handle: aRequestContext ]
		on: WAResponseNotification
		do: [ :n | "got a response" ]! !

!WAServerAdaptor methodsFor: 'initialization' stamp: 'lr 2/16/2009 09:42'!
initialize
	super initialize.
	codec := self defaultCodec.
	port := self defaultPort.! !

!WAServerAdaptor methodsFor: 'initialization' stamp: 'lr 2/16/2009 09:42'!
initializeWithManager: aServerManager
	self initialize.
	manager := aServerManager! !

!WAServerAdaptor methodsFor: 'testing' stamp: 'jf 10/30/2008 10:36'!
isRunning
	self subclassResponsibility! !

!WAServerAdaptor methodsFor: 'testing' stamp: 'jf 10/30/2008 10:36'!
isStarting
	self subclassResponsibility! !

!WAServerAdaptor methodsFor: 'testing' stamp: 'jf 10/30/2008 10:36'!
isStopped
	self subclassResponsibility! !

!WAServerAdaptor methodsFor: 'testing' stamp: 'jf 10/30/2008 10:36'!
isStopping
	self subclassResponsibility! !

!WAServerAdaptor methodsFor: 'starting/stopping' stamp: 'jf 10/30/2008 13:29'!
kill
	self basicStop! !

!WAServerAdaptor methodsFor: 'accessing-readonly' stamp: 'jf 10/30/2008 16:01'!
manager
	^ manager! !

!WAServerAdaptor methodsFor: 'accessing' stamp: 'jf 10/31/2008 09:12'!
port
	^ port! !

!WAServerAdaptor methodsFor: 'accessing' stamp: 'jf 10/29/2008 16:09'!
port: anObject
	port := anObject! !

!WAServerAdaptor methodsFor: 'processing' stamp: 'lr 2/20/2009 14:22'!
process: aNativeRequest
	"Process aNativeRequest by converting to a request context, handling the request, and converting the request context back to a native response. Make sure to release the context after processing, to help the garbage collector and avoid having large streams and sockets hanging around if people still refer to the obsolete request context."

	| context |
	context := self contextFor: aNativeRequest.
	^ [ self handle: context; responseFrom: context ]
		ensure: [ context destroy ]! !

!WAServerAdaptor methodsFor: 'converting-request' stamp: 'lr 2/16/2009 20:33'!
requestAddressFor: aNativeRequest
	self subclassResponsibility! !

!WAServerAdaptor methodsFor: 'converting-request' stamp: 'pmm 9/6/2009 13:12'!
requestBodyFor: aNativeRequest
	"Answer the undecoded request body as a String."
	
	self subclassResponsibility! !

!WAServerAdaptor methodsFor: 'converting-request' stamp: 'lr 2/16/2009 20:33'!
requestCookiesFor: aNativeRequest
	self subclassResponsibility! !

!WAServerAdaptor methodsFor: 'converting-request' stamp: 'lr 2/16/2009 20:33'!
requestFieldsFor: aNativeRequest
	self subclassResponsibility! !

!WAServerAdaptor methodsFor: 'converting' stamp: 'dkh 9/5/2009 08:38'!
requestFor: aNativeRequest
	"Answer a request object for aNativeRequest."

	^ (WARequest
		method: (self requestMethodFor: aNativeRequest)
		uri: (self requestUrlFor: aNativeRequest)
		version: (self requestVersionFor: aNativeRequest))
			setHeaders: (self requestHeadersFor: aNativeRequest);
			setFields: (self requestFieldsFor: aNativeRequest);
			setBody: (self requestBodyFor: aNativeRequest);
			setCookies: (self requestCookiesFor: aNativeRequest);
			setRemoteAddress: (self requestAddressFor: aNativeRequest);
			yourself! !

!WAServerAdaptor methodsFor: 'accessing' stamp: 'jf 10/31/2008 09:09'!
requestHandler
	"We don't set the instvar here, if nil, because the default request handler
	may change over time and we want to keep using the current default if
	the user hasn't specified one."
	^ requestHandler ifNil: [ self defaultRequestHandler ]! !

!WAServerAdaptor methodsFor: 'accessing' stamp: 'jf 10/29/2008 15:21'!
requestHandler: aRequestHandler
	requestHandler := aRequestHandler! !

!WAServerAdaptor methodsFor: 'converting-request' stamp: 'lr 2/16/2009 20:33'!
requestHeadersFor: aNativeRequest
	self subclassResponsibility! !

!WAServerAdaptor methodsFor: 'converting-request' stamp: 'lr 2/16/2009 20:33'!
requestMethodFor: aNativeRequest
	self subclassResponsibility! !

!WAServerAdaptor methodsFor: 'converting-request' stamp: 'lr 2/16/2009 20:33'!
requestUrlFor: aNativeRequest
	self subclassResponsibility! !

!WAServerAdaptor methodsFor: 'converting-request' stamp: 'jf 7/31/2009 09:57'!
requestVersionFor: aNativeRequest
	self subclassResponsibility! !

!WAServerAdaptor methodsFor: 'converting' stamp: 'lr 2/7/2009 15:06'!
responseFor: aNativeRequest
	"Answer a response object for aNativeRequest."

	^ WABufferedResponse on: (self codec encoderFor: (WriteStream on: String new))! !

!WAServerAdaptor methodsFor: 'converting' stamp: 'lr 2/7/2009 10:47'!
responseFrom: aRequestContext
	"Answer a native response from aRequestContext."

	self subclassResponsibility! !

!WAServerAdaptor methodsFor: 'starting/stopping' stamp: 'jf 10/30/2008 16:02'!
restart
	self manager restart: self! !

!WAServerAdaptor methodsFor: 'private' stamp: 'jf 10/30/2008 12:50'!
shutDown! !

!WAServerAdaptor methodsFor: 'starting/stopping' stamp: 'jf 10/30/2008 16:02'!
start
	self manager start: self! !

!WAServerAdaptor methodsFor: 'private' stamp: 'jf 10/30/2008 12:50'!
startUp! !

!WAServerAdaptor methodsFor: 'accessing-readonly' stamp: 'lr 2/15/2009 18:02'!
statusString
	^ self isRunning
		ifTrue: [ 'running' ]
		ifFalse: [ 'stopped' ]! !

!WAServerAdaptor methodsFor: 'starting/stopping' stamp: 'jf 10/30/2008 16:02'!
stop
	self manager stop: self! !

!WAServerAdaptor methodsFor: 'registration' stamp: 'jf 2/7/2009 20:19'!
unregister
	self manager unregister: self! !

!WAServerAdaptor methodsFor: 'registration' stamp: 'jf 2/7/2009 20:19'!
unregistered
	manager := nil! !

WAObject subclass: #WAServerManager
	instanceVariableNames: 'adaptors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Server'!

WAServerManager class
	instanceVariableNames: 'default'!

WAServerManager class
	instanceVariableNames: 'default'!

!WAServerManager class methodsFor: 'accessing' stamp: 'yann.monclair 9/5/2009 18:01'!
default
	^ default ifNil: [ default := self new ]! !

!WAServerManager class methodsFor: 'class initialization' stamp: 'jf 9/30/2009 00:19'!
initialize
	GRPlatform current
		addToStartUpList: self;
		addToShutDownList: self! !

!WAServerManager class methodsFor: 'system startup' stamp: 'yann.monclair 9/5/2009 18:03'!
shutDown
	self default adaptors do: [ :each | each shutDown ]! !

!WAServerManager class methodsFor: 'system startup' stamp: 'yann.monclair 9/5/2009 18:03'!
startUp
	self default adaptors do: [ :each | each startUp ]! !

!WAServerManager class methodsFor: 'class initialization' stamp: 'jf 9/30/2009 00:19'!
unload
	GRPlatform current
		removeFromStartUpList: self;
		removeFromShutDownList: self! !

!WAServerManager methodsFor: 'accessing' stamp: 'jf 10/29/2008 17:28'!
adaptors
	^ adaptors copy! !

!WAServerManager methodsFor: 'private' stamp: 'yann.monclair 9/5/2009 17:34'!
canStart: aServerAdaptor
	"Because we can't rely on the socket refusing to listen on a port already in use, we simply check here if we know of another adaptor using this adaptor's port"
	^ aServerAdaptor isStopped 
			and: [ self adaptors noneSatisfy: [ :adaptor | 
							( adaptor = aServerAdaptor ) not 
								and: [ adaptor port = aServerAdaptor port ] ] ]! !

!WAServerManager methodsFor: 'private' stamp: 'jf 10/30/2008 15:50'!
canStop: aServerAdaptor
	^ aServerAdaptor isStopped not! !

!WAServerManager methodsFor: 'initialization' stamp: 'jf 10/29/2008 17:28'!
initialize
	super initialize.
	adaptors := OrderedCollection new! !

!WAServerManager methodsFor: 'accessing' stamp: 'jf 10/30/2008 16:14'!
register: aServerAdaptor
	^ adaptors add: aServerAdaptor! !

!WAServerManager methodsFor: 'starting/stopping' stamp: 'jf 10/30/2008 13:51'!
restart: aServerAdaptor
	self stop: aServerAdaptor.
	self start: aServerAdaptor! !

!WAServerManager methodsFor: 'starting/stopping' stamp: 'jf 10/29/2008 17:31'!
restartAll
	adaptors do: [ :each | each restart ]! !

!WAServerManager methodsFor: 'starting/stopping' stamp: 'jf 10/31/2008 09:23'!
start: aServerAdaptor
	(self canStart: aServerAdaptor) ifTrue: [
		[ aServerAdaptor basicStart ]
			ifCurtailed: [ self stop: aServerAdaptor ] ]! !

!WAServerManager methodsFor: 'starting/stopping' stamp: 'jf 10/29/2008 17:31'!
startAll
	adaptors do: [ :each | each start ]! !

!WAServerManager methodsFor: 'starting/stopping' stamp: 'jf 10/30/2008 15:52'!
stop: aServerAdaptor
	(self canStop: aServerAdaptor) ifTrue: [ aServerAdaptor basicStop ]! !

!WAServerManager methodsFor: 'starting/stopping' stamp: 'jf 10/29/2008 17:31'!
stopAll
	adaptors do: [ :each | each stop ]! !

!WAServerManager methodsFor: 'accessing' stamp: 'jf 2/7/2009 20:20'!
unregister: aServerAdaptor
	self stop: aServerAdaptor.
	adaptors remove: aServerAdaptor.
	aServerAdaptor unregistered.
	^ aServerAdaptor! !

WAObject subclass: #WASnapshot
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Backtracking'!

!WASnapshot commentStamp: 'lr 6/2/2008 09:24' prior: 0!
I represent a memory snapshot of objects. Objects can be registered by sending the message #register:. All object snapshots are updated by sending #snapshot and restored by sending #restore. To have specific snpshot and restore actions for particular classes override #snapshotCopy and #restoreFromSnapshot: in your classes.!

!WASnapshot methodsFor: 'initialization' stamp: 'lr 1/19/2009 23:10'!
initialize
	super initialize.
	self reset! !

!WASnapshot methodsFor: 'registry' stamp: 'lr 1/19/2009 23:04'!
register: anObject
	"Register anObject for backtracking."

	anObject isNil
		ifFalse: [ objects at: anObject put: anObject snapshotCopy ]! !

!WASnapshot methodsFor: 'actions' stamp: 'lr 1/19/2009 23:10'!
reset
	"Clears the snapshot dictionary."

	objects := IdentityDictionary new! !

!WASnapshot methodsFor: 'actions' stamp: 'lr 5/31/2008 16:28'!
restore
	"Restore all the backtracked states."

	objects keysAndValuesDo: [ :key :value | key restoreFromSnapshot: value ]! !

!WASnapshot methodsFor: 'actions' stamp: 'lr 5/31/2008 16:29'!
snapshot
	"Snapshot all the states that have been registered for backtracking overriding existing snapshots."

	objects associationsDo: [ :assoc | assoc value: assoc key snapshotCopy ]! !

WAObject subclass: #WAUrl
	instanceVariableNames: 'scheme username password hostname port path slash parameters fragment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-HTTP'!

!WAUrl commentStamp: 'lr 8/11/2009 09:46' prior: 0!
I represent all portions of an URL as described by the RFC 1738. I include scheme, username, password, hostname, port, path, parameters, and fragment.

Instance Variables
	scheme:			<String> or nil
	username:		<String> or nil
	password:		<String> or nil
	hostname:		<String> or nil
	port:			<Integer> or nil
	path:			<OrderedCollection> or nil
	slash:			<Boolean>
	parameters:		<Dictionary>
	fragment:		<String> or nil!

!WAUrl class methodsFor: 'parsing' stamp: 'lr 3/26/2008 20:55'!
absolute: aString
	"Parse aString as an absolute URL."

	^ self basicNew initializeFromString: aString! !

!WAUrl class methodsFor: 'parsing' stamp: 'jf 9/22/2008 12:46'!
absolute: aString relative: aRelativeString
	"Take absolute URL aString and combine it with a relative path aRelativeString."

	^ (self absolute: aString)
		parsePath: aRelativeString;
		yourself! !

!WAUrl class methodsFor: 'decoding' stamp: 'lr 7/16/2009 08:54'!
decodePercent: aString
	"percent decodes the given String"
	| input output char |
	input := aString readStream.
	output := WriteStream on: (String new: aString size).
	[ input atEnd ] whileFalse: [
		char := input next.
		output nextPut: (char = $+
			ifTrue: [ Character space ]
			ifFalse: [
				char = $%
					ifTrue: [
						Character codePoint: input next asUppercase digitValue * 16
							+ input next asUppercase digitValue ]
					ifFalse: [ char ] ]) ].
	^ output contents! !

!WAUrl methodsFor: 'comparing' stamp: 'lr 9/8/2009 12:50'!
= aUrl
	^ self class = aUrl class and: [ self printString = aUrl printString ]! !

!WAUrl methodsFor: 'adding' stamp: 'lr 8/11/2009 09:58'!
addAllToPath: aCollectionOfStrings
	"Add a collection of strings to the path."
	
	aCollectionOfStrings do: [ :each | self addToPath: each ]! !

!WAUrl methodsFor: 'adding' stamp: 'lr 2/22/2009 11:20'!
addParameter: aValue
	"Add the parameter aValue to the receiving url."

	self addParameter: aValue value: nil! !

!WAUrl methodsFor: 'adding' stamp: 'lr 2/22/2009 11:21'!
addParameter: aKey value: aValue
	"Add the parameter aKey with aValue to the receiving url."
	
	aKey isEmpty 
		ifFalse: [ self parameters at: aKey append: aValue ]! !

!WAUrl methodsFor: 'adding' stamp: 'lr 8/11/2009 10:00'!
addToPath: aString
	"Adds the argument as a path element. If the argument contains $/ it is split into multiple elements."

	self path addAll: (aString findTokens: '/').
	self slash: (aString notEmpty and: [ aString last = $/ ])! !

!WAUrl methodsFor: 'private' stamp: 'pmm 12/27/2008 19:31'!
decode: aString
	"percent decodes the given String"
	^self class decodePercent: aString! !

!WAUrl methodsFor: 'converting' stamp: 'lr 2/7/2009 12:01'!
decodedWith: aCodec
	"answers a copy of the receiver decoded with the given codec
	http://www.ietf.org/rfc/rfc3987.txt"
	| url |
	url := self copy.
	
	"scheme, host, port cannot include escaped characters (%FF) and so should not
	be able to include characters that need decoding"
	
	"userinfo (username + password) can be percent encoded"
	self username isNil ifFalse: [
		url username: (aCodec url decode: self username) ].
	self password isNil ifFalse: [
		url password: (aCodec url decode: self password) ].
	
	self path isEmpty ifFalse: [
		url path: (self path collect: [ :each | aCodec url decode: each ]) ].
	url parameters: nil.
	self parameters keysAndValuesDo: [ :key :value |
		url
			addParameter: (aCodec url decode: key)
			value: (value isNil ifFalse: [ aCodec url decode: value ]) ].
	self fragment isNil ifFalse: [
		url fragment: (aCodec url decode: self fragment) ].
	
	^ url! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 8/20/2007 21:13'!
encodeFragmentOn: aDocument
	fragment ifNil: [ ^ self ].
	aDocument nextPut: $#.
	aDocument urlEncoder nextPutAll: fragment! !

!WAUrl methodsFor: 'encoding' stamp: 'pmm 9/20/2009 14:57'!
encodeOn: aDocument
	self encodeServerOn: aDocument.
	self encodePathOn: aDocument.
	self encodeParametersOn: aDocument.
	self encodeFragmentOn: aDocument! !

!WAUrl methodsFor: 'encoding' stamp: 'jf 9/30/2009 01:10'!
encodeParametersOn: aDocument 
	| first |
	first := true.
	parameters ifNil: [ ^ self ].
	parameters keysAndValuesDo: 
		[ :key :value | 
		aDocument htmlEncoder nextPut: (first 
				ifTrue: 
					[ first := false.
					$? ]
				ifFalse: [ $& ]).
		aDocument urlEncoder nextPutAll: key.
		value isNil ifFalse: 
			[ aDocument nextPut: $=.
			aDocument urlEncoder nextPutAll: value greaseString ] ]! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 8/11/2009 09:54'!
encodePathOn: aDocument
	path isNil ifFalse: [
		path do: [ :each |
			aDocument nextPut: $/.
			aDocument urlEncoder nextPutAll: each ] ].
	(path isNil or: [ path isEmpty or: [ slash ] ])
		ifTrue: [ aDocument nextPut: $/ ]! !

!WAUrl methodsFor: 'encoding' stamp: 'lr 7/16/2009 21:46'!
encodeServerOn: aDocument
	hostname ifNil: [ ^ self ].
	aDocument nextPutAll: self scheme; nextPutAll: '://'.
	username notNil ifTrue: [
		aDocument urlEncoder nextPutAll: username.
		password notNil ifTrue: [
			aDocument nextPut: $:.
			aDocument urlEncoder nextPutAll: password ].
		aDocument nextPut: $@ ].
	aDocument urlEncoder nextPutAll: hostname.
	port notNil ifTrue: [
		((self scheme = 'http' and: [ port = 80 ])
			or: [ self scheme = 'https' and: [ port = 443 ] ])
			ifFalse: [ aDocument nextPut: $:; print: port ] ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
fragment
	"Answer the fragment part of the URL."

	^ fragment! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:18'!
fragment: aString
	fragment := aString! !

!WAUrl methodsFor: 'comparing' stamp: 'lr 2/12/2008 11:09'!
hash
	^ self hostname hash bitXor: self path hash! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
hostname
	"Answer the host part of the URL."

	^ hostname! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 3/29/2008 10:14'!
hostname: aString
	hostname := aString isNil
		ifFalse: [ aString asLowercase ]! !

!WAUrl methodsFor: 'initialization' stamp: 'lr 8/11/2009 09:56'!
initialize
	super initialize.
	slash := false! !

!WAUrl methodsFor: 'initialization' stamp: 'pmm 11/3/2008 17:17'!
initializeFromString: aString
	| string index |
	self initialize.
	string := aString.
	index := string indexOf: $#.
	index > 0 ifTrue: [
		self parseFragment: (string copyFrom: index + 1 to: string size).
		string := string copyFrom: 1 to: index - 1 ].
	index := string indexOf: $?.
	index > 0 ifTrue: [
		self parseParameters: (string copyFrom: index + 1 to: string size).
		string := string copyFrom: 1 to: index - 1 ].
	index := string indexOfSubCollection: '://'.
	index > 0 ifTrue: [ 
		self scheme: (string copyFrom: 1 to: index - 1).
		string := string copyFrom: index + 3 to: string size.
		index := string indexOf: $/.
		string := index > 0
			ifFalse: [ 
				self parseHost: string.
				'' ]
			ifTrue: [
				self parseHost: (string copyFrom: 1 to: index - 1).
				string copyFrom: index + 1 to: string size ] ].
	self parsePath: string! !

!WAUrl methodsFor: 'private' stamp: 'lr 8/17/2007 22:49'!
isSeasideField: aString
	^ aString notEmpty
		and: [ aString first = $_
		or: [ aString allSatisfy: [ :each | each isDigit ] ] ]! !

!WAUrl methodsFor: 'accessing' stamp: 'jf 9/30/2009 00:26'!
parameters
	"Answer a dictionary with the query parameters."
	^ parameters ifNil: [ parameters := GRSmallDictionary new ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:19'!
parameters: aDictionary
	parameters := aDictionary! !

!WAUrl methodsFor: 'parsing' stamp: 'lr 3/28/2008 23:02'!
parseFragment: aString
	aString isEmpty ifTrue: [ ^ self ].
	self fragment: (self decode: aString)! !

!WAUrl methodsFor: 'parsing' stamp: 'jf 9/30/2009 01:04'!
parseHost: aString 
	| string temp index |
	aString isEmpty ifTrue: [ ^ self ].
	string := aString.
	index := string indexOf: $@.
	index > 1 ifTrue: 
		[ temp := string 
			copyFrom: 1
			to: index - 1.
		string := string 
			copyFrom: index + 1
			to: string size.
		index := temp indexOf: $:.
		index > 0 
			ifFalse: [ self username: (self decode: temp) ]
			ifTrue: 
				[ self username: (self decode: (temp 
							copyFrom: 1
							to: index - 1)).
				self password: (self decode: (temp 
							copyFrom: index + 1
							to: temp size)) ] ].
	index := string lastIndexOf: $:.
	index > 0 ifTrue: 
		[ temp := string 
			copyFrom: index + 1
			to: string size.
		string := string 
			copyFrom: 1
			to: index - 1.
		self port: ((temp allSatisfy: [ :each | each isDigit ]) ifTrue: [ temp greaseInteger ]) ].
	self hostname: (self decode: string)! !

!WAUrl methodsFor: 'parsing' stamp: 'lr 3/27/2008 08:30'!
parseParameters: aString
	| input string index |
	input := aString readStream.
	[ input atEnd ] whileFalse: [
		string := input upTo: $&.
		index := string indexOf: $=.
		index > 0
			ifFalse: [ self addParameter: (self decode: string) ]
			ifTrue: [
				self
					addParameter: (self decode: (string copyFrom: 1 to: index - 1))
					value: (self decode: (string copyFrom: index + 1 to: string size)) ] ]! !

!WAUrl methodsFor: 'parsing' stamp: 'lr 8/11/2009 09:51'!
parsePath: aString
	| input part |
	input := aString readStream.
	input peek = $/ 
		ifTrue: [ path := nil ].
	[ input atEnd ] whileFalse: [
		part := input upTo: $/.
		part isEmpty ifFalse: [
			part = '..'
				ifTrue: [ self path isEmpty ifFalse: [ self path removeLast ] ]
				ifFalse: [ part = '.' ifFalse: [ self path addLast: (self decode: part) ] ] ] ].
	slash := aString notEmpty and: [ aString last = $/ ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
password
	"Answer the password part of the URL."

	^ password! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:21'!
password: aString
	password := aString! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
path
	"Answer the path part of the URL."

	^ path ifNil: [ path := OrderedCollection new ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
path: aCollection
	"Set the path part of the URL to aCollection."

	path := aCollection! !

!WAUrl methodsFor: 'converting' stamp: 'jf 1/23/2009 23:15'!
pathString
	"Answer the path converted to a string."

	| document |
	^ String streamContents: [ :stream | 
		document := WAHtmlDocument on: stream.
		self encodePathOn: document ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:22'!
port
	"Answer the port number part of the URL."

	^ port! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:22'!
port: aNumber
	port := aNumber! !

!WAUrl methodsFor: 'copying' stamp: 'lr 3/28/2008 23:07'!
postCopy
	super postCopy.
	path := path copy.
	parameters := parameters copy! !

!WAUrl methodsFor: 'printing' stamp: 'jf 9/30/2009 00:27'!
printOn: aStream 
	| document codec |
	codec := [ self requestContext codec ] 
		on: WARequestContextNotFound
		do: [ :e | GRNullCodec new ].
	document := WAUnescapedDocument 
		on: aStream
		codec: codec.
	self encodeOn: document! !

!WAUrl methodsFor: 'converting' stamp: 'lr 9/8/2009 12:50'!
relativeTo: aUrl
	"Answer a path element collection relative from the receiver to aUrl."
	
	| currentPath argumentPath resultingPath |
	currentPath := self path copy.
	argumentPath := aUrl path copy.
	[ currentPath notEmpty and: [ argumentPath notEmpty and: [ currentPath first = argumentPath first ] ] ] whileTrue: [
		currentPath removeFirst.
		argumentPath removeFirst ].
	resultingPath := OrderedCollection new.
	currentPath size 
		timesRepeat: [ resultingPath add: '..' ].
	resultingPath addAll: argumentPath.
	^ resultingPath! !

!WAUrl methodsFor: 'private' stamp: 'lr 8/17/2007 20:54'!
removeParameters
	parameters := nil! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 7/16/2009 21:42'!
scheme
	"Answer the URL's scheme."

	^ scheme ifNil: [ 'http' ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/11/2009 09:58'!
scheme: aString
	scheme := aString asLowercase! !

!WAUrl methodsFor: 'converting' stamp: 'jf 9/22/2008 12:28'!
seasideUrl
	^ self! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/11/2009 09:58'!
slash
	"Answer if the path has a trailing slash."

	^ slash! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/11/2009 09:58'!
slash: aBoolean
	slash := aBoolean! !

!WAUrl methodsFor: 'private' stamp: 'lr 8/11/2009 09:41'!
takeServerParametersFromRequest: aRequest
	"Retrieves scheme, hostname and basepath from the request unless already set."

	scheme isNil
		ifTrue: [ self scheme: aRequest url scheme ].
	hostname isNil 
		ifTrue: [ aRequest headers at: 'host' ifPresent: [ :value | self parseHost: value ] ].
	path isNil
		ifTrue: [ aRequest headers at: 'base' ifPresent: [ :value | self parsePath: value ] ]! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:42'!
username
	"Answer the username part of the URL."

	^ username! !

!WAUrl methodsFor: 'accessing' stamp: 'lr 8/17/2007 20:38'!
username: aString
	username := aString! !

!WAUrl methodsFor: 'copying' stamp: 'avi 3/22/2004 00:52'!
with: pathString
	^ self copy
		addToPath: pathString;
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'pmm 6/21/2007 20:45'!
withParameter: aString
	^ self copy
		addParameter: aString;
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'avi 3/22/2004 00:51'!
withParameter: aString value: valueString
	^ self copy
		addParameter: aString value: valueString;
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'pmm 6/21/2007 20:57'!
withoutParameters
	^self copy
		removeParameters;
		yourself! !

WAObject subclass: #WAValueHolder
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

!WAValueHolder commentStamp: 'pmm 9/5/2007 19:01' prior: 0!
I wrap a single object. I am like value holder except that I am portable and don't include the Model cruft in Squeak.!

!WAValueHolder class methodsFor: 'instance creation' stamp: 'lr 9/5/2007 11:40'!
with: anObject
	^ self new contents: anObject! !

!WAValueHolder methodsFor: 'accessing' stamp: 'lr 4/16/2007 00:11'!
contents
	^ contents! !

!WAValueHolder methodsFor: 'accessing' stamp: 'lr 4/16/2007 00:11'!
contents: anObject
	contents := anObject! !

!WAValueHolder methodsFor: 'printing' stamp: 'lr 4/20/2007 20:46'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' contents: '; print: self contents! !

WAObject subclass: #WAVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Utilities'!

WAVisitor subclass: #WAAttributeVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Configuration'!

!WAAttributeVisitor methodsFor: 'visiting' stamp: 'jf 1/11/2009 19:37'!
visitAttribute: anAttribute! !

!WAAttributeVisitor methodsFor: 'visiting' stamp: 'jf 1/11/2009 19:40'!
visitBooleanAttribute: anAttribute
	self visitAttribute: anAttribute! !

!WAAttributeVisitor methodsFor: 'visiting' stamp: 'jf 1/11/2009 19:40'!
visitCollectionAttribute: anAttribute
	self visitListAttribute: anAttribute! !

!WAAttributeVisitor methodsFor: 'visiting' stamp: 'jf 1/11/2009 19:40'!
visitIntegerAttribute: anAttribute
	self visitNumberAttribute: anAttribute! !

!WAAttributeVisitor methodsFor: 'visiting' stamp: 'jf 1/11/2009 19:40'!
visitListAttribute: anAttribute
	self visitAttribute: anAttribute! !

!WAAttributeVisitor methodsFor: 'visiting' stamp: 'jf 1/11/2009 19:40'!
visitNumberAttribute: anAttribute
	self visitAttribute: anAttribute! !

!WAAttributeVisitor methodsFor: 'visiting' stamp: 'jf 1/11/2009 19:40'!
visitPasswordAttribute: anAttribute
	self visitAttribute: anAttribute! !

!WAAttributeVisitor methodsFor: 'visiting' stamp: 'jf 1/11/2009 19:40'!
visitStringAttribute: anAttribute
	self visitAttribute: anAttribute! !

WAVisitor subclass: #WAPainterVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Rendering'!

!WAPainterVisitor commentStamp: 'jf 2/13/2009 19:50' prior: 0!
An implementation of the Visitor pattern for Painter subclasses.!

!WAPainterVisitor methodsFor: 'copying' stamp: 'jf 2/13/2009 19:33'!
copyForRenderContext: aRenderContext 
	"Return a copy, making sure that references to a RenderContext are replaced
	with aRenderContext."
	
	^ self copy
		postCopyForRenderContext: aRenderContext;
		yourself! !

!WAPainterVisitor methodsFor: 'copying' stamp: 'jf 2/13/2009 19:33'!
postCopyForRenderContext: aRenderContext
	"self is a shallow copy. Subclasses should copy fields as necessary to complete
	the full copy and ensure that all references to the old RenderContext are replaced
	with aRenderContext. Note that #postCopy is also called prior to this method being called."! !

!WAPainterVisitor methodsFor: 'visiting' stamp: 'jf 10/22/2008 11:00'!
visitPainter: aPainter! !

WAPainterVisitor subclass: #WARenderVisitor
	instanceVariableNames: 'renderContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Rendering'!

!WARenderVisitor commentStamp: 'jf 2/13/2009 19:52' prior: 0!
A visitor that renders Painters. It creates an instance of the #rendererClass specified by each Painter it visits and passes it to the Painter with #renderContentOn:.!

!WARenderVisitor class methodsFor: 'instance creation' stamp: 'jf 1/23/2009 12:00'!
context: aRenderContext
	^ self basicNew
		initializeWithContext: aRenderContext;
		yourself! !

!WARenderVisitor methodsFor: 'initialization' stamp: 'jf 1/23/2009 12:01'!
initializeWithContext: aRenderContext
	self initialize.
	renderContext := aRenderContext! !

!WARenderVisitor methodsFor: 'copying' stamp: 'jf 2/12/2009 21:25'!
postCopyForRenderContext: aRenderContext
	super postCopyForRenderContext: aRenderContext.
	renderContext := aRenderContext! !

!WARenderVisitor methodsFor: 'accessing' stamp: 'jf 1/23/2009 12:02'!
renderContext
	^ renderContext! !

!WARenderVisitor methodsFor: 'visiting' stamp: 'jf 2/12/2009 19:48'!
visitPainter: aPainter 
	| renderer |
	renderer := aPainter rendererClass context: self renderContext.
	aPainter renderContentOn: renderer.
	renderer flush! !

WAPainterVisitor subclass: #WAUpdateRootVisitor
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Rendering'!

!WAUpdateRootVisitor commentStamp: 'jf 2/13/2009 19:54' prior: 0!
A visitor which asks Painters to update a WARoot subclass using #updateRoot:.

This is used to update the root of the Document stored on a RenderContext.!

!WAUpdateRootVisitor class methodsFor: 'instance creation' stamp: 'jf 2/9/2009 16:20'!
new
	^ self root: WARoot new! !

!WAUpdateRootVisitor class methodsFor: 'instance creation' stamp: 'jf 2/9/2009 16:18'!
root: aRoot
	^ self basicNew initializeWithRoot: aRoot; yourself! !

!WAUpdateRootVisitor methodsFor: 'initialization' stamp: 'jf 2/9/2009 16:17'!
initializeWithRoot: aRoot
	self initialize.
	root := aRoot! !

!WAUpdateRootVisitor methodsFor: 'accessing' stamp: 'jf 10/22/2008 12:04'!
root
	^ root! !

!WAUpdateRootVisitor methodsFor: 'visiting' stamp: 'jf 10/22/2008 15:51'!
visitPainter: aPainter
	aPainter updateRoot: self root! !

WAPainterVisitor subclass: #WAUpdateUrlVisitor
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Core-Rendering'!

!WAUpdateUrlVisitor commentStamp: 'jf 2/13/2009 19:54' prior: 0!
A visitor which asks Painters to update a WAUrl subclass using #updateRoot:.

This is used to update the base URL stored on a RenderContext.!

!WAUpdateUrlVisitor class methodsFor: 'instance creation' stamp: 'jf 2/9/2009 16:08'!
new
	^ self url: WAUrl new! !

!WAUpdateUrlVisitor class methodsFor: 'instance creation' stamp: 'jf 2/9/2009 16:08'!
url: aUrl
	^ self basicNew initializeWithUrl: aUrl; yourself! !

!WAUpdateUrlVisitor methodsFor: 'initialization' stamp: 'jf 2/9/2009 16:08'!
initializeWithUrl: aUrl
	self initialize.
	url := aUrl! !

!WAUpdateUrlVisitor methodsFor: 'accessing' stamp: 'jf 10/22/2008 12:18'!
url
	^ url! !

!WAUpdateUrlVisitor methodsFor: 'visiting' stamp: 'jf 10/22/2008 15:51'!
visitPainter: aPainter
	aPainter updateUrl: self url! !

!WAVisitor methodsFor: 'visiting' stamp: 'jf 2/9/2009 16:27'!
start: anObject
	self visit: anObject! !

!WAVisitor methodsFor: 'visiting' stamp: 'jf 2/9/2009 16:27'!
visit: anObject
	anObject accept: self! !

!WAVisitor methodsFor: 'visiting' stamp: 'jf 2/9/2009 16:27'!
visitAll: aCollection
	aCollection do: [ :each | self visit: each ]! !

!ByteArray methodsFor: '*seaside-core' stamp: 'mb 9/22/2006 12:17'!
renderOn: aRenderer
	aRenderer text: self! !

!ByteArray methodsFor: '*seaside-core' stamp: 'lr 10/18/2008 15:53'!
seasideMimeDocument
	^ WAMimeDocument on: self mimeType: WAMimeType applicationOctetStream! !

!Exception methodsFor: '*seaside-core' stamp: 'jf 2/20/2009 18:09'!
seasidePossibleCauses
	"Used by WAWalkback to render a list of what might have caused the receiver to be signaled.
	answers a collection of strings"
	^ #()! !

!GRUnsupportedEncodingError methodsFor: '*seaside-core' stamp: 'jf 2/20/2009 18:09'!
seasidePossibleCauses
	^#(
		'The given encoding name is not supported on this Smalltalk dialect.'
		'The given encoding name is misspelled.'
	)! !
WASharedConfiguration initialize!
WAHtmlEncoder initialize!
WAUrlEncoder initialize!
WAFileLibrary initialize!
WAKeyGenerator initialize!
WALocale initialize!
WAResponse initialize!
WAServerManager initialize!
